#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTObject.h"
#include "HROOTTQObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TAPPLICATION_DECLARATIONVIRT
#define ROOT_TAPPLICATION_DECLARATIONVIRT(Type) \
void Type ## _Run ( Type ## _p p, int retrn )

#undef ROOT_TAPPLICATION_DECLARATIONNONVIRT
#define ROOT_TAPPLICATION_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTApplication ( const char * appClassName, int * argc, char ** argv )

#undef ROOT_TAPPLICATION_DEFINITIONVIRT
#define ROOT_TAPPLICATION_DEFINITIONVIRT(Type)\
void Type ## _Run ( Type ## _p p, int retrn )\
{\
to_nonconst<Type,Type ## _t>(p)->Run(retrn);\
}

#undef ROOT_TAPPLICATION_DEFINITIONNONVIRT
#define ROOT_TAPPLICATION_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTApplication ( const char * appClassName, int * argc, char ** argv )\
{\
Type * newp = new Type (appClassName, argc, argv); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TOBJECT_DECLARATIONVIRT(TApplication);
ROOT_TQOBJECT_DECLARATIONVIRT(TApplication);
ROOT_DELETABLE_DECLARATIONVIRT(TApplication);


ROOT_TAPPLICATION_DECLARATIONVIRT(TApplication);


ROOT_TAPPLICATION_DECLARATIONNONVIRT(TApplication);


#ifdef __cplusplus
}
#endif
