#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTEllipse.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TARC_DECLARATIONVIRT
#define ROOT_TARC_DECLARATIONVIRT(Type) \


#undef ROOT_TARC_DECLARATIONNONVIRT
#define ROOT_TARC_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTArc ( double x1, double y1, double radius, double phimin, double phimax )

#undef ROOT_TARC_DEFINITIONVIRT
#define ROOT_TARC_DEFINITIONVIRT(Type)\


#undef ROOT_TARC_DEFINITIONNONVIRT
#define ROOT_TARC_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTArc ( double x1, double y1, double radius, double phimin, double phimax )\
{\
Type * newp = new Type (x1, y1, radius, phimin, phimax); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TELLIPSE_DECLARATIONVIRT(TArc);
ROOT_TOBJECT_DECLARATIONVIRT(TArc);
ROOT_TATTLINE_DECLARATIONVIRT(TArc);
ROOT_TATTFILL_DECLARATIONVIRT(TArc);
ROOT_DELETABLE_DECLARATIONVIRT(TArc);


ROOT_TARC_DECLARATIONVIRT(TArc);


ROOT_TARC_DECLARATIONNONVIRT(TArc);


#ifdef __cplusplus
}
#endif
