#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTDeletable.h"

#undef ROOT_TATTAXIS_DECLARATIONVIRT
#define ROOT_TATTAXIS_DECLARATIONVIRT(Type) \
int  Type ## _GetNdivisions ( Type ## _p p ); \
int  Type ## _GetAxisColor ( Type ## _p p ); \
int  Type ## _GetLabelColor ( Type ## _p p ); \
int  Type ## _GetLabelFont ( Type ## _p p ); \
double Type ## _GetLabelOffset ( Type ## _p p ); \
double Type ## _GetLabelSize ( Type ## _p p ); \
double Type ## _GetTitleOffset ( Type ## _p p ); \
double Type ## _GetTitleSize ( Type ## _p p ); \
double Type ## _GetTickLength ( Type ## _p p ); \
int  Type ## _GetTitleFont ( Type ## _p p ); \
void Type ## _SetNdivisions ( Type ## _p p, int  n, int optim ); \
void Type ## _SetAxisColor ( Type ## _p p, int  color ); \
void Type ## _SetLabelColor ( Type ## _p p, int  color ); \
void Type ## _SetLabelFont ( Type ## _p p, int  font ); \
void Type ## _SetLabelOffset ( Type ## _p p, double offset ); \
void Type ## _SetLabelSize ( Type ## _p p, double size ); \
void Type ## _SetTickLength ( Type ## _p p, double length ); \
void Type ## _SetTitleOffset ( Type ## _p p, double offset ); \
void Type ## _SetTitleSize ( Type ## _p p, double size ); \
void Type ## _SetTitleColor ( Type ## _p p, int  color ); \
void Type ## _SetTitleFont ( Type ## _p p, int  font )

#undef ROOT_TATTAXIS_DECLARATIONNONVIRT
#define ROOT_TATTAXIS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTAttAxis (  )

#undef ROOT_TATTAXIS_DEFINITIONVIRT
#define ROOT_TATTAXIS_DEFINITIONVIRT(Type)\
int  Type ## _GetNdivisions ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetNdivisions();\
}\
int  Type ## _GetAxisColor ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetAxisColor();\
}\
int  Type ## _GetLabelColor ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLabelColor();\
}\
int  Type ## _GetLabelFont ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLabelFont();\
}\
double Type ## _GetLabelOffset ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLabelOffset();\
}\
double Type ## _GetLabelSize ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLabelSize();\
}\
double Type ## _GetTitleOffset ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTitleOffset();\
}\
double Type ## _GetTitleSize ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTitleSize();\
}\
double Type ## _GetTickLength ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTickLength();\
}\
int  Type ## _GetTitleFont ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTitleFont();\
}\
void Type ## _SetNdivisions ( Type ## _p p, int  n, int optim )\
{\
to_nonconst<Type,Type ## _t>(p)->SetNdivisions(n, optim);\
}\
void Type ## _SetAxisColor ( Type ## _p p, int  color )\
{\
to_nonconst<Type,Type ## _t>(p)->SetAxisColor(color);\
}\
void Type ## _SetLabelColor ( Type ## _p p, int  color )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLabelColor(color);\
}\
void Type ## _SetLabelFont ( Type ## _p p, int  font )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLabelFont(font);\
}\
void Type ## _SetLabelOffset ( Type ## _p p, double offset )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLabelOffset(offset);\
}\
void Type ## _SetLabelSize ( Type ## _p p, double size )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLabelSize(size);\
}\
void Type ## _SetTickLength ( Type ## _p p, double length )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTickLength(length);\
}\
void Type ## _SetTitleOffset ( Type ## _p p, double offset )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTitleOffset(offset);\
}\
void Type ## _SetTitleSize ( Type ## _p p, double size )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTitleSize(size);\
}\
void Type ## _SetTitleColor ( Type ## _p p, int  color )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTitleColor(color);\
}\
void Type ## _SetTitleFont ( Type ## _p p, int  font )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTitleFont(font);\
}

#undef ROOT_TATTAXIS_DEFINITIONNONVIRT
#define ROOT_TATTAXIS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTAttAxis (  )\
{\
Type * newp = new Type (); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_DELETABLE_DECLARATIONVIRT(TAttAxis);


ROOT_TATTAXIS_DECLARATIONVIRT(TAttAxis);


ROOT_TATTAXIS_DECLARATIONNONVIRT(TAttAxis);


#ifdef __cplusplus
}
#endif
