#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTDeletable.h"

#undef ROOT_TATTFILL_DECLARATIONVIRT
#define ROOT_TATTFILL_DECLARATIONVIRT(Type) \
void Type ## _SetFillColor ( Type ## _p p, int  color ); \
void Type ## _SetFillStyle ( Type ## _p p, int  style )

#undef ROOT_TATTFILL_DECLARATIONNONVIRT
#define ROOT_TATTFILL_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTAttFill ( int  fcolor, int  fstyle )

#undef ROOT_TATTFILL_DEFINITIONVIRT
#define ROOT_TATTFILL_DEFINITIONVIRT(Type)\
void Type ## _SetFillColor ( Type ## _p p, int  color )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFillColor(color);\
}\
void Type ## _SetFillStyle ( Type ## _p p, int  style )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFillStyle(style);\
}

#undef ROOT_TATTFILL_DEFINITIONNONVIRT
#define ROOT_TATTFILL_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTAttFill ( int  fcolor, int  fstyle )\
{\
Type * newp = new Type (fcolor, fstyle); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_DELETABLE_DECLARATIONVIRT(TAttFill);


ROOT_TATTFILL_DECLARATIONVIRT(TAttFill);


ROOT_TATTFILL_DECLARATIONNONVIRT(TAttFill);


#ifdef __cplusplus
}
#endif
