#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTDeletable.h"

#undef ROOT_TATTTEXT_DECLARATIONVIRT
#define ROOT_TATTTEXT_DECLARATIONVIRT(Type) \
int  Type ## _GetTextAlign ( Type ## _p p ); \
double Type ## _GetTextAngle ( Type ## _p p ); \
int  Type ## _GetTextColor ( Type ## _p p ); \
int  Type ## _GetTextFont ( Type ## _p p ); \
double Type ## _GetTextSize ( Type ## _p p ); \
void Type ## _ResetAttText ( Type ## _p p, const char * toption ); \
void Type ## _SetTextAttributes ( Type ## _p p ); \
void Type ## _SetTextAlign ( Type ## _p p, int  align ); \
void Type ## _SetTextAngle ( Type ## _p p, double tangle ); \
void Type ## _SetTextColor ( Type ## _p p, int  tcolor ); \
void Type ## _SetTextFont ( Type ## _p p, int  tfont ); \
void Type ## _SetTextSize ( Type ## _p p, double tsize ); \
void Type ## _SetTextSizePixels ( Type ## _p p, int  npixels )

#undef ROOT_TATTTEXT_DECLARATIONNONVIRT
#define ROOT_TATTTEXT_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTAttText ( int  align, double angle, int  color, int  font, double tsize )

#undef ROOT_TATTTEXT_DEFINITIONVIRT
#define ROOT_TATTTEXT_DEFINITIONVIRT(Type)\
int  Type ## _GetTextAlign ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTextAlign();\
}\
double Type ## _GetTextAngle ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTextAngle();\
}\
int  Type ## _GetTextColor ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTextColor();\
}\
int  Type ## _GetTextFont ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTextFont();\
}\
double Type ## _GetTextSize ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTextSize();\
}\
void Type ## _ResetAttText ( Type ## _p p, const char * toption )\
{\
to_nonconst<Type,Type ## _t>(p)->ResetAttText(toption);\
}\
void Type ## _SetTextAttributes ( Type ## _p p )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTextAttributes();\
}\
void Type ## _SetTextAlign ( Type ## _p p, int  align )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTextAlign(align);\
}\
void Type ## _SetTextAngle ( Type ## _p p, double tangle )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTextAngle(tangle);\
}\
void Type ## _SetTextColor ( Type ## _p p, int  tcolor )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTextColor(tcolor);\
}\
void Type ## _SetTextFont ( Type ## _p p, int  tfont )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTextFont(tfont);\
}\
void Type ## _SetTextSize ( Type ## _p p, double tsize )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTextSize(tsize);\
}\
void Type ## _SetTextSizePixels ( Type ## _p p, int  npixels )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTextSizePixels(npixels);\
}

#undef ROOT_TATTTEXT_DEFINITIONNONVIRT
#define ROOT_TATTTEXT_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTAttText ( int  align, double angle, int  color, int  font, double tsize )\
{\
Type * newp = new Type (align, angle, color, font, tsize); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_DELETABLE_DECLARATIONVIRT(TAttText);


ROOT_TATTTEXT_DECLARATIONVIRT(TAttText);


ROOT_TATTTEXT_DECLARATIONNONVIRT(TAttText);


#ifdef __cplusplus
}
#endif
