#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTShape.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TBRIK_DECLARATIONVIRT
#define ROOT_TBRIK_DECLARATIONVIRT(Type) \


#undef ROOT_TBRIK_DECLARATIONNONVIRT
#define ROOT_TBRIK_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTBRIK ( const char * name, const char * title, const char * material, double dx, double dy, double dz )

#undef ROOT_TBRIK_DEFINITIONVIRT
#define ROOT_TBRIK_DEFINITIONVIRT(Type)\


#undef ROOT_TBRIK_DEFINITIONNONVIRT
#define ROOT_TBRIK_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTBRIK ( const char * name, const char * title, const char * material, double dx, double dy, double dz )\
{\
Type * newp = new Type (name, title, material, dx, dy, dz); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TSHAPE_DECLARATIONVIRT(TBRIK);
ROOT_TNAMED_DECLARATIONVIRT(TBRIK);
ROOT_TATTLINE_DECLARATIONVIRT(TBRIK);
ROOT_TATTFILL_DECLARATIONVIRT(TBRIK);
ROOT_TATT3D_DECLARATIONVIRT(TBRIK);
ROOT_TOBJECT_DECLARATIONVIRT(TBRIK);
ROOT_DELETABLE_DECLARATIONVIRT(TBRIK);


ROOT_TBRIK_DECLARATIONVIRT(TBRIK);


ROOT_TBRIK_DECLARATIONNONVIRT(TBRIK);


#ifdef __cplusplus
}
#endif
