#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPad.h"
#include "HROOTTVirtualPad.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttPad.h"
#include "HROOTTQObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TCANVAS_DECLARATIONVIRT
#define ROOT_TCANVAS_DECLARATIONVIRT(Type) \


#undef ROOT_TCANVAS_DECLARATIONNONVIRT
#define ROOT_TCANVAS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTCanvas ( const char * name, const char * title, int  ww, int  wh )

#undef ROOT_TCANVAS_DEFINITIONVIRT
#define ROOT_TCANVAS_DEFINITIONVIRT(Type)\


#undef ROOT_TCANVAS_DEFINITIONNONVIRT
#define ROOT_TCANVAS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTCanvas ( const char * name, const char * title, int  ww, int  wh )\
{\
Type * newp = new Type (name, title, ww, wh); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPAD_DECLARATIONVIRT(TCanvas);
ROOT_TVIRTUALPAD_DECLARATIONVIRT(TCanvas);
ROOT_TOBJECT_DECLARATIONVIRT(TCanvas);
ROOT_TATTLINE_DECLARATIONVIRT(TCanvas);
ROOT_TATTFILL_DECLARATIONVIRT(TCanvas);
ROOT_TATTPAD_DECLARATIONVIRT(TCanvas);
ROOT_TQOBJECT_DECLARATIONVIRT(TCanvas);
ROOT_DELETABLE_DECLARATIONVIRT(TCanvas);


ROOT_TCANVAS_DECLARATIONVIRT(TCanvas);


ROOT_TCANVAS_DECLARATIONNONVIRT(TCanvas);


#ifdef __cplusplus
}
#endif
