#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTTree.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TCHAIN_DECLARATIONVIRT
#define ROOT_TCHAIN_DECLARATIONVIRT(Type) \


#undef ROOT_TCHAIN_DECLARATIONNONVIRT
#define ROOT_TCHAIN_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTChain ( const char * name, const char * title )

#undef ROOT_TCHAIN_DEFINITIONVIRT
#define ROOT_TCHAIN_DEFINITIONVIRT(Type)\


#undef ROOT_TCHAIN_DEFINITIONNONVIRT
#define ROOT_TCHAIN_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTChain ( const char * name, const char * title )\
{\
Type * newp = new Type (name, title); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TTREE_DECLARATIONVIRT(TChain);
ROOT_TNAMED_DECLARATIONVIRT(TChain);
ROOT_TATTLINE_DECLARATIONVIRT(TChain);
ROOT_TATTFILL_DECLARATIONVIRT(TChain);
ROOT_TATTMARKER_DECLARATIONVIRT(TChain);
ROOT_TOBJECT_DECLARATIONVIRT(TChain);
ROOT_DELETABLE_DECLARATIONVIRT(TChain);


ROOT_TCHAIN_DECLARATIONVIRT(TChain);


ROOT_TCHAIN_DECLARATIONNONVIRT(TChain);


#ifdef __cplusplus
}
#endif
