#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTEllipse.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TCROWN_DECLARATIONVIRT
#define ROOT_TCROWN_DECLARATIONVIRT(Type) \


#undef ROOT_TCROWN_DECLARATIONNONVIRT
#define ROOT_TCROWN_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTCrown ( double x1, double y1, double radin, double radout, double phimin, double phimax )

#undef ROOT_TCROWN_DEFINITIONVIRT
#define ROOT_TCROWN_DEFINITIONVIRT(Type)\


#undef ROOT_TCROWN_DEFINITIONNONVIRT
#define ROOT_TCROWN_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTCrown ( double x1, double y1, double radin, double radout, double phimin, double phimax )\
{\
Type * newp = new Type (x1, y1, radin, radout, phimin, phimax); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TELLIPSE_DECLARATIONVIRT(TCrown);
ROOT_TOBJECT_DECLARATIONVIRT(TCrown);
ROOT_TATTLINE_DECLARATIONVIRT(TCrown);
ROOT_TATTFILL_DECLARATIONVIRT(TCrown);
ROOT_DELETABLE_DECLARATIONVIRT(TCrown);


ROOT_TCROWN_DECLARATIONVIRT(TCrown);


ROOT_TCROWN_DECLARATIONNONVIRT(TCrown);


#ifdef __cplusplus
}
#endif
