#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPolyLine.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TCURLYLINE_DECLARATIONVIRT
#define ROOT_TCURLYLINE_DECLARATIONVIRT(Type) \


#undef ROOT_TCURLYLINE_DECLARATIONNONVIRT
#define ROOT_TCURLYLINE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTCurlyLine ( double x1, double y1, double x2, double y2, double wl, double amp )

#undef ROOT_TCURLYLINE_DEFINITIONVIRT
#define ROOT_TCURLYLINE_DEFINITIONVIRT(Type)\


#undef ROOT_TCURLYLINE_DEFINITIONNONVIRT
#define ROOT_TCURLYLINE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTCurlyLine ( double x1, double y1, double x2, double y2, double wl, double amp )\
{\
Type * newp = new Type (x1, y1, x2, y2, wl, amp); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPOLYLINE_DECLARATIONVIRT(TCurlyLine);
ROOT_TOBJECT_DECLARATIONVIRT(TCurlyLine);
ROOT_TATTLINE_DECLARATIONVIRT(TCurlyLine);
ROOT_TATTFILL_DECLARATIONVIRT(TCurlyLine);
ROOT_DELETABLE_DECLARATIONVIRT(TCurlyLine);


ROOT_TCURLYLINE_DECLARATIONVIRT(TCurlyLine);


ROOT_TCURLYLINE_DECLARATIONNONVIRT(TCurlyLine);


#ifdef __cplusplus
}
#endif
