#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TCutG.h"
#include "HROOTTCutG.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TGRAPH_DEFINITIONVIRT(TCutG)
ROOT_TNAMED_DEFINITIONVIRT(TCutG)
ROOT_TATTLINE_DEFINITIONVIRT(TCutG)
ROOT_TATTFILL_DEFINITIONVIRT(TCutG)
ROOT_TATTMARKER_DEFINITIONVIRT(TCutG)
ROOT_TOBJECT_DEFINITIONVIRT(TCutG)
ROOT_DELETABLE_DEFINITIONVIRT(TCutG)

ROOT_TCUTG_DEFINITIONVIRT(TCutG)

ROOT_TCUTG_DEFINITIONNONVIRT(TCutG)

void dummyTCutG ( void ) 
{
  
}

