#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTDeletable.h"

#undef ROOT_TDATIME_DECLARATIONVIRT
#define ROOT_TDATIME_DECLARATIONVIRT(Type) \
unsigned int  Type ## _Convert ( Type ## _p p, int toGMT ); \
void Type ## _setTDatime ( Type ## _p p, unsigned int  tloc )

#undef ROOT_TDATIME_DECLARATIONNONVIRT
#define ROOT_TDATIME_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTDatime ( int  year, int  month, int  day, int  hour, int  min, int  sec ); \
int  Type ## _tDatimeGetDay ( Type ## _p p ); \
int  Type ## _tDatimeGetHour ( Type ## _p p ); \
int  Type ## _tDatimeGetMinute ( Type ## _p p ); \
int  Type ## _tDatimeGetSecond ( Type ## _p p ); \
int  Type ## _tDatimeGetYear ( Type ## _p p ); \
int  Type ## _tDatimeGetMonth ( Type ## _p p )

#undef ROOT_TDATIME_DEFINITIONVIRT
#define ROOT_TDATIME_DEFINITIONVIRT(Type)\
unsigned int  Type ## _Convert ( Type ## _p p, int toGMT )\
{\
return to_nonconst<Type,Type ## _t>(p)->Convert(toGMT);\
}\
void Type ## _setTDatime ( Type ## _p p, unsigned int  tloc )\
{\
to_nonconst<Type,Type ## _t>(p)->Set(tloc);\
}

#undef ROOT_TDATIME_DEFINITIONNONVIRT
#define ROOT_TDATIME_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTDatime ( int  year, int  month, int  day, int  hour, int  min, int  sec )\
{\
Type * newp = new Type (year, month, day, hour, min, sec); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
int  Type ## _tDatimeGetDay ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetDay();\
}\
int  Type ## _tDatimeGetHour ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetHour();\
}\
int  Type ## _tDatimeGetMinute ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMinute();\
}\
int  Type ## _tDatimeGetSecond ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetSecond();\
}\
int  Type ## _tDatimeGetYear ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetYear();\
}\
int  Type ## _tDatimeGetMonth ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMonth();\
}

ROOT_DELETABLE_DECLARATIONVIRT(TDatime);


ROOT_TDATIME_DECLARATIONVIRT(TDatime);


ROOT_TDATIME_DECLARATIONNONVIRT(TDatime);


#ifdef __cplusplus
}
#endif
