#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTDirectory.h"
#include "HROOTTNamed.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TDIRECTORYFILE_DECLARATIONVIRT
#define ROOT_TDIRECTORYFILE_DECLARATIONVIRT(Type) \
TList_p Type ## _GetListOfKeys ( Type ## _p p )

#undef ROOT_TDIRECTORYFILE_DECLARATIONNONVIRT
#define ROOT_TDIRECTORYFILE_DECLARATIONNONVIRT(Type) \


#undef ROOT_TDIRECTORYFILE_DEFINITIONVIRT
#define ROOT_TDIRECTORYFILE_DEFINITIONVIRT(Type)\
TList_p Type ## _GetListOfKeys ( Type ## _p p )\
{\
return to_nonconst<TList_t,TList>((TList*)to_nonconst<Type,Type ## _t>(p)->GetListOfKeys());\
}

#undef ROOT_TDIRECTORYFILE_DEFINITIONNONVIRT
#define ROOT_TDIRECTORYFILE_DEFINITIONNONVIRT(Type)\


ROOT_TDIRECTORY_DECLARATIONVIRT(TDirectoryFile);
ROOT_TNAMED_DECLARATIONVIRT(TDirectoryFile);
ROOT_TOBJECT_DECLARATIONVIRT(TDirectoryFile);
ROOT_DELETABLE_DECLARATIONVIRT(TDirectoryFile);


ROOT_TDIRECTORYFILE_DECLARATIONVIRT(TDirectoryFile);


ROOT_TDIRECTORYFILE_DECLARATIONNONVIRT(TDirectoryFile);


#ifdef __cplusplus
}
#endif
