#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTDirectoryFile.h"
#include "HROOTTDirectory.h"
#include "HROOTTNamed.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TFILE_DECLARATIONVIRT
#define ROOT_TFILE_DECLARATIONVIRT(Type) \


#undef ROOT_TFILE_DECLARATIONNONVIRT
#define ROOT_TFILE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTFile ( const char * fname, const char * option, const char * ftitle, int  compress )

#undef ROOT_TFILE_DEFINITIONVIRT
#define ROOT_TFILE_DEFINITIONVIRT(Type)\


#undef ROOT_TFILE_DEFINITIONNONVIRT
#define ROOT_TFILE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTFile ( const char * fname, const char * option, const char * ftitle, int  compress )\
{\
Type * newp = new Type (fname, option, ftitle, compress); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TDIRECTORYFILE_DECLARATIONVIRT(TFile);
ROOT_TDIRECTORY_DECLARATIONVIRT(TFile);
ROOT_TNAMED_DECLARATIONVIRT(TFile);
ROOT_TOBJECT_DECLARATIONVIRT(TFile);
ROOT_DELETABLE_DECLARATIONVIRT(TFile);


ROOT_TFILE_DECLARATIONVIRT(TFile);


ROOT_TFILE_DECLARATIONNONVIRT(TFile);


#ifdef __cplusplus
}
#endif
