#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTLine.h"
#include "HROOTTAttText.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTDeletable.h"

#undef ROOT_TGAXIS_DECLARATIONVIRT
#define ROOT_TGAXIS_DECLARATIONVIRT(Type) \


#undef ROOT_TGAXIS_DECLARATIONNONVIRT
#define ROOT_TGAXIS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTGaxis ( double xmin, double ymin, double xmax, double ymax, double wmin, double wmax, int  ndiv, const char * chopt, double gridlength )

#undef ROOT_TGAXIS_DEFINITIONVIRT
#define ROOT_TGAXIS_DEFINITIONVIRT(Type)\


#undef ROOT_TGAXIS_DEFINITIONNONVIRT
#define ROOT_TGAXIS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTGaxis ( double xmin, double ymin, double xmax, double ymax, double wmin, double wmax, int  ndiv, const char * chopt, double gridlength )\
{\
Type * newp = new Type (xmin, ymin, xmax, ymax, wmin, wmax, ndiv, chopt, gridlength); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TLINE_DECLARATIONVIRT(TGaxis);
ROOT_TATTTEXT_DECLARATIONVIRT(TGaxis);
ROOT_TOBJECT_DECLARATIONVIRT(TGaxis);
ROOT_TATTLINE_DECLARATIONVIRT(TGaxis);
ROOT_DELETABLE_DECLARATIONVIRT(TGaxis);


ROOT_TGAXIS_DECLARATIONVIRT(TGaxis);


ROOT_TGAXIS_DECLARATIONNONVIRT(TGaxis);


#ifdef __cplusplus
}
#endif
