#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TGraphAsymmErrors.h"
#include "HROOTTGraphAsymmErrors.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TGRAPH_DEFINITIONVIRT(TGraphAsymmErrors)
ROOT_TNAMED_DEFINITIONVIRT(TGraphAsymmErrors)
ROOT_TATTLINE_DEFINITIONVIRT(TGraphAsymmErrors)
ROOT_TATTFILL_DEFINITIONVIRT(TGraphAsymmErrors)
ROOT_TATTMARKER_DEFINITIONVIRT(TGraphAsymmErrors)
ROOT_TOBJECT_DEFINITIONVIRT(TGraphAsymmErrors)
ROOT_DELETABLE_DEFINITIONVIRT(TGraphAsymmErrors)

ROOT_TGRAPHASYMMERRORS_DEFINITIONVIRT(TGraphAsymmErrors)

ROOT_TGRAPHASYMMERRORS_DEFINITIONNONVIRT(TGraphAsymmErrors)

void dummyTGraphAsymmErrors ( void ) 
{
  
}

