#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TGraphBentErrors.h"
#include "HROOTTGraphBentErrors.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TGRAPH_DEFINITIONVIRT(TGraphBentErrors)
ROOT_TNAMED_DEFINITIONVIRT(TGraphBentErrors)
ROOT_TATTLINE_DEFINITIONVIRT(TGraphBentErrors)
ROOT_TATTFILL_DEFINITIONVIRT(TGraphBentErrors)
ROOT_TATTMARKER_DEFINITIONVIRT(TGraphBentErrors)
ROOT_TOBJECT_DEFINITIONVIRT(TGraphBentErrors)
ROOT_DELETABLE_DEFINITIONVIRT(TGraphBentErrors)

ROOT_TGRAPHBENTERRORS_DEFINITIONVIRT(TGraphBentErrors)

ROOT_TGRAPHBENTERRORS_DEFINITIONNONVIRT(TGraphBentErrors)

void dummyTGraphBentErrors ( void ) 
{
  
}

