#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TGRAPHQQ_DECLARATIONVIRT
#define ROOT_TGRAPHQQ_DECLARATIONVIRT(Type) \


#undef ROOT_TGRAPHQQ_DECLARATIONNONVIRT
#define ROOT_TGRAPHQQ_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTGraphQQ ( int  nx, double * x, int  ny, double * y )

#undef ROOT_TGRAPHQQ_DEFINITIONVIRT
#define ROOT_TGRAPHQQ_DEFINITIONVIRT(Type)\


#undef ROOT_TGRAPHQQ_DEFINITIONNONVIRT
#define ROOT_TGRAPHQQ_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTGraphQQ ( int  nx, double * x, int  ny, double * y )\
{\
Type * newp = new Type (nx, x, ny, y); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TGRAPH_DECLARATIONVIRT(TGraphQQ);
ROOT_TNAMED_DECLARATIONVIRT(TGraphQQ);
ROOT_TATTLINE_DECLARATIONVIRT(TGraphQQ);
ROOT_TATTFILL_DECLARATIONVIRT(TGraphQQ);
ROOT_TATTMARKER_DECLARATIONVIRT(TGraphQQ);
ROOT_TOBJECT_DECLARATIONVIRT(TGraphQQ);
ROOT_DELETABLE_DECLARATIONVIRT(TGraphQQ);


ROOT_TGRAPHQQ_DECLARATIONVIRT(TGraphQQ);


ROOT_TGRAPHQQ_DECLARATIONNONVIRT(TGraphQQ);


#ifdef __cplusplus
}
#endif
