#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTH1.h"
#include "HROOTTArrayD.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "HROOTTArray.h"

#undef ROOT_TH1D_DECLARATIONVIRT
#define ROOT_TH1D_DECLARATIONVIRT(Type) \


#undef ROOT_TH1D_DECLARATIONNONVIRT
#define ROOT_TH1D_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTH1D ( const char * name, const char * title, int  nbinsx, double xlow, double xup )

#undef ROOT_TH1D_DEFINITIONVIRT
#define ROOT_TH1D_DEFINITIONVIRT(Type)\


#undef ROOT_TH1D_DEFINITIONNONVIRT
#define ROOT_TH1D_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTH1D ( const char * name, const char * title, int  nbinsx, double xlow, double xup )\
{\
Type * newp = new Type (name, title, nbinsx, xlow, xup); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TH1_DECLARATIONVIRT(TH1D);
ROOT_TARRAYD_DECLARATIONVIRT(TH1D);
ROOT_TNAMED_DECLARATIONVIRT(TH1D);
ROOT_TATTLINE_DECLARATIONVIRT(TH1D);
ROOT_TATTFILL_DECLARATIONVIRT(TH1D);
ROOT_TATTMARKER_DECLARATIONVIRT(TH1D);
ROOT_TOBJECT_DECLARATIONVIRT(TH1D);
ROOT_DELETABLE_DECLARATIONVIRT(TH1D);
ROOT_TARRAY_DECLARATIONVIRT(TH1D);


ROOT_TH1D_DECLARATIONVIRT(TH1D);


ROOT_TH1D_DECLARATIONNONVIRT(TH1D);


#ifdef __cplusplus
}
#endif
