#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTH1.h"
#include "HROOTTArrayF.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "HROOTTArray.h"

#undef ROOT_TH1F_DECLARATIONVIRT
#define ROOT_TH1F_DECLARATIONVIRT(Type) \


#undef ROOT_TH1F_DECLARATIONNONVIRT
#define ROOT_TH1F_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTH1F ( const char * name, const char * title, int  nbinsx, double xlow, double xup )

#undef ROOT_TH1F_DEFINITIONVIRT
#define ROOT_TH1F_DEFINITIONVIRT(Type)\


#undef ROOT_TH1F_DEFINITIONNONVIRT
#define ROOT_TH1F_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTH1F ( const char * name, const char * title, int  nbinsx, double xlow, double xup )\
{\
Type * newp = new Type (name, title, nbinsx, xlow, xup); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TH1_DECLARATIONVIRT(TH1F);
ROOT_TARRAYF_DECLARATIONVIRT(TH1F);
ROOT_TNAMED_DECLARATIONVIRT(TH1F);
ROOT_TATTLINE_DECLARATIONVIRT(TH1F);
ROOT_TATTFILL_DECLARATIONVIRT(TH1F);
ROOT_TATTMARKER_DECLARATIONVIRT(TH1F);
ROOT_TOBJECT_DECLARATIONVIRT(TH1F);
ROOT_DELETABLE_DECLARATIONVIRT(TH1F);
ROOT_TARRAY_DECLARATIONVIRT(TH1F);


ROOT_TH1F_DECLARATIONVIRT(TH1F);


ROOT_TH1F_DECLARATIONNONVIRT(TH1F);


#ifdef __cplusplus
}
#endif
