#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTH2.h"
#include "HROOTTArrayD.h"
#include "HROOTTH1.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "HROOTTArray.h"

#undef ROOT_TH2D_DECLARATIONVIRT
#define ROOT_TH2D_DECLARATIONVIRT(Type) \


#undef ROOT_TH2D_DECLARATIONNONVIRT
#define ROOT_TH2D_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTH2D ( const char * name, const char * title, int  nbinsx, double xlow, double xup, int  nbinsy, double ylow, double yup )

#undef ROOT_TH2D_DEFINITIONVIRT
#define ROOT_TH2D_DEFINITIONVIRT(Type)\


#undef ROOT_TH2D_DEFINITIONNONVIRT
#define ROOT_TH2D_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTH2D ( const char * name, const char * title, int  nbinsx, double xlow, double xup, int  nbinsy, double ylow, double yup )\
{\
Type * newp = new Type (name, title, nbinsx, xlow, xup, nbinsy, ylow, yup); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TH2_DECLARATIONVIRT(TH2D);
ROOT_TARRAYD_DECLARATIONVIRT(TH2D);
ROOT_TH1_DECLARATIONVIRT(TH2D);
ROOT_TNAMED_DECLARATIONVIRT(TH2D);
ROOT_TATTLINE_DECLARATIONVIRT(TH2D);
ROOT_TATTFILL_DECLARATIONVIRT(TH2D);
ROOT_TATTMARKER_DECLARATIONVIRT(TH2D);
ROOT_TOBJECT_DECLARATIONVIRT(TH2D);
ROOT_DELETABLE_DECLARATIONVIRT(TH2D);
ROOT_TARRAY_DECLARATIONVIRT(TH2D);


ROOT_TH2D_DECLARATIONVIRT(TH2D);


ROOT_TH2D_DECLARATIONNONVIRT(TH2D);


#ifdef __cplusplus
}
#endif
