#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTText.h"
#include "HROOTTAttLine.h"
#include "HROOTTNamed.h"
#include "HROOTTAttText.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TLATEX_DECLARATIONVIRT
#define ROOT_TLATEX_DECLARATIONVIRT(Type) \


#undef ROOT_TLATEX_DECLARATIONNONVIRT
#define ROOT_TLATEX_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTLatex ( double x, double y, const char * text ); \
Type ## _p Type ## _tLatexDrawLatex ( Type ## _p p, double x, double y, const char * text )

#undef ROOT_TLATEX_DEFINITIONVIRT
#define ROOT_TLATEX_DEFINITIONVIRT(Type)\


#undef ROOT_TLATEX_DEFINITIONNONVIRT
#define ROOT_TLATEX_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTLatex ( double x, double y, const char * text )\
{\
Type * newp = new Type (x, y, text); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
Type ## _p Type ## _tLatexDrawLatex ( Type ## _p p, double x, double y, const char * text )\
{\
return to_nonconst<Type ## _t, Type>((Type *)to_nonconst<Type,Type ## _t>(p)->DrawLatex(x, y, text)) ;\
}

ROOT_TTEXT_DECLARATIONVIRT(TLatex);
ROOT_TATTLINE_DECLARATIONVIRT(TLatex);
ROOT_TNAMED_DECLARATIONVIRT(TLatex);
ROOT_TATTTEXT_DECLARATIONVIRT(TLatex);
ROOT_TOBJECT_DECLARATIONVIRT(TLatex);
ROOT_DELETABLE_DECLARATIONVIRT(TLatex);


ROOT_TLATEX_DECLARATIONVIRT(TLatex);


ROOT_TLATEX_DECLARATIONNONVIRT(TLatex);


#ifdef __cplusplus
}
#endif
