#include "HROOTTShape.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TPCON.h"
#include "HROOTTPCON.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TSHAPE_DEFINITIONVIRT(TPCON)
ROOT_TNAMED_DEFINITIONVIRT(TPCON)
ROOT_TATTLINE_DEFINITIONVIRT(TPCON)
ROOT_TATTFILL_DEFINITIONVIRT(TPCON)
ROOT_TATT3D_DEFINITIONVIRT(TPCON)
ROOT_TOBJECT_DEFINITIONVIRT(TPCON)
ROOT_DELETABLE_DEFINITIONVIRT(TPCON)

ROOT_TPCON_DEFINITIONVIRT(TPCON)

ROOT_TPCON_DEFINITIONNONVIRT(TPCON)

void dummyTPCON ( void ) 
{
  
}

