#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTShape.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TPCON_DECLARATIONVIRT
#define ROOT_TPCON_DECLARATIONVIRT(Type) \


#undef ROOT_TPCON_DECLARATIONNONVIRT
#define ROOT_TPCON_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTPCON ( const char * name, const char * title, const char * material, double phi1, double dphi1, int  nz )

#undef ROOT_TPCON_DEFINITIONVIRT
#define ROOT_TPCON_DEFINITIONVIRT(Type)\


#undef ROOT_TPCON_DEFINITIONNONVIRT
#define ROOT_TPCON_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTPCON ( const char * name, const char * title, const char * material, double phi1, double dphi1, int  nz )\
{\
Type * newp = new Type (name, title, material, phi1, dphi1, nz); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TSHAPE_DECLARATIONVIRT(TPCON);
ROOT_TNAMED_DECLARATIONVIRT(TPCON);
ROOT_TATTLINE_DECLARATIONVIRT(TPCON);
ROOT_TATTFILL_DECLARATIONVIRT(TPCON);
ROOT_TATT3D_DECLARATIONVIRT(TPCON);
ROOT_TOBJECT_DECLARATIONVIRT(TPCON);
ROOT_DELETABLE_DECLARATIONVIRT(TPCON);


ROOT_TPCON_DECLARATIONVIRT(TPCON);


ROOT_TPCON_DECLARATIONNONVIRT(TPCON);


#ifdef __cplusplus
}
#endif
