#include "HROOTTVirtualPad.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttPad.h"
#include "HROOTTQObject.h"
#include "HROOTDeletable.h"
#include "TPad.h"
#include "HROOTTPad.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TVIRTUALPAD_DEFINITIONVIRT(TPad)
ROOT_TOBJECT_DEFINITIONVIRT(TPad)
ROOT_TATTLINE_DEFINITIONVIRT(TPad)
ROOT_TATTFILL_DEFINITIONVIRT(TPad)
ROOT_TATTPAD_DEFINITIONVIRT(TPad)
ROOT_TQOBJECT_DEFINITIONVIRT(TPad)
ROOT_DELETABLE_DEFINITIONVIRT(TPad)

ROOT_TPAD_DEFINITIONVIRT(TPad)

ROOT_TPAD_DEFINITIONNONVIRT(TPad)

void dummyTPad ( void ) 
{
  
}

