#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPaveText.h"
#include "HROOTTPave.h"
#include "HROOTTAttText.h"
#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TPAVESTATS_DECLARATIONVIRT
#define ROOT_TPAVESTATS_DECLARATIONVIRT(Type) \


#undef ROOT_TPAVESTATS_DECLARATIONNONVIRT
#define ROOT_TPAVESTATS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTPaveStats ( double x1, double y1, double x2, double y2, const char * br )

#undef ROOT_TPAVESTATS_DEFINITIONVIRT
#define ROOT_TPAVESTATS_DEFINITIONVIRT(Type)\


#undef ROOT_TPAVESTATS_DEFINITIONNONVIRT
#define ROOT_TPAVESTATS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTPaveStats ( double x1, double y1, double x2, double y2, const char * br )\
{\
Type * newp = new Type (x1, y1, x2, y2, br); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPAVETEXT_DECLARATIONVIRT(TPaveStats);
ROOT_TPAVE_DECLARATIONVIRT(TPaveStats);
ROOT_TATTTEXT_DECLARATIONVIRT(TPaveStats);
ROOT_TBOX_DECLARATIONVIRT(TPaveStats);
ROOT_TOBJECT_DECLARATIONVIRT(TPaveStats);
ROOT_TATTLINE_DECLARATIONVIRT(TPaveStats);
ROOT_TATTFILL_DECLARATIONVIRT(TPaveStats);
ROOT_DELETABLE_DECLARATIONVIRT(TPaveStats);


ROOT_TPAVESTATS_DECLARATIONVIRT(TPaveStats);


ROOT_TPAVESTATS_DECLARATIONNONVIRT(TPaveStats);


#ifdef __cplusplus
}
#endif
