#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPave.h"
#include "HROOTTAttText.h"
#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TPAVETEXT_DECLARATIONVIRT
#define ROOT_TPAVETEXT_DECLARATIONVIRT(Type) \


#undef ROOT_TPAVETEXT_DECLARATIONNONVIRT
#define ROOT_TPAVETEXT_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTPaveText ( double x1, double y1, double x2, double y2, const char * br )

#undef ROOT_TPAVETEXT_DEFINITIONVIRT
#define ROOT_TPAVETEXT_DEFINITIONVIRT(Type)\


#undef ROOT_TPAVETEXT_DEFINITIONNONVIRT
#define ROOT_TPAVETEXT_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTPaveText ( double x1, double y1, double x2, double y2, const char * br )\
{\
Type * newp = new Type (x1, y1, x2, y2, br); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPAVE_DECLARATIONVIRT(TPaveText);
ROOT_TATTTEXT_DECLARATIONVIRT(TPaveText);
ROOT_TBOX_DECLARATIONVIRT(TPaveText);
ROOT_TOBJECT_DECLARATIONVIRT(TPaveText);
ROOT_TATTLINE_DECLARATIONVIRT(TPaveText);
ROOT_TATTFILL_DECLARATIONVIRT(TPaveText);
ROOT_DELETABLE_DECLARATIONVIRT(TPaveText);


ROOT_TPAVETEXT_DECLARATIONVIRT(TPaveText);


ROOT_TPAVETEXT_DECLARATIONNONVIRT(TPaveText);


#ifdef __cplusplus
}
#endif
