#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TPOLYLINE_DECLARATIONVIRT
#define ROOT_TPOLYLINE_DECLARATIONVIRT(Type) \


#undef ROOT_TPOLYLINE_DECLARATIONNONVIRT
#define ROOT_TPOLYLINE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTPolyLine ( int  n, double * x, double * y, const char * option )

#undef ROOT_TPOLYLINE_DEFINITIONVIRT
#define ROOT_TPOLYLINE_DEFINITIONVIRT(Type)\


#undef ROOT_TPOLYLINE_DEFINITIONNONVIRT
#define ROOT_TPOLYLINE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTPolyLine ( int  n, double * x, double * y, const char * option )\
{\
Type * newp = new Type (n, x, y, option); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TOBJECT_DECLARATIONVIRT(TPolyLine);
ROOT_TATTLINE_DECLARATIONVIRT(TPolyLine);
ROOT_TATTFILL_DECLARATIONVIRT(TPolyLine);
ROOT_DELETABLE_DECLARATIONVIRT(TPolyLine);


ROOT_TPOLYLINE_DECLARATIONVIRT(TPolyLine);


ROOT_TPOLYLINE_DECLARATIONNONVIRT(TPolyLine);


#ifdef __cplusplus
}
#endif
