#include "HROOTTShape.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TSPHE.h"
#include "HROOTTSPHE.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TSHAPE_DEFINITIONVIRT(TSPHE)
ROOT_TNAMED_DEFINITIONVIRT(TSPHE)
ROOT_TATTLINE_DEFINITIONVIRT(TSPHE)
ROOT_TATTFILL_DEFINITIONVIRT(TSPHE)
ROOT_TATT3D_DEFINITIONVIRT(TSPHE)
ROOT_TOBJECT_DEFINITIONVIRT(TSPHE)
ROOT_DELETABLE_DEFINITIONVIRT(TSPHE)

ROOT_TSPHE_DEFINITIONVIRT(TSPHE)

ROOT_TSPHE_DEFINITIONNONVIRT(TSPHE)

void dummyTSPHE ( void ) 
{
  
}

