#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TSHAPE_DECLARATIONVIRT
#define ROOT_TSHAPE_DECLARATIONVIRT(Type) \


#undef ROOT_TSHAPE_DECLARATIONNONVIRT
#define ROOT_TSHAPE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTShape ( const char * name, const char * title, const char * material )

#undef ROOT_TSHAPE_DEFINITIONVIRT
#define ROOT_TSHAPE_DEFINITIONVIRT(Type)\


#undef ROOT_TSHAPE_DEFINITIONNONVIRT
#define ROOT_TSHAPE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTShape ( const char * name, const char * title, const char * material )\
{\
Type * newp = new Type (name, title, material); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TNAMED_DECLARATIONVIRT(TShape);
ROOT_TATTLINE_DECLARATIONVIRT(TShape);
ROOT_TATTFILL_DECLARATIONVIRT(TShape);
ROOT_TATT3D_DECLARATIONVIRT(TShape);
ROOT_TOBJECT_DECLARATIONVIRT(TShape);
ROOT_DELETABLE_DECLARATIONVIRT(TShape);


ROOT_TSHAPE_DECLARATIONVIRT(TShape);


ROOT_TSHAPE_DECLARATIONNONVIRT(TShape);


#ifdef __cplusplus
}
#endif
