#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTShape.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TTUBE_DECLARATIONVIRT
#define ROOT_TTUBE_DECLARATIONVIRT(Type) \


#undef ROOT_TTUBE_DECLARATIONNONVIRT
#define ROOT_TTUBE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTTUBE ( const char * name, const char * title, const char * material, double rmin, double rmax, double dz, double aspect )

#undef ROOT_TTUBE_DEFINITIONVIRT
#define ROOT_TTUBE_DEFINITIONVIRT(Type)\


#undef ROOT_TTUBE_DEFINITIONNONVIRT
#define ROOT_TTUBE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTTUBE ( const char * name, const char * title, const char * material, double rmin, double rmax, double dz, double aspect )\
{\
Type * newp = new Type (name, title, material, rmin, rmax, dz, aspect); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TSHAPE_DECLARATIONVIRT(TTUBE);
ROOT_TNAMED_DECLARATIONVIRT(TTUBE);
ROOT_TATTLINE_DECLARATIONVIRT(TTUBE);
ROOT_TATTFILL_DECLARATIONVIRT(TTUBE);
ROOT_TATT3D_DECLARATIONVIRT(TTUBE);
ROOT_TOBJECT_DECLARATIONVIRT(TTUBE);
ROOT_DELETABLE_DECLARATIONVIRT(TTUBE);


ROOT_TTUBE_DECLARATIONVIRT(TTUBE);


ROOT_TTUBE_DECLARATIONNONVIRT(TTUBE);


#ifdef __cplusplus
}
#endif
