#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttPad.h"
#include "HROOTTQObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TVIRTUALPAD_DECLARATIONVIRT
#define ROOT_TVIRTUALPAD_DECLARATIONVIRT(Type) \
TVirtualPad_p Type ## _cd ( Type ## _p p, int  subpadnumber ); \
TFrame_p Type ## _GetFrame ( Type ## _p p ); \
void Type ## _Modified ( Type ## _p p, int flag ); \
void Type ## _Range ( Type ## _p p, double x1, double y1, double x2, double y2 )

#undef ROOT_TVIRTUALPAD_DECLARATIONNONVIRT
#define ROOT_TVIRTUALPAD_DECLARATIONNONVIRT(Type) \


#undef ROOT_TVIRTUALPAD_DEFINITIONVIRT
#define ROOT_TVIRTUALPAD_DEFINITIONVIRT(Type)\
TVirtualPad_p Type ## _cd ( Type ## _p p, int  subpadnumber )\
{\
return to_nonconst<TVirtualPad_t,TVirtualPad>((TVirtualPad*)to_nonconst<Type,Type ## _t>(p)->cd(subpadnumber));\
}\
TFrame_p Type ## _GetFrame ( Type ## _p p )\
{\
return to_nonconst<TFrame_t,TFrame>((TFrame*)to_nonconst<Type,Type ## _t>(p)->GetFrame());\
}\
void Type ## _Modified ( Type ## _p p, int flag )\
{\
to_nonconst<Type,Type ## _t>(p)->Modified(flag);\
}\
void Type ## _Range ( Type ## _p p, double x1, double y1, double x2, double y2 )\
{\
to_nonconst<Type,Type ## _t>(p)->Range(x1, y1, x2, y2);\
}

#undef ROOT_TVIRTUALPAD_DEFINITIONNONVIRT
#define ROOT_TVIRTUALPAD_DEFINITIONNONVIRT(Type)\


ROOT_TOBJECT_DECLARATIONVIRT(TVirtualPad);
ROOT_TATTLINE_DECLARATIONVIRT(TVirtualPad);
ROOT_TATTFILL_DECLARATIONVIRT(TVirtualPad);
ROOT_TATTPAD_DECLARATIONVIRT(TVirtualPad);
ROOT_TQOBJECT_DECLARATIONVIRT(TVirtualPad);
ROOT_DELETABLE_DECLARATIONVIRT(TVirtualPad);


ROOT_TVIRTUALPAD_DECLARATIONVIRT(TVirtualPad);


ROOT_TVIRTUALPAD_DECLARATIONNONVIRT(TVirtualPad);


#ifdef __cplusplus
}
#endif
