{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TApplication.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TApplication.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTApplication.h"

foreign import ccall "HROOTTApplication.h TApplication_Draw" c_tapplication_draw 
  :: (Ptr RawTApplication) -> CString -> IO ()
foreign import ccall "HROOTTApplication.h TApplication_FindObject" c_tapplication_findobject 
  :: (Ptr RawTApplication) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTApplication.h TApplication_GetName" c_tapplication_getname 
  :: (Ptr RawTApplication) -> IO CString
foreign import ccall "HROOTTApplication.h TApplication_IsA" c_tapplication_isa 
  :: (Ptr RawTApplication) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTApplication.h TApplication_IsFolder" c_tapplication_isfolder 
  :: (Ptr RawTApplication) -> IO CInt
foreign import ccall "HROOTTApplication.h TApplication_IsEqual" c_tapplication_isequal 
  :: (Ptr RawTApplication) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTApplication.h TApplication_IsSortable" c_tapplication_issortable 
  :: (Ptr RawTApplication) -> IO CInt
foreign import ccall "HROOTTApplication.h TApplication_Paint" c_tapplication_paint 
  :: (Ptr RawTApplication) -> CString -> IO ()
foreign import ccall "HROOTTApplication.h TApplication_printObj" c_tapplication_printobj 
  :: (Ptr RawTApplication) -> CString -> IO ()
foreign import ccall "HROOTTApplication.h TApplication_RecursiveRemove" c_tapplication_recursiveremove 
  :: (Ptr RawTApplication) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTApplication.h TApplication_SaveAs" c_tapplication_saveas 
  :: (Ptr RawTApplication) -> CString -> CString -> IO ()
foreign import ccall "HROOTTApplication.h TApplication_UseCurrentStyle" c_tapplication_usecurrentstyle 
  :: (Ptr RawTApplication) -> IO ()
foreign import ccall "HROOTTApplication.h TApplication_Write" c_tapplication_write 
  :: (Ptr RawTApplication) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTApplication.h TApplication_delete" c_tapplication_delete 
  :: (Ptr RawTApplication) -> IO ()
foreign import ccall "HROOTTApplication.h TApplication_newTApplication" c_tapplication_newtapplication 
  :: CString -> (Ptr CInt) -> (Ptr (CString)) -> IO (Ptr RawTApplication)
foreign import ccall "HROOTTApplication.h TApplication_Run" c_tapplication_run 
  :: (Ptr RawTApplication) -> CInt -> IO ()

