{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TArrayI.Implementation where


import HROOT.TypeCast

import HROOT.Class.TArrayI.RawType
import HROOT.Class.TArrayI.FFI
import HROOT.Class.TArrayI.Interface
import HROOT.Class.TArrayI.Cast

import HROOT.Class.TArray.RawType
import HROOT.Class.TArray.Cast
import HROOT.Class.TArray.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITArrayI TArrayI where
instance ITArray TArrayI where
instance IDeletable TArrayI where
  delete = xform0 c_tarrayi_delete

instance ITArrayI (Exist TArrayI) where

instance ITArray (Exist TArrayI) where

instance IDeletable (Exist TArrayI) where
  delete (ETArrayI x) = delete x





instance FPtr (Exist TArrayI) where
  type Raw (Exist TArrayI) = RawTArrayI
  get_fptr (ETArrayI obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayI (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayI) :: TArrayI)
