{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TArrayI.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TArrayI.RawType

import HROOT.Class.TArray.Interface


class (ITArray a) => ITArrayI a where

instance Existable TArrayI where
  data Exist TArrayI = forall a. (FPtr a, ITArrayI a) => ETArrayI a

upcastTArrayI :: (FPtr a, ITArrayI a) => a -> TArrayI
upcastTArrayI h = let fh = get_fptr h
                      fh2 :: ForeignPtr RawTArrayI = castForeignPtr fh
                  in cast_fptr_to_obj fh2
