{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TArrayL.Implementation where


import HROOT.TypeCast

import HROOT.Class.TArrayL.RawType
import HROOT.Class.TArrayL.FFI
import HROOT.Class.TArrayL.Interface
import HROOT.Class.TArrayL.Cast

import HROOT.Class.TArray.RawType
import HROOT.Class.TArray.Cast
import HROOT.Class.TArray.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITArrayL TArrayL where
instance ITArray TArrayL where
instance IDeletable TArrayL where
  delete = xform0 c_tarrayl_delete

instance ITArrayL (Exist TArrayL) where

instance ITArray (Exist TArrayL) where

instance IDeletable (Exist TArrayL) where
  delete (ETArrayL x) = delete x





instance FPtr (Exist TArrayL) where
  type Raw (Exist TArrayL) = RawTArrayL
  get_fptr (ETArrayL obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayL (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayL) :: TArrayL)
