{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TArrayS.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TArrayS.RawType

import HROOT.Class.TArray.Interface


class (ITArray a) => ITArrayS a where

instance Existable TArrayS where
  data Exist TArrayS = forall a. (FPtr a, ITArrayS a) => ETArrayS a

upcastTArrayS :: (FPtr a, ITArrayS a) => a -> TArrayS
upcastTArrayS h = let fh = get_fptr h
                      fh2 :: ForeignPtr RawTArrayS = castForeignPtr fh
                  in cast_fptr_to_obj fh2
