{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TAttAxis.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TAttAxis.RawType


#include "HROOTTAttAxis.h"

foreign import ccall "HROOTTAttAxis.h TAttAxis_delete" c_tattaxis_delete 
  :: (Ptr RawTAttAxis) -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_newTAttAxis" c_tattaxis_newtattaxis 
  :: IO (Ptr RawTAttAxis)
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetNdivisions" c_tattaxis_getndivisions 
  :: (Ptr RawTAttAxis) -> IO CInt
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetAxisColor" c_tattaxis_getaxiscolor 
  :: (Ptr RawTAttAxis) -> IO CInt
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetLabelColor" c_tattaxis_getlabelcolor 
  :: (Ptr RawTAttAxis) -> IO CInt
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetLabelFont" c_tattaxis_getlabelfont 
  :: (Ptr RawTAttAxis) -> IO CInt
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetLabelOffset" c_tattaxis_getlabeloffset 
  :: (Ptr RawTAttAxis) -> IO CDouble
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetLabelSize" c_tattaxis_getlabelsize 
  :: (Ptr RawTAttAxis) -> IO CDouble
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetTitleOffset" c_tattaxis_gettitleoffset 
  :: (Ptr RawTAttAxis) -> IO CDouble
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetTitleSize" c_tattaxis_gettitlesize 
  :: (Ptr RawTAttAxis) -> IO CDouble
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetTickLength" c_tattaxis_getticklength 
  :: (Ptr RawTAttAxis) -> IO CDouble
foreign import ccall "HROOTTAttAxis.h TAttAxis_GetTitleFont" c_tattaxis_gettitlefont 
  :: (Ptr RawTAttAxis) -> IO CInt
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetNdivisions" c_tattaxis_setndivisions 
  :: (Ptr RawTAttAxis) -> CInt -> CInt -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetAxisColor" c_tattaxis_setaxiscolor 
  :: (Ptr RawTAttAxis) -> CInt -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetLabelColor" c_tattaxis_setlabelcolor 
  :: (Ptr RawTAttAxis) -> CInt -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetLabelFont" c_tattaxis_setlabelfont 
  :: (Ptr RawTAttAxis) -> CInt -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetLabelOffset" c_tattaxis_setlabeloffset 
  :: (Ptr RawTAttAxis) -> CDouble -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetLabelSize" c_tattaxis_setlabelsize 
  :: (Ptr RawTAttAxis) -> CDouble -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetTickLength" c_tattaxis_setticklength 
  :: (Ptr RawTAttAxis) -> CDouble -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetTitleOffset" c_tattaxis_settitleoffset 
  :: (Ptr RawTAttAxis) -> CDouble -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetTitleSize" c_tattaxis_settitlesize 
  :: (Ptr RawTAttAxis) -> CDouble -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetTitleColor" c_tattaxis_settitlecolor 
  :: (Ptr RawTAttAxis) -> CInt -> IO ()
foreign import ccall "HROOTTAttAxis.h TAttAxis_SetTitleFont" c_tattaxis_settitlefont 
  :: (Ptr RawTAttAxis) -> CInt -> IO ()

