{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TAttCanvas.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TAttCanvas.RawType

import HROOT.Class.Deletable.Interface


class (IDeletable a) => ITAttCanvas a where

instance Existable TAttCanvas where
  data Exist TAttCanvas = forall a. (FPtr a, ITAttCanvas a) => ETAttCanvas a

upcastTAttCanvas :: (FPtr a, ITAttCanvas a) => a -> TAttCanvas
upcastTAttCanvas h = let fh = get_fptr h
                         fh2 :: ForeignPtr RawTAttCanvas = castForeignPtr fh
                     in cast_fptr_to_obj fh2
