{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TAttParticle.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TAttParticle.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTAttParticle.h"

foreign import ccall "HROOTTAttParticle.h TAttParticle_SetName" c_tattparticle_setname 
  :: (Ptr RawTAttParticle) -> CString -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_SetNameTitle" c_tattparticle_setnametitle 
  :: (Ptr RawTAttParticle) -> CString -> CString -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_SetTitle" c_tattparticle_settitle 
  :: (Ptr RawTAttParticle) -> CString -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_Draw" c_tattparticle_draw 
  :: (Ptr RawTAttParticle) -> CString -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_FindObject" c_tattparticle_findobject 
  :: (Ptr RawTAttParticle) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTAttParticle.h TAttParticle_GetName" c_tattparticle_getname 
  :: (Ptr RawTAttParticle) -> IO CString
foreign import ccall "HROOTTAttParticle.h TAttParticle_IsA" c_tattparticle_isa 
  :: (Ptr RawTAttParticle) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTAttParticle.h TAttParticle_IsFolder" c_tattparticle_isfolder 
  :: (Ptr RawTAttParticle) -> IO CInt
foreign import ccall "HROOTTAttParticle.h TAttParticle_IsEqual" c_tattparticle_isequal 
  :: (Ptr RawTAttParticle) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTAttParticle.h TAttParticle_IsSortable" c_tattparticle_issortable 
  :: (Ptr RawTAttParticle) -> IO CInt
foreign import ccall "HROOTTAttParticle.h TAttParticle_Paint" c_tattparticle_paint 
  :: (Ptr RawTAttParticle) -> CString -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_printObj" c_tattparticle_printobj 
  :: (Ptr RawTAttParticle) -> CString -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_RecursiveRemove" c_tattparticle_recursiveremove 
  :: (Ptr RawTAttParticle) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_SaveAs" c_tattparticle_saveas 
  :: (Ptr RawTAttParticle) -> CString -> CString -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_UseCurrentStyle" c_tattparticle_usecurrentstyle 
  :: (Ptr RawTAttParticle) -> IO ()
foreign import ccall "HROOTTAttParticle.h TAttParticle_Write" c_tattparticle_write 
  :: (Ptr RawTAttParticle) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTAttParticle.h TAttParticle_delete" c_tattparticle_delete 
  :: (Ptr RawTAttParticle) -> IO ()

