{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TAttParticle.Implementation where


import HROOT.TypeCast

import HROOT.Class.TAttParticle.RawType
import HROOT.Class.TAttParticle.FFI
import HROOT.Class.TAttParticle.Interface
import HROOT.Class.TAttParticle.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TNamed.RawType
import HROOT.Class.TNamed.Cast
import HROOT.Class.TNamed.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITAttParticle TAttParticle where
instance ITNamed TAttParticle where
  setName = xform1 c_tattparticle_setname
  setNameTitle = xform2 c_tattparticle_setnametitle
  setTitle = xform1 c_tattparticle_settitle
instance ITObject TAttParticle where
  draw = xform1 c_tattparticle_draw
  findObject = xform1 c_tattparticle_findobject
  getName = xform0 c_tattparticle_getname
  isA = xform0 c_tattparticle_isa
  isFolder = xform0 c_tattparticle_isfolder
  isEqual = xform1 c_tattparticle_isequal
  isSortable = xform0 c_tattparticle_issortable
  paint = xform1 c_tattparticle_paint
  printObj = xform1 c_tattparticle_printobj
  recursiveRemove = xform1 c_tattparticle_recursiveremove
  saveAs = xform2 c_tattparticle_saveas
  useCurrentStyle = xform0 c_tattparticle_usecurrentstyle
  write = xform3 c_tattparticle_write
instance IDeletable TAttParticle where
  delete = xform0 c_tattparticle_delete

instance ITAttParticle (Exist TAttParticle) where

instance ITNamed (Exist TAttParticle) where
  setName (ETAttParticle x) = setName x
  setNameTitle (ETAttParticle x) = setNameTitle x
  setTitle (ETAttParticle x) = setTitle x
instance ITObject (Exist TAttParticle) where
  draw (ETAttParticle x) = draw x
  findObject (ETAttParticle x) = findObject x
  getName (ETAttParticle x) = getName x
  isA (ETAttParticle x) = isA x
  isFolder (ETAttParticle x) = isFolder x
  isEqual (ETAttParticle x) = isEqual x
  isSortable (ETAttParticle x) = isSortable x
  paint (ETAttParticle x) = paint x
  printObj (ETAttParticle x) = printObj x
  recursiveRemove (ETAttParticle x) = recursiveRemove x
  saveAs (ETAttParticle x) = saveAs x
  useCurrentStyle (ETAttParticle x) = useCurrentStyle x
  write (ETAttParticle x) = write x
instance IDeletable (Exist TAttParticle) where
  delete (ETAttParticle x) = delete x





instance FPtr (Exist TAttParticle) where
  type Raw (Exist TAttParticle) = RawTAttParticle
  get_fptr (ETAttParticle obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttParticle (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttParticle) :: TAttParticle)
