{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TAttText.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TAttText.RawType


#include "HROOTTAttText.h"

foreign import ccall "HROOTTAttText.h TAttText_delete" c_tatttext_delete 
  :: (Ptr RawTAttText) -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_newTAttText" c_tatttext_newtatttext 
  :: CInt -> CDouble -> CInt -> CInt -> CDouble -> IO (Ptr RawTAttText)
foreign import ccall "HROOTTAttText.h TAttText_GetTextAlign" c_tatttext_gettextalign 
  :: (Ptr RawTAttText) -> IO CInt
foreign import ccall "HROOTTAttText.h TAttText_GetTextAngle" c_tatttext_gettextangle 
  :: (Ptr RawTAttText) -> IO CDouble
foreign import ccall "HROOTTAttText.h TAttText_GetTextColor" c_tatttext_gettextcolor 
  :: (Ptr RawTAttText) -> IO CInt
foreign import ccall "HROOTTAttText.h TAttText_GetTextFont" c_tatttext_gettextfont 
  :: (Ptr RawTAttText) -> IO CInt
foreign import ccall "HROOTTAttText.h TAttText_GetTextSize" c_tatttext_gettextsize 
  :: (Ptr RawTAttText) -> IO CDouble
foreign import ccall "HROOTTAttText.h TAttText_ResetAttText" c_tatttext_resetatttext 
  :: (Ptr RawTAttText) -> CString -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_SetTextAttributes" c_tatttext_settextattributes 
  :: (Ptr RawTAttText) -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_SetTextAlign" c_tatttext_settextalign 
  :: (Ptr RawTAttText) -> CInt -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_SetTextAngle" c_tatttext_settextangle 
  :: (Ptr RawTAttText) -> CDouble -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_SetTextColor" c_tatttext_settextcolor 
  :: (Ptr RawTAttText) -> CInt -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_SetTextFont" c_tatttext_settextfont 
  :: (Ptr RawTAttText) -> CInt -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_SetTextSize" c_tatttext_settextsize 
  :: (Ptr RawTAttText) -> CDouble -> IO ()
foreign import ccall "HROOTTAttText.h TAttText_SetTextSizePixels" c_tatttext_settextsizepixels 
  :: (Ptr RawTAttText) -> CInt -> IO ()

