{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TBranch.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TBranch.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTBranch.h"

foreign import ccall "HROOTTBranch.h TBranch_SetName" c_tbranch_setname 
  :: (Ptr RawTBranch) -> CString -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_SetNameTitle" c_tbranch_setnametitle 
  :: (Ptr RawTBranch) -> CString -> CString -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_SetTitle" c_tbranch_settitle 
  :: (Ptr RawTBranch) -> CString -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_SetFillColor" c_tbranch_setfillcolor 
  :: (Ptr RawTBranch) -> CInt -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_SetFillStyle" c_tbranch_setfillstyle 
  :: (Ptr RawTBranch) -> CInt -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_Draw" c_tbranch_draw 
  :: (Ptr RawTBranch) -> CString -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_FindObject" c_tbranch_findobject 
  :: (Ptr RawTBranch) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTBranch.h TBranch_GetName" c_tbranch_getname 
  :: (Ptr RawTBranch) -> IO CString
foreign import ccall "HROOTTBranch.h TBranch_IsA" c_tbranch_isa 
  :: (Ptr RawTBranch) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTBranch.h TBranch_IsFolder" c_tbranch_isfolder 
  :: (Ptr RawTBranch) -> IO CInt
foreign import ccall "HROOTTBranch.h TBranch_IsEqual" c_tbranch_isequal 
  :: (Ptr RawTBranch) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTBranch.h TBranch_IsSortable" c_tbranch_issortable 
  :: (Ptr RawTBranch) -> IO CInt
foreign import ccall "HROOTTBranch.h TBranch_Paint" c_tbranch_paint 
  :: (Ptr RawTBranch) -> CString -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_printObj" c_tbranch_printobj 
  :: (Ptr RawTBranch) -> CString -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_RecursiveRemove" c_tbranch_recursiveremove 
  :: (Ptr RawTBranch) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_SaveAs" c_tbranch_saveas 
  :: (Ptr RawTBranch) -> CString -> CString -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_UseCurrentStyle" c_tbranch_usecurrentstyle 
  :: (Ptr RawTBranch) -> IO ()
foreign import ccall "HROOTTBranch.h TBranch_Write" c_tbranch_write 
  :: (Ptr RawTBranch) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTBranch.h TBranch_delete" c_tbranch_delete 
  :: (Ptr RawTBranch) -> IO ()

