{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TChain.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TChain.RawType

import HROOT.Class.TTree.Interface


class (ITTree a) => ITChain a where

instance Existable TChain where
  data Exist TChain = forall a. (FPtr a, ITChain a) => ETChain a

upcastTChain :: (FPtr a, ITChain a) => a -> TChain
upcastTChain h = let fh = get_fptr h
                     fh2 :: ForeignPtr RawTChain = castForeignPtr fh
                 in cast_fptr_to_obj fh2
