{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TCrown.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TCrown.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTCrown.h"

foreign import ccall "HROOTTCrown.h TCrown_Draw" c_tcrown_draw 
  :: (Ptr RawTCrown) -> CString -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_FindObject" c_tcrown_findobject 
  :: (Ptr RawTCrown) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTCrown.h TCrown_GetName" c_tcrown_getname 
  :: (Ptr RawTCrown) -> IO CString
foreign import ccall "HROOTTCrown.h TCrown_IsA" c_tcrown_isa 
  :: (Ptr RawTCrown) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTCrown.h TCrown_IsFolder" c_tcrown_isfolder 
  :: (Ptr RawTCrown) -> IO CInt
foreign import ccall "HROOTTCrown.h TCrown_IsEqual" c_tcrown_isequal 
  :: (Ptr RawTCrown) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTCrown.h TCrown_IsSortable" c_tcrown_issortable 
  :: (Ptr RawTCrown) -> IO CInt
foreign import ccall "HROOTTCrown.h TCrown_Paint" c_tcrown_paint 
  :: (Ptr RawTCrown) -> CString -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_printObj" c_tcrown_printobj 
  :: (Ptr RawTCrown) -> CString -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_RecursiveRemove" c_tcrown_recursiveremove 
  :: (Ptr RawTCrown) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_SaveAs" c_tcrown_saveas 
  :: (Ptr RawTCrown) -> CString -> CString -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_UseCurrentStyle" c_tcrown_usecurrentstyle 
  :: (Ptr RawTCrown) -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_Write" c_tcrown_write 
  :: (Ptr RawTCrown) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTCrown.h TCrown_GetLineColor" c_tcrown_getlinecolor 
  :: (Ptr RawTCrown) -> IO CInt
foreign import ccall "HROOTTCrown.h TCrown_GetLineStyle" c_tcrown_getlinestyle 
  :: (Ptr RawTCrown) -> IO CInt
foreign import ccall "HROOTTCrown.h TCrown_GetLineWidth" c_tcrown_getlinewidth 
  :: (Ptr RawTCrown) -> IO CInt
foreign import ccall "HROOTTCrown.h TCrown_ResetAttLine" c_tcrown_resetattline 
  :: (Ptr RawTCrown) -> CString -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_SetLineAttributes" c_tcrown_setlineattributes 
  :: (Ptr RawTCrown) -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_SetLineColor" c_tcrown_setlinecolor 
  :: (Ptr RawTCrown) -> CInt -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_SetLineStyle" c_tcrown_setlinestyle 
  :: (Ptr RawTCrown) -> CInt -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_SetLineWidth" c_tcrown_setlinewidth 
  :: (Ptr RawTCrown) -> CInt -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_SetFillColor" c_tcrown_setfillcolor 
  :: (Ptr RawTCrown) -> CInt -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_SetFillStyle" c_tcrown_setfillstyle 
  :: (Ptr RawTCrown) -> CInt -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_delete" c_tcrown_delete 
  :: (Ptr RawTCrown) -> IO ()
foreign import ccall "HROOTTCrown.h TCrown_newTCrown" c_tcrown_newtcrown 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTCrown)

