{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TCurlyLine.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TCurlyLine.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTCurlyLine.h"

foreign import ccall "HROOTTCurlyLine.h TCurlyLine_Draw" c_tcurlyline_draw 
  :: (Ptr RawTCurlyLine) -> CString -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_FindObject" c_tcurlyline_findobject 
  :: (Ptr RawTCurlyLine) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_GetName" c_tcurlyline_getname 
  :: (Ptr RawTCurlyLine) -> IO CString
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_IsA" c_tcurlyline_isa 
  :: (Ptr RawTCurlyLine) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_IsFolder" c_tcurlyline_isfolder 
  :: (Ptr RawTCurlyLine) -> IO CInt
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_IsEqual" c_tcurlyline_isequal 
  :: (Ptr RawTCurlyLine) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_IsSortable" c_tcurlyline_issortable 
  :: (Ptr RawTCurlyLine) -> IO CInt
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_Paint" c_tcurlyline_paint 
  :: (Ptr RawTCurlyLine) -> CString -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_printObj" c_tcurlyline_printobj 
  :: (Ptr RawTCurlyLine) -> CString -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_RecursiveRemove" c_tcurlyline_recursiveremove 
  :: (Ptr RawTCurlyLine) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_SaveAs" c_tcurlyline_saveas 
  :: (Ptr RawTCurlyLine) -> CString -> CString -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_UseCurrentStyle" c_tcurlyline_usecurrentstyle 
  :: (Ptr RawTCurlyLine) -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_Write" c_tcurlyline_write 
  :: (Ptr RawTCurlyLine) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_GetLineColor" c_tcurlyline_getlinecolor 
  :: (Ptr RawTCurlyLine) -> IO CInt
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_GetLineStyle" c_tcurlyline_getlinestyle 
  :: (Ptr RawTCurlyLine) -> IO CInt
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_GetLineWidth" c_tcurlyline_getlinewidth 
  :: (Ptr RawTCurlyLine) -> IO CInt
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_ResetAttLine" c_tcurlyline_resetattline 
  :: (Ptr RawTCurlyLine) -> CString -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_SetLineAttributes" c_tcurlyline_setlineattributes 
  :: (Ptr RawTCurlyLine) -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_SetLineColor" c_tcurlyline_setlinecolor 
  :: (Ptr RawTCurlyLine) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_SetLineStyle" c_tcurlyline_setlinestyle 
  :: (Ptr RawTCurlyLine) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_SetLineWidth" c_tcurlyline_setlinewidth 
  :: (Ptr RawTCurlyLine) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_SetFillColor" c_tcurlyline_setfillcolor 
  :: (Ptr RawTCurlyLine) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_SetFillStyle" c_tcurlyline_setfillstyle 
  :: (Ptr RawTCurlyLine) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_delete" c_tcurlyline_delete 
  :: (Ptr RawTCurlyLine) -> IO ()
foreign import ccall "HROOTTCurlyLine.h TCurlyLine_newTCurlyLine" c_tcurlyline_newtcurlyline 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTCurlyLine)

