{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TDatime.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TDatime.RawType


#include "HROOTTDatime.h"

foreign import ccall "HROOTTDatime.h TDatime_delete" c_tdatime_delete 
  :: (Ptr RawTDatime) -> IO ()
foreign import ccall "HROOTTDatime.h TDatime_newTDatime" c_tdatime_newtdatime 
  :: CInt -> CInt -> CInt -> CInt -> CInt -> CInt -> IO (Ptr RawTDatime)
foreign import ccall "HROOTTDatime.h TDatime_Convert" c_tdatime_convert 
  :: (Ptr RawTDatime) -> CInt -> IO CUInt
foreign import ccall "HROOTTDatime.h TDatime_tDatimeGetDay" c_tdatime_tdatimegetday 
  :: (Ptr RawTDatime) -> IO CInt
foreign import ccall "HROOTTDatime.h TDatime_tDatimeGetHour" c_tdatime_tdatimegethour 
  :: (Ptr RawTDatime) -> IO CInt
foreign import ccall "HROOTTDatime.h TDatime_tDatimeGetMinute" c_tdatime_tdatimegetminute 
  :: (Ptr RawTDatime) -> IO CInt
foreign import ccall "HROOTTDatime.h TDatime_tDatimeGetSecond" c_tdatime_tdatimegetsecond 
  :: (Ptr RawTDatime) -> IO CInt
foreign import ccall "HROOTTDatime.h TDatime_tDatimeGetYear" c_tdatime_tdatimegetyear 
  :: (Ptr RawTDatime) -> IO CInt
foreign import ccall "HROOTTDatime.h TDatime_tDatimeGetMonth" c_tdatime_tdatimegetmonth 
  :: (Ptr RawTDatime) -> IO CInt
foreign import ccall "HROOTTDatime.h TDatime_setTDatime" c_tdatime_settdatime 
  :: (Ptr RawTDatime) -> CUInt -> IO ()

