{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TDiamond.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TDiamond.RawType

import HROOT.Class.TPaveText.Interface


class (ITPaveText a) => ITDiamond a where

instance Existable TDiamond where
  data Exist TDiamond = forall a. (FPtr a, ITDiamond a) => ETDiamond a

upcastTDiamond :: (FPtr a, ITDiamond a) => a -> TDiamond
upcastTDiamond h = let fh = get_fptr h
                       fh2 :: ForeignPtr RawTDiamond = castForeignPtr fh
                   in cast_fptr_to_obj fh2
