{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TDirectory.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TDirectory.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType
import HROOT.Class.TKey.RawType

#include "HROOTTDirectory.h"

foreign import ccall "HROOTTDirectory.h TDirectory_SetName" c_tdirectory_setname 
  :: (Ptr RawTDirectory) -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_SetNameTitle" c_tdirectory_setnametitle 
  :: (Ptr RawTDirectory) -> CString -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_SetTitle" c_tdirectory_settitle 
  :: (Ptr RawTDirectory) -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_Draw" c_tdirectory_draw 
  :: (Ptr RawTDirectory) -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_FindObject" c_tdirectory_findobject 
  :: (Ptr RawTDirectory) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTDirectory.h TDirectory_GetName" c_tdirectory_getname 
  :: (Ptr RawTDirectory) -> IO CString
foreign import ccall "HROOTTDirectory.h TDirectory_IsA" c_tdirectory_isa 
  :: (Ptr RawTDirectory) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTDirectory.h TDirectory_IsFolder" c_tdirectory_isfolder 
  :: (Ptr RawTDirectory) -> IO CInt
foreign import ccall "HROOTTDirectory.h TDirectory_IsEqual" c_tdirectory_isequal 
  :: (Ptr RawTDirectory) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTDirectory.h TDirectory_IsSortable" c_tdirectory_issortable 
  :: (Ptr RawTDirectory) -> IO CInt
foreign import ccall "HROOTTDirectory.h TDirectory_Paint" c_tdirectory_paint 
  :: (Ptr RawTDirectory) -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_printObj" c_tdirectory_printobj 
  :: (Ptr RawTDirectory) -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_RecursiveRemove" c_tdirectory_recursiveremove 
  :: (Ptr RawTDirectory) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_SaveAs" c_tdirectory_saveas 
  :: (Ptr RawTDirectory) -> CString -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_UseCurrentStyle" c_tdirectory_usecurrentstyle 
  :: (Ptr RawTDirectory) -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_Write" c_tdirectory_write 
  :: (Ptr RawTDirectory) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTDirectory.h TDirectory_delete" c_tdirectory_delete 
  :: (Ptr RawTDirectory) -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_Append" c_tdirectory_append 
  :: (Ptr RawTDirectory) -> (Ptr RawTObject) -> CInt -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_addD" c_tdirectory_addd 
  :: (Ptr RawTDirectory) -> (Ptr RawTObject) -> CInt -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_AppendKey" c_tdirectory_appendkey 
  :: (Ptr RawTDirectory) -> (Ptr RawTKey) -> IO CInt
foreign import ccall "HROOTTDirectory.h TDirectory_Close" c_tdirectory_close 
  :: (Ptr RawTDirectory) -> CString -> IO ()
foreign import ccall "HROOTTDirectory.h TDirectory_Get" c_tdirectory_get 
  :: (Ptr RawTDirectory) -> CString -> IO (Ptr RawTObject)

