{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TDirectoryFile.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TDirectoryFile.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TKey.RawType
import HROOT.Class.TClass.RawType
import HROOT.Class.TList.RawType

#include "HROOTTDirectoryFile.h"

foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_Append" c_tdirectoryfile_append 
  :: (Ptr RawTDirectoryFile) -> (Ptr RawTObject) -> CInt -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_addD" c_tdirectoryfile_addd 
  :: (Ptr RawTDirectoryFile) -> (Ptr RawTObject) -> CInt -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_AppendKey" c_tdirectoryfile_appendkey 
  :: (Ptr RawTDirectoryFile) -> (Ptr RawTKey) -> IO CInt
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_Close" c_tdirectoryfile_close 
  :: (Ptr RawTDirectoryFile) -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_Get" c_tdirectoryfile_get 
  :: (Ptr RawTDirectoryFile) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_SetName" c_tdirectoryfile_setname 
  :: (Ptr RawTDirectoryFile) -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_SetNameTitle" c_tdirectoryfile_setnametitle 
  :: (Ptr RawTDirectoryFile) -> CString -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_SetTitle" c_tdirectoryfile_settitle 
  :: (Ptr RawTDirectoryFile) -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_Draw" c_tdirectoryfile_draw 
  :: (Ptr RawTDirectoryFile) -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_FindObject" c_tdirectoryfile_findobject 
  :: (Ptr RawTDirectoryFile) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_GetName" c_tdirectoryfile_getname 
  :: (Ptr RawTDirectoryFile) -> IO CString
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_IsA" c_tdirectoryfile_isa 
  :: (Ptr RawTDirectoryFile) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_IsFolder" c_tdirectoryfile_isfolder 
  :: (Ptr RawTDirectoryFile) -> IO CInt
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_IsEqual" c_tdirectoryfile_isequal 
  :: (Ptr RawTDirectoryFile) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_IsSortable" c_tdirectoryfile_issortable 
  :: (Ptr RawTDirectoryFile) -> IO CInt
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_Paint" c_tdirectoryfile_paint 
  :: (Ptr RawTDirectoryFile) -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_printObj" c_tdirectoryfile_printobj 
  :: (Ptr RawTDirectoryFile) -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_RecursiveRemove" c_tdirectoryfile_recursiveremove 
  :: (Ptr RawTDirectoryFile) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_SaveAs" c_tdirectoryfile_saveas 
  :: (Ptr RawTDirectoryFile) -> CString -> CString -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_UseCurrentStyle" c_tdirectoryfile_usecurrentstyle 
  :: (Ptr RawTDirectoryFile) -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_Write" c_tdirectoryfile_write 
  :: (Ptr RawTDirectoryFile) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_delete" c_tdirectoryfile_delete 
  :: (Ptr RawTDirectoryFile) -> IO ()
foreign import ccall "HROOTTDirectoryFile.h TDirectoryFile_GetListOfKeys" c_tdirectoryfile_getlistofkeys 
  :: (Ptr RawTDirectoryFile) -> IO (Ptr RawTList)

