{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TEfficiency.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TEfficiency.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTEfficiency.h"

foreign import ccall "HROOTTEfficiency.h TEfficiency_SetName" c_tefficiency_setname 
  :: (Ptr RawTEfficiency) -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetNameTitle" c_tefficiency_setnametitle 
  :: (Ptr RawTEfficiency) -> CString -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetTitle" c_tefficiency_settitle 
  :: (Ptr RawTEfficiency) -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_GetLineColor" c_tefficiency_getlinecolor 
  :: (Ptr RawTEfficiency) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_GetLineStyle" c_tefficiency_getlinestyle 
  :: (Ptr RawTEfficiency) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_GetLineWidth" c_tefficiency_getlinewidth 
  :: (Ptr RawTEfficiency) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_ResetAttLine" c_tefficiency_resetattline 
  :: (Ptr RawTEfficiency) -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetLineAttributes" c_tefficiency_setlineattributes 
  :: (Ptr RawTEfficiency) -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetLineColor" c_tefficiency_setlinecolor 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetLineStyle" c_tefficiency_setlinestyle 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetLineWidth" c_tefficiency_setlinewidth 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetFillColor" c_tefficiency_setfillcolor 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetFillStyle" c_tefficiency_setfillstyle 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_GetMarkerColor" c_tefficiency_getmarkercolor 
  :: (Ptr RawTEfficiency) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_GetMarkerStyle" c_tefficiency_getmarkerstyle 
  :: (Ptr RawTEfficiency) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_GetMarkerSize" c_tefficiency_getmarkersize 
  :: (Ptr RawTEfficiency) -> IO CDouble
foreign import ccall "HROOTTEfficiency.h TEfficiency_ResetAttMarker" c_tefficiency_resetattmarker 
  :: (Ptr RawTEfficiency) -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetMarkerAttributes" c_tefficiency_setmarkerattributes 
  :: (Ptr RawTEfficiency) -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetMarkerColor" c_tefficiency_setmarkercolor 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetMarkerStyle" c_tefficiency_setmarkerstyle 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SetMarkerSize" c_tefficiency_setmarkersize 
  :: (Ptr RawTEfficiency) -> CInt -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_Draw" c_tefficiency_draw 
  :: (Ptr RawTEfficiency) -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_FindObject" c_tefficiency_findobject 
  :: (Ptr RawTEfficiency) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTEfficiency.h TEfficiency_GetName" c_tefficiency_getname 
  :: (Ptr RawTEfficiency) -> IO CString
foreign import ccall "HROOTTEfficiency.h TEfficiency_IsA" c_tefficiency_isa 
  :: (Ptr RawTEfficiency) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTEfficiency.h TEfficiency_IsFolder" c_tefficiency_isfolder 
  :: (Ptr RawTEfficiency) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_IsEqual" c_tefficiency_isequal 
  :: (Ptr RawTEfficiency) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_IsSortable" c_tefficiency_issortable 
  :: (Ptr RawTEfficiency) -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_Paint" c_tefficiency_paint 
  :: (Ptr RawTEfficiency) -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_printObj" c_tefficiency_printobj 
  :: (Ptr RawTEfficiency) -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_RecursiveRemove" c_tefficiency_recursiveremove 
  :: (Ptr RawTEfficiency) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_SaveAs" c_tefficiency_saveas 
  :: (Ptr RawTEfficiency) -> CString -> CString -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_UseCurrentStyle" c_tefficiency_usecurrentstyle 
  :: (Ptr RawTEfficiency) -> IO ()
foreign import ccall "HROOTTEfficiency.h TEfficiency_Write" c_tefficiency_write 
  :: (Ptr RawTEfficiency) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTEfficiency.h TEfficiency_delete" c_tefficiency_delete 
  :: (Ptr RawTEfficiency) -> IO ()

