{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TFrame.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTFrame.h"

foreign import ccall "HROOTTFrame.h TFrame_SetBorderMode" c_tframe_setbordermode 
  :: (Ptr RawTFrame) -> CInt -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_Draw" c_tframe_draw 
  :: (Ptr RawTFrame) -> CString -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_FindObject" c_tframe_findobject 
  :: (Ptr RawTFrame) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTFrame.h TFrame_GetName" c_tframe_getname 
  :: (Ptr RawTFrame) -> IO CString
foreign import ccall "HROOTTFrame.h TFrame_IsA" c_tframe_isa 
  :: (Ptr RawTFrame) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTFrame.h TFrame_IsFolder" c_tframe_isfolder 
  :: (Ptr RawTFrame) -> IO CInt
foreign import ccall "HROOTTFrame.h TFrame_IsEqual" c_tframe_isequal 
  :: (Ptr RawTFrame) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTFrame.h TFrame_IsSortable" c_tframe_issortable 
  :: (Ptr RawTFrame) -> IO CInt
foreign import ccall "HROOTTFrame.h TFrame_Paint" c_tframe_paint 
  :: (Ptr RawTFrame) -> CString -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_printObj" c_tframe_printobj 
  :: (Ptr RawTFrame) -> CString -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_RecursiveRemove" c_tframe_recursiveremove 
  :: (Ptr RawTFrame) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_SaveAs" c_tframe_saveas 
  :: (Ptr RawTFrame) -> CString -> CString -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_UseCurrentStyle" c_tframe_usecurrentstyle 
  :: (Ptr RawTFrame) -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_Write" c_tframe_write 
  :: (Ptr RawTFrame) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTFrame.h TFrame_GetLineColor" c_tframe_getlinecolor 
  :: (Ptr RawTFrame) -> IO CInt
foreign import ccall "HROOTTFrame.h TFrame_GetLineStyle" c_tframe_getlinestyle 
  :: (Ptr RawTFrame) -> IO CInt
foreign import ccall "HROOTTFrame.h TFrame_GetLineWidth" c_tframe_getlinewidth 
  :: (Ptr RawTFrame) -> IO CInt
foreign import ccall "HROOTTFrame.h TFrame_ResetAttLine" c_tframe_resetattline 
  :: (Ptr RawTFrame) -> CString -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_SetLineAttributes" c_tframe_setlineattributes 
  :: (Ptr RawTFrame) -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_SetLineColor" c_tframe_setlinecolor 
  :: (Ptr RawTFrame) -> CInt -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_SetLineStyle" c_tframe_setlinestyle 
  :: (Ptr RawTFrame) -> CInt -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_SetLineWidth" c_tframe_setlinewidth 
  :: (Ptr RawTFrame) -> CInt -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_SetFillColor" c_tframe_setfillcolor 
  :: (Ptr RawTFrame) -> CInt -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_SetFillStyle" c_tframe_setfillstyle 
  :: (Ptr RawTFrame) -> CInt -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_delete" c_tframe_delete 
  :: (Ptr RawTFrame) -> IO ()
foreign import ccall "HROOTTFrame.h TFrame_newTFrame" c_tframe_newtframe 
  :: CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTFrame)

