{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TGroupButton.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TGroupButton.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTGroupButton.h"

foreign import ccall "HROOTTGroupButton.h TGroupButton_GetTextAlign" c_tgroupbutton_gettextalign 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetTextAngle" c_tgroupbutton_gettextangle 
  :: (Ptr RawTGroupButton) -> IO CDouble
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetTextColor" c_tgroupbutton_gettextcolor 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetTextFont" c_tgroupbutton_gettextfont 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetTextSize" c_tgroupbutton_gettextsize 
  :: (Ptr RawTGroupButton) -> IO CDouble
foreign import ccall "HROOTTGroupButton.h TGroupButton_ResetAttText" c_tgroupbutton_resetatttext 
  :: (Ptr RawTGroupButton) -> CString -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTextAttributes" c_tgroupbutton_settextattributes 
  :: (Ptr RawTGroupButton) -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTextAlign" c_tgroupbutton_settextalign 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTextAngle" c_tgroupbutton_settextangle 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTextColor" c_tgroupbutton_settextcolor 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTextFont" c_tgroupbutton_settextfont 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTextSize" c_tgroupbutton_settextsize 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTextSizePixels" c_tgroupbutton_settextsizepixels 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_cd" c_tgroupbutton_cd 
  :: (Ptr RawTGroupButton) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetFrame" c_tgroupbutton_getframe 
  :: (Ptr RawTGroupButton) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTGroupButton.h TGroupButton_Modified" c_tgroupbutton_modified 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_Range" c_tgroupbutton_range 
  :: (Ptr RawTGroupButton) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_Draw" c_tgroupbutton_draw 
  :: (Ptr RawTGroupButton) -> CString -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_FindObject" c_tgroupbutton_findobject 
  :: (Ptr RawTGroupButton) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetName" c_tgroupbutton_getname 
  :: (Ptr RawTGroupButton) -> IO CString
foreign import ccall "HROOTTGroupButton.h TGroupButton_IsA" c_tgroupbutton_isa 
  :: (Ptr RawTGroupButton) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTGroupButton.h TGroupButton_IsFolder" c_tgroupbutton_isfolder 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_IsEqual" c_tgroupbutton_isequal 
  :: (Ptr RawTGroupButton) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_IsSortable" c_tgroupbutton_issortable 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_Paint" c_tgroupbutton_paint 
  :: (Ptr RawTGroupButton) -> CString -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_printObj" c_tgroupbutton_printobj 
  :: (Ptr RawTGroupButton) -> CString -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_RecursiveRemove" c_tgroupbutton_recursiveremove 
  :: (Ptr RawTGroupButton) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SaveAs" c_tgroupbutton_saveas 
  :: (Ptr RawTGroupButton) -> CString -> CString -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_UseCurrentStyle" c_tgroupbutton_usecurrentstyle 
  :: (Ptr RawTGroupButton) -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_Write" c_tgroupbutton_write 
  :: (Ptr RawTGroupButton) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetLineColor" c_tgroupbutton_getlinecolor 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetLineStyle" c_tgroupbutton_getlinestyle 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_GetLineWidth" c_tgroupbutton_getlinewidth 
  :: (Ptr RawTGroupButton) -> IO CInt
foreign import ccall "HROOTTGroupButton.h TGroupButton_ResetAttLine" c_tgroupbutton_resetattline 
  :: (Ptr RawTGroupButton) -> CString -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetLineAttributes" c_tgroupbutton_setlineattributes 
  :: (Ptr RawTGroupButton) -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetLineColor" c_tgroupbutton_setlinecolor 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetLineStyle" c_tgroupbutton_setlinestyle 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetLineWidth" c_tgroupbutton_setlinewidth 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetFillColor" c_tgroupbutton_setfillcolor 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetFillStyle" c_tgroupbutton_setfillstyle 
  :: (Ptr RawTGroupButton) -> CInt -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_ResetAttPad" c_tgroupbutton_resetattpad 
  :: (Ptr RawTGroupButton) -> CString -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetBottomMargin" c_tgroupbutton_setbottommargin 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetLeftMargin" c_tgroupbutton_setleftmargin 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetRightMargin" c_tgroupbutton_setrightmargin 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetTopMargin" c_tgroupbutton_settopmargin 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetMargin" c_tgroupbutton_setmargin 
  :: (Ptr RawTGroupButton) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetAfile" c_tgroupbutton_setafile 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetXfile" c_tgroupbutton_setxfile 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetYfile" c_tgroupbutton_setyfile 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetAstat" c_tgroupbutton_setastat 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetXstat" c_tgroupbutton_setxstat 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_SetYstat" c_tgroupbutton_setystat 
  :: (Ptr RawTGroupButton) -> CDouble -> IO ()
foreign import ccall "HROOTTGroupButton.h TGroupButton_delete" c_tgroupbutton_delete 
  :: (Ptr RawTGroupButton) -> IO ()

