{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TH3F.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TH3F.RawType

import HROOT.Class.TH3.Interface
import HROOT.Class.TArrayF.Interface


class (ITH3 a,ITArrayF a) => ITH3F a where

instance Existable TH3F where
  data Exist TH3F = forall a. (FPtr a, ITH3F a) => ETH3F a

upcastTH3F :: (FPtr a, ITH3F a) => a -> TH3F
upcastTH3F h = let fh = get_fptr h
                   fh2 :: ForeignPtr RawTH3F = castForeignPtr fh
               in cast_fptr_to_obj fh2
