{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TH3I.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TH3I.RawType

import HROOT.Class.TH3.Interface
import HROOT.Class.TArrayI.Interface


class (ITH3 a,ITArrayI a) => ITH3I a where

instance Existable TH3I where
  data Exist TH3I = forall a. (FPtr a, ITH3I a) => ETH3I a

upcastTH3I :: (FPtr a, ITH3I a) => a -> TH3I
upcastTH3I h = let fh = get_fptr h
                   fh2 :: ForeignPtr RawTH3I = castForeignPtr fh
               in cast_fptr_to_obj fh2
