{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TInspectCanvas.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TInspectCanvas.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTInspectCanvas.h"

foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetTextAlign" c_tinspectcanvas_gettextalign 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetTextAngle" c_tinspectcanvas_gettextangle 
  :: (Ptr RawTInspectCanvas) -> IO CDouble
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetTextColor" c_tinspectcanvas_gettextcolor 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetTextFont" c_tinspectcanvas_gettextfont 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetTextSize" c_tinspectcanvas_gettextsize 
  :: (Ptr RawTInspectCanvas) -> IO CDouble
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_ResetAttText" c_tinspectcanvas_resetatttext 
  :: (Ptr RawTInspectCanvas) -> CString -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTextAttributes" c_tinspectcanvas_settextattributes 
  :: (Ptr RawTInspectCanvas) -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTextAlign" c_tinspectcanvas_settextalign 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTextAngle" c_tinspectcanvas_settextangle 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTextColor" c_tinspectcanvas_settextcolor 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTextFont" c_tinspectcanvas_settextfont 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTextSize" c_tinspectcanvas_settextsize 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTextSizePixels" c_tinspectcanvas_settextsizepixels 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_cd" c_tinspectcanvas_cd 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetFrame" c_tinspectcanvas_getframe 
  :: (Ptr RawTInspectCanvas) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_Modified" c_tinspectcanvas_modified 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_Range" c_tinspectcanvas_range 
  :: (Ptr RawTInspectCanvas) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_Draw" c_tinspectcanvas_draw 
  :: (Ptr RawTInspectCanvas) -> CString -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_FindObject" c_tinspectcanvas_findobject 
  :: (Ptr RawTInspectCanvas) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetName" c_tinspectcanvas_getname 
  :: (Ptr RawTInspectCanvas) -> IO CString
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_IsA" c_tinspectcanvas_isa 
  :: (Ptr RawTInspectCanvas) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_IsFolder" c_tinspectcanvas_isfolder 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_IsEqual" c_tinspectcanvas_isequal 
  :: (Ptr RawTInspectCanvas) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_IsSortable" c_tinspectcanvas_issortable 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_Paint" c_tinspectcanvas_paint 
  :: (Ptr RawTInspectCanvas) -> CString -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_printObj" c_tinspectcanvas_printobj 
  :: (Ptr RawTInspectCanvas) -> CString -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_RecursiveRemove" c_tinspectcanvas_recursiveremove 
  :: (Ptr RawTInspectCanvas) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SaveAs" c_tinspectcanvas_saveas 
  :: (Ptr RawTInspectCanvas) -> CString -> CString -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_UseCurrentStyle" c_tinspectcanvas_usecurrentstyle 
  :: (Ptr RawTInspectCanvas) -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_Write" c_tinspectcanvas_write 
  :: (Ptr RawTInspectCanvas) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetLineColor" c_tinspectcanvas_getlinecolor 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetLineStyle" c_tinspectcanvas_getlinestyle 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_GetLineWidth" c_tinspectcanvas_getlinewidth 
  :: (Ptr RawTInspectCanvas) -> IO CInt
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_ResetAttLine" c_tinspectcanvas_resetattline 
  :: (Ptr RawTInspectCanvas) -> CString -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetLineAttributes" c_tinspectcanvas_setlineattributes 
  :: (Ptr RawTInspectCanvas) -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetLineColor" c_tinspectcanvas_setlinecolor 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetLineStyle" c_tinspectcanvas_setlinestyle 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetLineWidth" c_tinspectcanvas_setlinewidth 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetFillColor" c_tinspectcanvas_setfillcolor 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetFillStyle" c_tinspectcanvas_setfillstyle 
  :: (Ptr RawTInspectCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_ResetAttPad" c_tinspectcanvas_resetattpad 
  :: (Ptr RawTInspectCanvas) -> CString -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetBottomMargin" c_tinspectcanvas_setbottommargin 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetLeftMargin" c_tinspectcanvas_setleftmargin 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetRightMargin" c_tinspectcanvas_setrightmargin 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetTopMargin" c_tinspectcanvas_settopmargin 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetMargin" c_tinspectcanvas_setmargin 
  :: (Ptr RawTInspectCanvas) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetAfile" c_tinspectcanvas_setafile 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetXfile" c_tinspectcanvas_setxfile 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetYfile" c_tinspectcanvas_setyfile 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetAstat" c_tinspectcanvas_setastat 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetXstat" c_tinspectcanvas_setxstat 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_SetYstat" c_tinspectcanvas_setystat 
  :: (Ptr RawTInspectCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTInspectCanvas.h TInspectCanvas_delete" c_tinspectcanvas_delete 
  :: (Ptr RawTInspectCanvas) -> IO ()

