{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TInspectCanvas.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TInspectCanvas.RawType

import HROOT.Class.TCanvas.Interface
import HROOT.Class.TAttText.Interface


class (ITCanvas a,ITAttText a) => ITInspectCanvas a where

instance Existable TInspectCanvas where
  data Exist TInspectCanvas = forall a. (FPtr a, ITInspectCanvas a) => ETInspectCanvas a

upcastTInspectCanvas :: (FPtr a, ITInspectCanvas a) => a -> TInspectCanvas
upcastTInspectCanvas h = let fh = get_fptr h
                             fh2 :: ForeignPtr RawTInspectCanvas = castForeignPtr fh
                         in cast_fptr_to_obj fh2
