{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TLegend.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TLegend.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType
import HROOT.Class.TLegendEntry.RawType

#include "HROOTTLegend.h"

foreign import ccall "HROOTTLegend.h TLegend_GetTextAlign" c_tlegend_gettextalign 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_GetTextAngle" c_tlegend_gettextangle 
  :: (Ptr RawTLegend) -> IO CDouble
foreign import ccall "HROOTTLegend.h TLegend_GetTextColor" c_tlegend_gettextcolor 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_GetTextFont" c_tlegend_gettextfont 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_GetTextSize" c_tlegend_gettextsize 
  :: (Ptr RawTLegend) -> IO CDouble
foreign import ccall "HROOTTLegend.h TLegend_ResetAttText" c_tlegend_resetatttext 
  :: (Ptr RawTLegend) -> CString -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetTextAttributes" c_tlegend_settextattributes 
  :: (Ptr RawTLegend) -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetTextAlign" c_tlegend_settextalign 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetTextAngle" c_tlegend_settextangle 
  :: (Ptr RawTLegend) -> CDouble -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetTextColor" c_tlegend_settextcolor 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetTextFont" c_tlegend_settextfont 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetTextSize" c_tlegend_settextsize 
  :: (Ptr RawTLegend) -> CDouble -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetTextSizePixels" c_tlegend_settextsizepixels 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_Draw" c_tlegend_draw 
  :: (Ptr RawTLegend) -> CString -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_FindObject" c_tlegend_findobject 
  :: (Ptr RawTLegend) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTLegend.h TLegend_GetName" c_tlegend_getname 
  :: (Ptr RawTLegend) -> IO CString
foreign import ccall "HROOTTLegend.h TLegend_IsA" c_tlegend_isa 
  :: (Ptr RawTLegend) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTLegend.h TLegend_IsFolder" c_tlegend_isfolder 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_IsEqual" c_tlegend_isequal 
  :: (Ptr RawTLegend) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_IsSortable" c_tlegend_issortable 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_Paint" c_tlegend_paint 
  :: (Ptr RawTLegend) -> CString -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_printObj" c_tlegend_printobj 
  :: (Ptr RawTLegend) -> CString -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_RecursiveRemove" c_tlegend_recursiveremove 
  :: (Ptr RawTLegend) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SaveAs" c_tlegend_saveas 
  :: (Ptr RawTLegend) -> CString -> CString -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_UseCurrentStyle" c_tlegend_usecurrentstyle 
  :: (Ptr RawTLegend) -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_Write" c_tlegend_write 
  :: (Ptr RawTLegend) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_GetLineColor" c_tlegend_getlinecolor 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_GetLineStyle" c_tlegend_getlinestyle 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_GetLineWidth" c_tlegend_getlinewidth 
  :: (Ptr RawTLegend) -> IO CInt
foreign import ccall "HROOTTLegend.h TLegend_ResetAttLine" c_tlegend_resetattline 
  :: (Ptr RawTLegend) -> CString -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetLineAttributes" c_tlegend_setlineattributes 
  :: (Ptr RawTLegend) -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetLineColor" c_tlegend_setlinecolor 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetLineStyle" c_tlegend_setlinestyle 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetLineWidth" c_tlegend_setlinewidth 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetFillColor" c_tlegend_setfillcolor 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_SetFillStyle" c_tlegend_setfillstyle 
  :: (Ptr RawTLegend) -> CInt -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_delete" c_tlegend_delete 
  :: (Ptr RawTLegend) -> IO ()
foreign import ccall "HROOTTLegend.h TLegend_newTLegend" c_tlegend_newtlegend 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CString -> CString -> IO (Ptr RawTLegend)
foreign import ccall "HROOTTLegend.h TLegend_AddEntry" c_tlegend_addentry 
  :: (Ptr RawTLegend) -> (Ptr RawTObject) -> CString -> CString -> IO (Ptr RawTLegendEntry)

