{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TLegendEntry.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TLegendEntry.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTLegendEntry.h"

foreign import ccall "HROOTTLegendEntry.h TLegendEntry_Draw" c_tlegendentry_draw 
  :: (Ptr RawTLegendEntry) -> CString -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_FindObject" c_tlegendentry_findobject 
  :: (Ptr RawTLegendEntry) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetName" c_tlegendentry_getname 
  :: (Ptr RawTLegendEntry) -> IO CString
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_IsA" c_tlegendentry_isa 
  :: (Ptr RawTLegendEntry) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_IsFolder" c_tlegendentry_isfolder 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_IsEqual" c_tlegendentry_isequal 
  :: (Ptr RawTLegendEntry) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_IsSortable" c_tlegendentry_issortable 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_Paint" c_tlegendentry_paint 
  :: (Ptr RawTLegendEntry) -> CString -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_printObj" c_tlegendentry_printobj 
  :: (Ptr RawTLegendEntry) -> CString -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_RecursiveRemove" c_tlegendentry_recursiveremove 
  :: (Ptr RawTLegendEntry) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SaveAs" c_tlegendentry_saveas 
  :: (Ptr RawTLegendEntry) -> CString -> CString -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_UseCurrentStyle" c_tlegendentry_usecurrentstyle 
  :: (Ptr RawTLegendEntry) -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_Write" c_tlegendentry_write 
  :: (Ptr RawTLegendEntry) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetTextAlign" c_tlegendentry_gettextalign 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetTextAngle" c_tlegendentry_gettextangle 
  :: (Ptr RawTLegendEntry) -> IO CDouble
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetTextColor" c_tlegendentry_gettextcolor 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetTextFont" c_tlegendentry_gettextfont 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetTextSize" c_tlegendentry_gettextsize 
  :: (Ptr RawTLegendEntry) -> IO CDouble
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_ResetAttText" c_tlegendentry_resetatttext 
  :: (Ptr RawTLegendEntry) -> CString -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetTextAttributes" c_tlegendentry_settextattributes 
  :: (Ptr RawTLegendEntry) -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetTextAlign" c_tlegendentry_settextalign 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetTextAngle" c_tlegendentry_settextangle 
  :: (Ptr RawTLegendEntry) -> CDouble -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetTextColor" c_tlegendentry_settextcolor 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetTextFont" c_tlegendentry_settextfont 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetTextSize" c_tlegendentry_settextsize 
  :: (Ptr RawTLegendEntry) -> CDouble -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetTextSizePixels" c_tlegendentry_settextsizepixels 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetLineColor" c_tlegendentry_getlinecolor 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetLineStyle" c_tlegendentry_getlinestyle 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetLineWidth" c_tlegendentry_getlinewidth 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_ResetAttLine" c_tlegendentry_resetattline 
  :: (Ptr RawTLegendEntry) -> CString -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetLineAttributes" c_tlegendentry_setlineattributes 
  :: (Ptr RawTLegendEntry) -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetLineColor" c_tlegendentry_setlinecolor 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetLineStyle" c_tlegendentry_setlinestyle 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetLineWidth" c_tlegendentry_setlinewidth 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetFillColor" c_tlegendentry_setfillcolor 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetFillStyle" c_tlegendentry_setfillstyle 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetMarkerColor" c_tlegendentry_getmarkercolor 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetMarkerStyle" c_tlegendentry_getmarkerstyle 
  :: (Ptr RawTLegendEntry) -> IO CInt
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_GetMarkerSize" c_tlegendentry_getmarkersize 
  :: (Ptr RawTLegendEntry) -> IO CDouble
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_ResetAttMarker" c_tlegendentry_resetattmarker 
  :: (Ptr RawTLegendEntry) -> CString -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetMarkerAttributes" c_tlegendentry_setmarkerattributes 
  :: (Ptr RawTLegendEntry) -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetMarkerColor" c_tlegendentry_setmarkercolor 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetMarkerStyle" c_tlegendentry_setmarkerstyle 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_SetMarkerSize" c_tlegendentry_setmarkersize 
  :: (Ptr RawTLegendEntry) -> CInt -> IO ()
foreign import ccall "HROOTTLegendEntry.h TLegendEntry_delete" c_tlegendentry_delete 
  :: (Ptr RawTLegendEntry) -> IO ()

