{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TNtupleD.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TNtupleD.RawType

import HROOT.Class.TTree.Interface


class (ITTree a) => ITNtupleD a where

instance Existable TNtupleD where
  data Exist TNtupleD = forall a. (FPtr a, ITNtupleD a) => ETNtupleD a

upcastTNtupleD :: (FPtr a, ITNtupleD a) => a -> TNtupleD
upcastTNtupleD h = let fh = get_fptr h
                       fh2 :: ForeignPtr RawTNtupleD = castForeignPtr fh
                   in cast_fptr_to_obj fh2
