{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TObjArray.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TObjArray.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTObjArray.h"

foreign import ccall "HROOTTObjArray.h TObjArray_Draw" c_tobjarray_draw 
  :: (Ptr RawTObjArray) -> CString -> IO ()
foreign import ccall "HROOTTObjArray.h TObjArray_FindObject" c_tobjarray_findobject 
  :: (Ptr RawTObjArray) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTObjArray.h TObjArray_GetName" c_tobjarray_getname 
  :: (Ptr RawTObjArray) -> IO CString
foreign import ccall "HROOTTObjArray.h TObjArray_IsA" c_tobjarray_isa 
  :: (Ptr RawTObjArray) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTObjArray.h TObjArray_IsFolder" c_tobjarray_isfolder 
  :: (Ptr RawTObjArray) -> IO CInt
foreign import ccall "HROOTTObjArray.h TObjArray_IsEqual" c_tobjarray_isequal 
  :: (Ptr RawTObjArray) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTObjArray.h TObjArray_IsSortable" c_tobjarray_issortable 
  :: (Ptr RawTObjArray) -> IO CInt
foreign import ccall "HROOTTObjArray.h TObjArray_Paint" c_tobjarray_paint 
  :: (Ptr RawTObjArray) -> CString -> IO ()
foreign import ccall "HROOTTObjArray.h TObjArray_printObj" c_tobjarray_printobj 
  :: (Ptr RawTObjArray) -> CString -> IO ()
foreign import ccall "HROOTTObjArray.h TObjArray_RecursiveRemove" c_tobjarray_recursiveremove 
  :: (Ptr RawTObjArray) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTObjArray.h TObjArray_SaveAs" c_tobjarray_saveas 
  :: (Ptr RawTObjArray) -> CString -> CString -> IO ()
foreign import ccall "HROOTTObjArray.h TObjArray_UseCurrentStyle" c_tobjarray_usecurrentstyle 
  :: (Ptr RawTObjArray) -> IO ()
foreign import ccall "HROOTTObjArray.h TObjArray_Write" c_tobjarray_write 
  :: (Ptr RawTObjArray) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTObjArray.h TObjArray_delete" c_tobjarray_delete 
  :: (Ptr RawTObjArray) -> IO ()

