{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPave.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPave.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPave.h"

foreign import ccall "HROOTTPave.h TPave_Draw" c_tpave_draw 
  :: (Ptr RawTPave) -> CString -> IO ()
foreign import ccall "HROOTTPave.h TPave_FindObject" c_tpave_findobject 
  :: (Ptr RawTPave) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPave.h TPave_GetName" c_tpave_getname 
  :: (Ptr RawTPave) -> IO CString
foreign import ccall "HROOTTPave.h TPave_IsA" c_tpave_isa 
  :: (Ptr RawTPave) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPave.h TPave_IsFolder" c_tpave_isfolder 
  :: (Ptr RawTPave) -> IO CInt
foreign import ccall "HROOTTPave.h TPave_IsEqual" c_tpave_isequal 
  :: (Ptr RawTPave) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPave.h TPave_IsSortable" c_tpave_issortable 
  :: (Ptr RawTPave) -> IO CInt
foreign import ccall "HROOTTPave.h TPave_Paint" c_tpave_paint 
  :: (Ptr RawTPave) -> CString -> IO ()
foreign import ccall "HROOTTPave.h TPave_printObj" c_tpave_printobj 
  :: (Ptr RawTPave) -> CString -> IO ()
foreign import ccall "HROOTTPave.h TPave_RecursiveRemove" c_tpave_recursiveremove 
  :: (Ptr RawTPave) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPave.h TPave_SaveAs" c_tpave_saveas 
  :: (Ptr RawTPave) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPave.h TPave_UseCurrentStyle" c_tpave_usecurrentstyle 
  :: (Ptr RawTPave) -> IO ()
foreign import ccall "HROOTTPave.h TPave_Write" c_tpave_write 
  :: (Ptr RawTPave) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPave.h TPave_GetLineColor" c_tpave_getlinecolor 
  :: (Ptr RawTPave) -> IO CInt
foreign import ccall "HROOTTPave.h TPave_GetLineStyle" c_tpave_getlinestyle 
  :: (Ptr RawTPave) -> IO CInt
foreign import ccall "HROOTTPave.h TPave_GetLineWidth" c_tpave_getlinewidth 
  :: (Ptr RawTPave) -> IO CInt
foreign import ccall "HROOTTPave.h TPave_ResetAttLine" c_tpave_resetattline 
  :: (Ptr RawTPave) -> CString -> IO ()
foreign import ccall "HROOTTPave.h TPave_SetLineAttributes" c_tpave_setlineattributes 
  :: (Ptr RawTPave) -> IO ()
foreign import ccall "HROOTTPave.h TPave_SetLineColor" c_tpave_setlinecolor 
  :: (Ptr RawTPave) -> CInt -> IO ()
foreign import ccall "HROOTTPave.h TPave_SetLineStyle" c_tpave_setlinestyle 
  :: (Ptr RawTPave) -> CInt -> IO ()
foreign import ccall "HROOTTPave.h TPave_SetLineWidth" c_tpave_setlinewidth 
  :: (Ptr RawTPave) -> CInt -> IO ()
foreign import ccall "HROOTTPave.h TPave_SetFillColor" c_tpave_setfillcolor 
  :: (Ptr RawTPave) -> CInt -> IO ()
foreign import ccall "HROOTTPave.h TPave_SetFillStyle" c_tpave_setfillstyle 
  :: (Ptr RawTPave) -> CInt -> IO ()
foreign import ccall "HROOTTPave.h TPave_delete" c_tpave_delete 
  :: (Ptr RawTPave) -> IO ()
foreign import ccall "HROOTTPave.h TPave_newTPave" c_tpave_newtpave 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CInt -> CString -> IO (Ptr RawTPave)

