{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TPaveClass.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TPaveClass.RawType

import HROOT.Class.TPaveLabel.Interface


class (ITPaveLabel a) => ITPaveClass a where

instance Existable TPaveClass where
  data Exist TPaveClass = forall a. (FPtr a, ITPaveClass a) => ETPaveClass a

upcastTPaveClass :: (FPtr a, ITPaveClass a) => a -> TPaveClass
upcastTPaveClass h = let fh = get_fptr h
                         fh2 :: ForeignPtr RawTPaveClass = castForeignPtr fh
                     in cast_fptr_to_obj fh2
