{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPaveStats.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPaveStats.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPaveStats.h"

foreign import ccall "HROOTTPaveStats.h TPaveStats_GetTextAlign" c_tpavestats_gettextalign 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetTextAngle" c_tpavestats_gettextangle 
  :: (Ptr RawTPaveStats) -> IO CDouble
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetTextColor" c_tpavestats_gettextcolor 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetTextFont" c_tpavestats_gettextfont 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetTextSize" c_tpavestats_gettextsize 
  :: (Ptr RawTPaveStats) -> IO CDouble
foreign import ccall "HROOTTPaveStats.h TPaveStats_ResetAttText" c_tpavestats_resetatttext 
  :: (Ptr RawTPaveStats) -> CString -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetTextAttributes" c_tpavestats_settextattributes 
  :: (Ptr RawTPaveStats) -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetTextAlign" c_tpavestats_settextalign 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetTextAngle" c_tpavestats_settextangle 
  :: (Ptr RawTPaveStats) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetTextColor" c_tpavestats_settextcolor 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetTextFont" c_tpavestats_settextfont 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetTextSize" c_tpavestats_settextsize 
  :: (Ptr RawTPaveStats) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetTextSizePixels" c_tpavestats_settextsizepixels 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_Draw" c_tpavestats_draw 
  :: (Ptr RawTPaveStats) -> CString -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_FindObject" c_tpavestats_findobject 
  :: (Ptr RawTPaveStats) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetName" c_tpavestats_getname 
  :: (Ptr RawTPaveStats) -> IO CString
foreign import ccall "HROOTTPaveStats.h TPaveStats_IsA" c_tpavestats_isa 
  :: (Ptr RawTPaveStats) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPaveStats.h TPaveStats_IsFolder" c_tpavestats_isfolder 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_IsEqual" c_tpavestats_isequal 
  :: (Ptr RawTPaveStats) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_IsSortable" c_tpavestats_issortable 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_Paint" c_tpavestats_paint 
  :: (Ptr RawTPaveStats) -> CString -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_printObj" c_tpavestats_printobj 
  :: (Ptr RawTPaveStats) -> CString -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_RecursiveRemove" c_tpavestats_recursiveremove 
  :: (Ptr RawTPaveStats) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SaveAs" c_tpavestats_saveas 
  :: (Ptr RawTPaveStats) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_UseCurrentStyle" c_tpavestats_usecurrentstyle 
  :: (Ptr RawTPaveStats) -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_Write" c_tpavestats_write 
  :: (Ptr RawTPaveStats) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetLineColor" c_tpavestats_getlinecolor 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetLineStyle" c_tpavestats_getlinestyle 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_GetLineWidth" c_tpavestats_getlinewidth 
  :: (Ptr RawTPaveStats) -> IO CInt
foreign import ccall "HROOTTPaveStats.h TPaveStats_ResetAttLine" c_tpavestats_resetattline 
  :: (Ptr RawTPaveStats) -> CString -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetLineAttributes" c_tpavestats_setlineattributes 
  :: (Ptr RawTPaveStats) -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetLineColor" c_tpavestats_setlinecolor 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetLineStyle" c_tpavestats_setlinestyle 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetLineWidth" c_tpavestats_setlinewidth 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetFillColor" c_tpavestats_setfillcolor 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_SetFillStyle" c_tpavestats_setfillstyle 
  :: (Ptr RawTPaveStats) -> CInt -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_delete" c_tpavestats_delete 
  :: (Ptr RawTPaveStats) -> IO ()
foreign import ccall "HROOTTPaveStats.h TPaveStats_newTPaveStats" c_tpavestats_newtpavestats 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CString -> IO (Ptr RawTPaveStats)

