{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TRint.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TRint.RawType

import HROOT.Class.TApplication.Interface


class (ITApplication a) => ITRint a where

instance Existable TRint where
  data Exist TRint = forall a. (FPtr a, ITRint a) => ETRint a

upcastTRint :: (FPtr a, ITRint a) => a -> TRint
upcastTRint h = let fh = get_fptr h
                    fh2 :: ForeignPtr RawTRint = castForeignPtr fh
                in cast_fptr_to_obj fh2
