{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TSlider.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TSlider.RawType

import HROOT.Class.TPad.Interface


class (ITPad a) => ITSlider a where

instance Existable TSlider where
  data Exist TSlider = forall a. (FPtr a, ITSlider a) => ETSlider a

upcastTSlider :: (FPtr a, ITSlider a) => a -> TSlider
upcastTSlider h = let fh = get_fptr h
                      fh2 :: ForeignPtr RawTSlider = castForeignPtr fh
                  in cast_fptr_to_obj fh2
