{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TSliderBox.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TSliderBox.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTSliderBox.h"

foreign import ccall "HROOTTSliderBox.h TSliderBox_SetBorderMode" c_tsliderbox_setbordermode 
  :: (Ptr RawTSliderBox) -> CInt -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_Draw" c_tsliderbox_draw 
  :: (Ptr RawTSliderBox) -> CString -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_FindObject" c_tsliderbox_findobject 
  :: (Ptr RawTSliderBox) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTSliderBox.h TSliderBox_GetName" c_tsliderbox_getname 
  :: (Ptr RawTSliderBox) -> IO CString
foreign import ccall "HROOTTSliderBox.h TSliderBox_IsA" c_tsliderbox_isa 
  :: (Ptr RawTSliderBox) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTSliderBox.h TSliderBox_IsFolder" c_tsliderbox_isfolder 
  :: (Ptr RawTSliderBox) -> IO CInt
foreign import ccall "HROOTTSliderBox.h TSliderBox_IsEqual" c_tsliderbox_isequal 
  :: (Ptr RawTSliderBox) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTSliderBox.h TSliderBox_IsSortable" c_tsliderbox_issortable 
  :: (Ptr RawTSliderBox) -> IO CInt
foreign import ccall "HROOTTSliderBox.h TSliderBox_Paint" c_tsliderbox_paint 
  :: (Ptr RawTSliderBox) -> CString -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_printObj" c_tsliderbox_printobj 
  :: (Ptr RawTSliderBox) -> CString -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_RecursiveRemove" c_tsliderbox_recursiveremove 
  :: (Ptr RawTSliderBox) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_SaveAs" c_tsliderbox_saveas 
  :: (Ptr RawTSliderBox) -> CString -> CString -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_UseCurrentStyle" c_tsliderbox_usecurrentstyle 
  :: (Ptr RawTSliderBox) -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_Write" c_tsliderbox_write 
  :: (Ptr RawTSliderBox) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTSliderBox.h TSliderBox_GetLineColor" c_tsliderbox_getlinecolor 
  :: (Ptr RawTSliderBox) -> IO CInt
foreign import ccall "HROOTTSliderBox.h TSliderBox_GetLineStyle" c_tsliderbox_getlinestyle 
  :: (Ptr RawTSliderBox) -> IO CInt
foreign import ccall "HROOTTSliderBox.h TSliderBox_GetLineWidth" c_tsliderbox_getlinewidth 
  :: (Ptr RawTSliderBox) -> IO CInt
foreign import ccall "HROOTTSliderBox.h TSliderBox_ResetAttLine" c_tsliderbox_resetattline 
  :: (Ptr RawTSliderBox) -> CString -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_SetLineAttributes" c_tsliderbox_setlineattributes 
  :: (Ptr RawTSliderBox) -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_SetLineColor" c_tsliderbox_setlinecolor 
  :: (Ptr RawTSliderBox) -> CInt -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_SetLineStyle" c_tsliderbox_setlinestyle 
  :: (Ptr RawTSliderBox) -> CInt -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_SetLineWidth" c_tsliderbox_setlinewidth 
  :: (Ptr RawTSliderBox) -> CInt -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_SetFillColor" c_tsliderbox_setfillcolor 
  :: (Ptr RawTSliderBox) -> CInt -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_SetFillStyle" c_tsliderbox_setfillstyle 
  :: (Ptr RawTSliderBox) -> CInt -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_delete" c_tsliderbox_delete 
  :: (Ptr RawTSliderBox) -> IO ()
foreign import ccall "HROOTTSliderBox.h TSliderBox_newTSliderBox" c_tsliderbox_newtsliderbox 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CInt -> CInt -> CInt -> IO (Ptr RawTSliderBox)

