{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TText.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TText.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTText.h"

foreign import ccall "HROOTTText.h TText_SetName" c_ttext_setname 
  :: (Ptr RawTText) -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_SetNameTitle" c_ttext_setnametitle 
  :: (Ptr RawTText) -> CString -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_SetTitle" c_ttext_settitle 
  :: (Ptr RawTText) -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_GetTextAlign" c_ttext_gettextalign 
  :: (Ptr RawTText) -> IO CInt
foreign import ccall "HROOTTText.h TText_GetTextAngle" c_ttext_gettextangle 
  :: (Ptr RawTText) -> IO CDouble
foreign import ccall "HROOTTText.h TText_GetTextColor" c_ttext_gettextcolor 
  :: (Ptr RawTText) -> IO CInt
foreign import ccall "HROOTTText.h TText_GetTextFont" c_ttext_gettextfont 
  :: (Ptr RawTText) -> IO CInt
foreign import ccall "HROOTTText.h TText_GetTextSize" c_ttext_gettextsize 
  :: (Ptr RawTText) -> IO CDouble
foreign import ccall "HROOTTText.h TText_ResetAttText" c_ttext_resetatttext 
  :: (Ptr RawTText) -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_SetTextAttributes" c_ttext_settextattributes 
  :: (Ptr RawTText) -> IO ()
foreign import ccall "HROOTTText.h TText_SetTextAlign" c_ttext_settextalign 
  :: (Ptr RawTText) -> CInt -> IO ()
foreign import ccall "HROOTTText.h TText_SetTextAngle" c_ttext_settextangle 
  :: (Ptr RawTText) -> CDouble -> IO ()
foreign import ccall "HROOTTText.h TText_SetTextColor" c_ttext_settextcolor 
  :: (Ptr RawTText) -> CInt -> IO ()
foreign import ccall "HROOTTText.h TText_SetTextFont" c_ttext_settextfont 
  :: (Ptr RawTText) -> CInt -> IO ()
foreign import ccall "HROOTTText.h TText_SetTextSize" c_ttext_settextsize 
  :: (Ptr RawTText) -> CDouble -> IO ()
foreign import ccall "HROOTTText.h TText_SetTextSizePixels" c_ttext_settextsizepixels 
  :: (Ptr RawTText) -> CInt -> IO ()
foreign import ccall "HROOTTText.h TText_Draw" c_ttext_draw 
  :: (Ptr RawTText) -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_FindObject" c_ttext_findobject 
  :: (Ptr RawTText) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTText.h TText_GetName" c_ttext_getname 
  :: (Ptr RawTText) -> IO CString
foreign import ccall "HROOTTText.h TText_IsA" c_ttext_isa 
  :: (Ptr RawTText) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTText.h TText_IsFolder" c_ttext_isfolder 
  :: (Ptr RawTText) -> IO CInt
foreign import ccall "HROOTTText.h TText_IsEqual" c_ttext_isequal 
  :: (Ptr RawTText) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTText.h TText_IsSortable" c_ttext_issortable 
  :: (Ptr RawTText) -> IO CInt
foreign import ccall "HROOTTText.h TText_Paint" c_ttext_paint 
  :: (Ptr RawTText) -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_printObj" c_ttext_printobj 
  :: (Ptr RawTText) -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_RecursiveRemove" c_ttext_recursiveremove 
  :: (Ptr RawTText) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTText.h TText_SaveAs" c_ttext_saveas 
  :: (Ptr RawTText) -> CString -> CString -> IO ()
foreign import ccall "HROOTTText.h TText_UseCurrentStyle" c_ttext_usecurrentstyle 
  :: (Ptr RawTText) -> IO ()
foreign import ccall "HROOTTText.h TText_Write" c_ttext_write 
  :: (Ptr RawTText) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTText.h TText_delete" c_ttext_delete 
  :: (Ptr RawTText) -> IO ()
foreign import ccall "HROOTTText.h TText_newTText" c_ttext_newttext 
  :: CDouble -> CDouble -> CString -> IO (Ptr RawTText)
foreign import ccall "HROOTTText.h TText_DrawText" c_ttext_drawtext 
  :: (Ptr RawTText) -> CDouble -> CDouble -> CString -> IO (Ptr RawTText)
foreign import ccall "HROOTTText.h TText_DrawTextNDC" c_ttext_drawtextndc 
  :: (Ptr RawTText) -> CDouble -> CDouble -> CString -> IO (Ptr RawTText)
foreign import ccall "HROOTTText.h TText_GetControlBox" c_ttext_getcontrolbox 
  :: (Ptr RawTText) -> CInt -> CInt -> CInt -> (Ptr CInt) -> (Ptr CInt) -> IO ()
foreign import ccall "HROOTTText.h TText_SetText" c_ttext_settext 
  :: (Ptr RawTText) -> CDouble -> CDouble -> CString -> IO ()

