{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TTreePlayer.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TTreePlayer.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTTreePlayer.h"

foreign import ccall "HROOTTTreePlayer.h TTreePlayer_Draw" c_ttreeplayer_draw 
  :: (Ptr RawTTreePlayer) -> CString -> IO ()
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_FindObject" c_ttreeplayer_findobject 
  :: (Ptr RawTTreePlayer) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_GetName" c_ttreeplayer_getname 
  :: (Ptr RawTTreePlayer) -> IO CString
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_IsA" c_ttreeplayer_isa 
  :: (Ptr RawTTreePlayer) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_IsFolder" c_ttreeplayer_isfolder 
  :: (Ptr RawTTreePlayer) -> IO CInt
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_IsEqual" c_ttreeplayer_isequal 
  :: (Ptr RawTTreePlayer) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_IsSortable" c_ttreeplayer_issortable 
  :: (Ptr RawTTreePlayer) -> IO CInt
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_Paint" c_ttreeplayer_paint 
  :: (Ptr RawTTreePlayer) -> CString -> IO ()
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_printObj" c_ttreeplayer_printobj 
  :: (Ptr RawTTreePlayer) -> CString -> IO ()
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_RecursiveRemove" c_ttreeplayer_recursiveremove 
  :: (Ptr RawTTreePlayer) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_SaveAs" c_ttreeplayer_saveas 
  :: (Ptr RawTTreePlayer) -> CString -> CString -> IO ()
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_UseCurrentStyle" c_ttreeplayer_usecurrentstyle 
  :: (Ptr RawTTreePlayer) -> IO ()
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_Write" c_ttreeplayer_write 
  :: (Ptr RawTTreePlayer) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTTreePlayer.h TTreePlayer_delete" c_ttreeplayer_delete 
  :: (Ptr RawTTreePlayer) -> IO ()

