{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TVirtualPad.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType
import HROOT.Class.TFrame.RawType

#include "HROOTTVirtualPad.h"

foreign import ccall "HROOTTVirtualPad.h TVirtualPad_Draw" c_tvirtualpad_draw 
  :: (Ptr RawTVirtualPad) -> CString -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_FindObject" c_tvirtualpad_findobject 
  :: (Ptr RawTVirtualPad) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_GetName" c_tvirtualpad_getname 
  :: (Ptr RawTVirtualPad) -> IO CString
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_IsA" c_tvirtualpad_isa 
  :: (Ptr RawTVirtualPad) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_IsFolder" c_tvirtualpad_isfolder 
  :: (Ptr RawTVirtualPad) -> IO CInt
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_IsEqual" c_tvirtualpad_isequal 
  :: (Ptr RawTVirtualPad) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_IsSortable" c_tvirtualpad_issortable 
  :: (Ptr RawTVirtualPad) -> IO CInt
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_Paint" c_tvirtualpad_paint 
  :: (Ptr RawTVirtualPad) -> CString -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_printObj" c_tvirtualpad_printobj 
  :: (Ptr RawTVirtualPad) -> CString -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_RecursiveRemove" c_tvirtualpad_recursiveremove 
  :: (Ptr RawTVirtualPad) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SaveAs" c_tvirtualpad_saveas 
  :: (Ptr RawTVirtualPad) -> CString -> CString -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_UseCurrentStyle" c_tvirtualpad_usecurrentstyle 
  :: (Ptr RawTVirtualPad) -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_Write" c_tvirtualpad_write 
  :: (Ptr RawTVirtualPad) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_GetLineColor" c_tvirtualpad_getlinecolor 
  :: (Ptr RawTVirtualPad) -> IO CInt
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_GetLineStyle" c_tvirtualpad_getlinestyle 
  :: (Ptr RawTVirtualPad) -> IO CInt
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_GetLineWidth" c_tvirtualpad_getlinewidth 
  :: (Ptr RawTVirtualPad) -> IO CInt
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_ResetAttLine" c_tvirtualpad_resetattline 
  :: (Ptr RawTVirtualPad) -> CString -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetLineAttributes" c_tvirtualpad_setlineattributes 
  :: (Ptr RawTVirtualPad) -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetLineColor" c_tvirtualpad_setlinecolor 
  :: (Ptr RawTVirtualPad) -> CInt -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetLineStyle" c_tvirtualpad_setlinestyle 
  :: (Ptr RawTVirtualPad) -> CInt -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetLineWidth" c_tvirtualpad_setlinewidth 
  :: (Ptr RawTVirtualPad) -> CInt -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetFillColor" c_tvirtualpad_setfillcolor 
  :: (Ptr RawTVirtualPad) -> CInt -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetFillStyle" c_tvirtualpad_setfillstyle 
  :: (Ptr RawTVirtualPad) -> CInt -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_ResetAttPad" c_tvirtualpad_resetattpad 
  :: (Ptr RawTVirtualPad) -> CString -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetBottomMargin" c_tvirtualpad_setbottommargin 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetLeftMargin" c_tvirtualpad_setleftmargin 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetRightMargin" c_tvirtualpad_setrightmargin 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetTopMargin" c_tvirtualpad_settopmargin 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetMargin" c_tvirtualpad_setmargin 
  :: (Ptr RawTVirtualPad) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetAfile" c_tvirtualpad_setafile 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetXfile" c_tvirtualpad_setxfile 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetYfile" c_tvirtualpad_setyfile 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetAstat" c_tvirtualpad_setastat 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetXstat" c_tvirtualpad_setxstat 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_SetYstat" c_tvirtualpad_setystat 
  :: (Ptr RawTVirtualPad) -> CDouble -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_delete" c_tvirtualpad_delete 
  :: (Ptr RawTVirtualPad) -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_cd" c_tvirtualpad_cd 
  :: (Ptr RawTVirtualPad) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_GetFrame" c_tvirtualpad_getframe 
  :: (Ptr RawTVirtualPad) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_Modified" c_tvirtualpad_modified 
  :: (Ptr RawTVirtualPad) -> CInt -> IO ()
foreign import ccall "HROOTTVirtualPad.h TVirtualPad_Range" c_tvirtualpad_range 
  :: (Ptr RawTVirtualPad) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()

