{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TXTRU.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TXTRU.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTXTRU.h"

foreign import ccall "HROOTTXTRU.h TXTRU_SetName" c_txtru_setname 
  :: (Ptr RawTXTRU) -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetNameTitle" c_txtru_setnametitle 
  :: (Ptr RawTXTRU) -> CString -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetTitle" c_txtru_settitle 
  :: (Ptr RawTXTRU) -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_GetLineColor" c_txtru_getlinecolor 
  :: (Ptr RawTXTRU) -> IO CInt
foreign import ccall "HROOTTXTRU.h TXTRU_GetLineStyle" c_txtru_getlinestyle 
  :: (Ptr RawTXTRU) -> IO CInt
foreign import ccall "HROOTTXTRU.h TXTRU_GetLineWidth" c_txtru_getlinewidth 
  :: (Ptr RawTXTRU) -> IO CInt
foreign import ccall "HROOTTXTRU.h TXTRU_ResetAttLine" c_txtru_resetattline 
  :: (Ptr RawTXTRU) -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetLineAttributes" c_txtru_setlineattributes 
  :: (Ptr RawTXTRU) -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetLineColor" c_txtru_setlinecolor 
  :: (Ptr RawTXTRU) -> CInt -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetLineStyle" c_txtru_setlinestyle 
  :: (Ptr RawTXTRU) -> CInt -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetLineWidth" c_txtru_setlinewidth 
  :: (Ptr RawTXTRU) -> CInt -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetFillColor" c_txtru_setfillcolor 
  :: (Ptr RawTXTRU) -> CInt -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SetFillStyle" c_txtru_setfillstyle 
  :: (Ptr RawTXTRU) -> CInt -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_Draw" c_txtru_draw 
  :: (Ptr RawTXTRU) -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_FindObject" c_txtru_findobject 
  :: (Ptr RawTXTRU) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTXTRU.h TXTRU_GetName" c_txtru_getname 
  :: (Ptr RawTXTRU) -> IO CString
foreign import ccall "HROOTTXTRU.h TXTRU_IsA" c_txtru_isa 
  :: (Ptr RawTXTRU) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTXTRU.h TXTRU_IsFolder" c_txtru_isfolder 
  :: (Ptr RawTXTRU) -> IO CInt
foreign import ccall "HROOTTXTRU.h TXTRU_IsEqual" c_txtru_isequal 
  :: (Ptr RawTXTRU) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTXTRU.h TXTRU_IsSortable" c_txtru_issortable 
  :: (Ptr RawTXTRU) -> IO CInt
foreign import ccall "HROOTTXTRU.h TXTRU_Paint" c_txtru_paint 
  :: (Ptr RawTXTRU) -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_printObj" c_txtru_printobj 
  :: (Ptr RawTXTRU) -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_RecursiveRemove" c_txtru_recursiveremove 
  :: (Ptr RawTXTRU) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_SaveAs" c_txtru_saveas 
  :: (Ptr RawTXTRU) -> CString -> CString -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_UseCurrentStyle" c_txtru_usecurrentstyle 
  :: (Ptr RawTXTRU) -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_Write" c_txtru_write 
  :: (Ptr RawTXTRU) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTXTRU.h TXTRU_delete" c_txtru_delete 
  :: (Ptr RawTXTRU) -> IO ()
foreign import ccall "HROOTTXTRU.h TXTRU_newTXTRU" c_txtru_newtxtru 
  :: CString -> CString -> CString -> CInt -> CInt -> IO (Ptr RawTXTRU)

