{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TXTRU.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TXTRU.RawType

import HROOT.Class.TShape.Interface


class (ITShape a) => ITXTRU a where

instance Existable TXTRU where
  data Exist TXTRU = forall a. (FPtr a, ITXTRU a) => ETXTRU a

upcastTXTRU :: (FPtr a, ITXTRU a) => a -> TXTRU
upcastTXTRU h = let fh = get_fptr h
                    fh2 :: ForeignPtr RawTXTRU = castForeignPtr fh
                in cast_fptr_to_obj fh2
