#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTDeletable.h"

#undef ROOT_TATTLINE_DECLARATIONVIRT
#define ROOT_TATTLINE_DECLARATIONVIRT(Type) \
int  Type ## _GetLineColor ( Type ## _p p ); \
int  Type ## _GetLineStyle ( Type ## _p p ); \
int  Type ## _GetLineWidth ( Type ## _p p ); \
void Type ## _ResetAttLine ( Type ## _p p, const char * option ); \
void Type ## _SetLineAttributes ( Type ## _p p ); \
void Type ## _SetLineColor ( Type ## _p p, int  lcolor ); \
void Type ## _SetLineStyle ( Type ## _p p, int  lstyle ); \
void Type ## _SetLineWidth ( Type ## _p p, int  lwidth )

#undef ROOT_TATTLINE_DECLARATIONNONVIRT
#define ROOT_TATTLINE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTAttLine ( int  lcolor, int  lstyle, int  lwidth ); \
int  Type ## _tAttLineDistancetoLine ( Type ## _p p, int  px, int  py, double xp1, double yp1, double xp2, double yp2 )

#undef ROOT_TATTLINE_DEFINITIONVIRT
#define ROOT_TATTLINE_DEFINITIONVIRT(Type)\
int  Type ## _GetLineColor ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLineColor();\
}\
int  Type ## _GetLineStyle ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLineStyle();\
}\
int  Type ## _GetLineWidth ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLineWidth();\
}\
void Type ## _ResetAttLine ( Type ## _p p, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->ResetAttLine(option);\
}\
void Type ## _SetLineAttributes ( Type ## _p p )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLineAttributes();\
}\
void Type ## _SetLineColor ( Type ## _p p, int  lcolor )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLineColor(lcolor);\
}\
void Type ## _SetLineStyle ( Type ## _p p, int  lstyle )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLineStyle(lstyle);\
}\
void Type ## _SetLineWidth ( Type ## _p p, int  lwidth )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLineWidth(lwidth);\
}

#undef ROOT_TATTLINE_DEFINITIONNONVIRT
#define ROOT_TATTLINE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTAttLine ( int  lcolor, int  lstyle, int  lwidth )\
{\
Type * newp = new Type (lcolor, lstyle, lwidth); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
int  Type ## _tAttLineDistancetoLine ( Type ## _p p, int  px, int  py, double xp1, double yp1, double xp2, double yp2 )\
{\
return to_nonconst<Type,Type ## _t>(p)->DistancetoLine(px, py, xp1, yp1, xp2, yp2);\
}

ROOT_DELETABLE_DECLARATIONVIRT(TAttLine);


ROOT_TATTLINE_DECLARATIONVIRT(TAttLine);


ROOT_TATTLINE_DECLARATIONNONVIRT(TAttLine);


#ifdef __cplusplus
}
#endif
