#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTDeletable.h"

#undef ROOT_TATTMARKER_DECLARATIONVIRT
#define ROOT_TATTMARKER_DECLARATIONVIRT(Type) \
int  Type ## _GetMarkerColor ( Type ## _p p ); \
int  Type ## _GetMarkerStyle ( Type ## _p p ); \
double Type ## _GetMarkerSize ( Type ## _p p ); \
void Type ## _ResetAttMarker ( Type ## _p p, const char * option ); \
void Type ## _SetMarkerAttributes ( Type ## _p p ); \
void Type ## _SetMarkerColor ( Type ## _p p, int  tcolor ); \
void Type ## _SetMarkerStyle ( Type ## _p p, int  mstyle ); \
void Type ## _SetMarkerSize ( Type ## _p p, int  msize )

#undef ROOT_TATTMARKER_DECLARATIONNONVIRT
#define ROOT_TATTMARKER_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTAttMarker ( int  color, int  style, int  msize )

#undef ROOT_TATTMARKER_DEFINITIONVIRT
#define ROOT_TATTMARKER_DEFINITIONVIRT(Type)\
int  Type ## _GetMarkerColor ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMarkerColor();\
}\
int  Type ## _GetMarkerStyle ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMarkerStyle();\
}\
double Type ## _GetMarkerSize ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMarkerSize();\
}\
void Type ## _ResetAttMarker ( Type ## _p p, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->ResetAttMarker(option);\
}\
void Type ## _SetMarkerAttributes ( Type ## _p p )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMarkerAttributes();\
}\
void Type ## _SetMarkerColor ( Type ## _p p, int  tcolor )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMarkerColor(tcolor);\
}\
void Type ## _SetMarkerStyle ( Type ## _p p, int  mstyle )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMarkerStyle(mstyle);\
}\
void Type ## _SetMarkerSize ( Type ## _p p, int  msize )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMarkerSize(msize);\
}

#undef ROOT_TATTMARKER_DEFINITIONNONVIRT
#define ROOT_TATTMARKER_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTAttMarker ( int  color, int  style, int  msize )\
{\
Type * newp = new Type (color, style, msize); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_DELETABLE_DECLARATIONVIRT(TAttMarker);


ROOT_TATTMARKER_DECLARATIONVIRT(TAttMarker);


ROOT_TATTMARKER_DECLARATIONNONVIRT(TAttMarker);


#ifdef __cplusplus
}
#endif
