#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTDeletable.h"

#undef ROOT_TATTPAD_DECLARATIONVIRT
#define ROOT_TATTPAD_DECLARATIONVIRT(Type) \
void Type ## _ResetAttPad ( Type ## _p p, const char * option ); \
void Type ## _SetBottomMargin ( Type ## _p p, double bottommargin ); \
void Type ## _SetLeftMargin ( Type ## _p p, double leftmargin ); \
void Type ## _SetRightMargin ( Type ## _p p, double rightmargin ); \
void Type ## _SetTopMargin ( Type ## _p p, double topmargin ); \
void Type ## _SetMargin ( Type ## _p p, double left, double right, double bottom, double top ); \
void Type ## _SetAfile ( Type ## _p p, double afile ); \
void Type ## _SetXfile ( Type ## _p p, double xfile ); \
void Type ## _SetYfile ( Type ## _p p, double yfile ); \
void Type ## _SetAstat ( Type ## _p p, double astat ); \
void Type ## _SetXstat ( Type ## _p p, double xstat ); \
void Type ## _SetYstat ( Type ## _p p, double ystat )

#undef ROOT_TATTPAD_DECLARATIONNONVIRT
#define ROOT_TATTPAD_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTAttPad (  ); \
double Type ## _tAttPadGetBottomMargin ( Type ## _p p ); \
double Type ## _tAttPadGetLeftMargin ( Type ## _p p ); \
double Type ## _tAttPadGetRightMargin ( Type ## _p p ); \
double Type ## _tAttPadGetTopMargin ( Type ## _p p ); \
double Type ## _tAttPadGetAfile ( Type ## _p p ); \
double Type ## _tAttPadGetXfile ( Type ## _p p ); \
double Type ## _tAttPadGetYfile ( Type ## _p p ); \
double Type ## _tAttPadGetAstat ( Type ## _p p ); \
double Type ## _tAttPadGetXstat ( Type ## _p p ); \
double Type ## _tAttPadGetYstat ( Type ## _p p ); \
int  Type ## _tAttPadGetFrameFillColor ( Type ## _p p ); \
int  Type ## _tAttPadGetFrameLineColor ( Type ## _p p ); \
int  Type ## _tAttPadGetFrameFillStyle ( Type ## _p p ); \
int  Type ## _tAttPadGetFrameLineStyle ( Type ## _p p ); \
int  Type ## _tAttPadGetFrameLineWidth ( Type ## _p p ); \
int  Type ## _tAttPadGetFrameBorderSize ( Type ## _p p ); \
int  Type ## _tAttPadGetFrameBorderMode ( Type ## _p p ); \
void Type ## _tAttPadSetFrameFillColor ( Type ## _p p, int  color ); \
void Type ## _tAttPadSetFrameLineColor ( Type ## _p p, int  color ); \
void Type ## _tAttPadSetFrameFillStyle ( Type ## _p p, int  styl ); \
void Type ## _tAttPadSetFrameLineStyle ( Type ## _p p, int  styl ); \
void Type ## _tAttPadSetFrameLineWidth ( Type ## _p p, int  width ); \
void Type ## _tAttPadSetFrameBorderSize ( Type ## _p p, int  size ); \
void Type ## _tAttPadSetFrameBorderMode ( Type ## _p p, int  mode )

#undef ROOT_TATTPAD_DEFINITIONVIRT
#define ROOT_TATTPAD_DEFINITIONVIRT(Type)\
void Type ## _ResetAttPad ( Type ## _p p, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->ResetAttPad(option);\
}\
void Type ## _SetBottomMargin ( Type ## _p p, double bottommargin )\
{\
to_nonconst<Type,Type ## _t>(p)->SetBottomMargin(bottommargin);\
}\
void Type ## _SetLeftMargin ( Type ## _p p, double leftmargin )\
{\
to_nonconst<Type,Type ## _t>(p)->SetLeftMargin(leftmargin);\
}\
void Type ## _SetRightMargin ( Type ## _p p, double rightmargin )\
{\
to_nonconst<Type,Type ## _t>(p)->SetRightMargin(rightmargin);\
}\
void Type ## _SetTopMargin ( Type ## _p p, double topmargin )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTopMargin(topmargin);\
}\
void Type ## _SetMargin ( Type ## _p p, double left, double right, double bottom, double top )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMargin(left, right, bottom, top);\
}\
void Type ## _SetAfile ( Type ## _p p, double afile )\
{\
to_nonconst<Type,Type ## _t>(p)->SetAfile(afile);\
}\
void Type ## _SetXfile ( Type ## _p p, double xfile )\
{\
to_nonconst<Type,Type ## _t>(p)->SetXfile(xfile);\
}\
void Type ## _SetYfile ( Type ## _p p, double yfile )\
{\
to_nonconst<Type,Type ## _t>(p)->SetYfile(yfile);\
}\
void Type ## _SetAstat ( Type ## _p p, double astat )\
{\
to_nonconst<Type,Type ## _t>(p)->SetAstat(astat);\
}\
void Type ## _SetXstat ( Type ## _p p, double xstat )\
{\
to_nonconst<Type,Type ## _t>(p)->SetXstat(xstat);\
}\
void Type ## _SetYstat ( Type ## _p p, double ystat )\
{\
to_nonconst<Type,Type ## _t>(p)->SetYstat(ystat);\
}

#undef ROOT_TATTPAD_DEFINITIONNONVIRT
#define ROOT_TATTPAD_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTAttPad (  )\
{\
Type * newp = new Type (); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
double Type ## _tAttPadGetBottomMargin ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetBottomMargin();\
}\
double Type ## _tAttPadGetLeftMargin ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetLeftMargin();\
}\
double Type ## _tAttPadGetRightMargin ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetRightMargin();\
}\
double Type ## _tAttPadGetTopMargin ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetTopMargin();\
}\
double Type ## _tAttPadGetAfile ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetAfile();\
}\
double Type ## _tAttPadGetXfile ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetXfile();\
}\
double Type ## _tAttPadGetYfile ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetYfile();\
}\
double Type ## _tAttPadGetAstat ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetAstat();\
}\
double Type ## _tAttPadGetXstat ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetXstat();\
}\
double Type ## _tAttPadGetYstat ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetYstat();\
}\
int  Type ## _tAttPadGetFrameFillColor ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetFrameFillColor();\
}\
int  Type ## _tAttPadGetFrameLineColor ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetFrameLineColor();\
}\
int  Type ## _tAttPadGetFrameFillStyle ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetFrameFillStyle();\
}\
int  Type ## _tAttPadGetFrameLineStyle ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetFrameLineStyle();\
}\
int  Type ## _tAttPadGetFrameLineWidth ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetFrameLineWidth();\
}\
int  Type ## _tAttPadGetFrameBorderSize ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetFrameBorderSize();\
}\
int  Type ## _tAttPadGetFrameBorderMode ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetFrameBorderMode();\
}\
void Type ## _tAttPadSetFrameFillColor ( Type ## _p p, int  color )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFrameFillColor(color);\
}\
void Type ## _tAttPadSetFrameLineColor ( Type ## _p p, int  color )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFrameLineColor(color);\
}\
void Type ## _tAttPadSetFrameFillStyle ( Type ## _p p, int  styl )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFrameFillStyle(styl);\
}\
void Type ## _tAttPadSetFrameLineStyle ( Type ## _p p, int  styl )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFrameLineStyle(styl);\
}\
void Type ## _tAttPadSetFrameLineWidth ( Type ## _p p, int  width )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFrameLineWidth(width);\
}\
void Type ## _tAttPadSetFrameBorderSize ( Type ## _p p, int  size )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFrameBorderSize(size);\
}\
void Type ## _tAttPadSetFrameBorderMode ( Type ## _p p, int  mode )\
{\
to_nonconst<Type,Type ## _t>(p)->SetFrameBorderMode(mode);\
}

ROOT_DELETABLE_DECLARATIONVIRT(TAttPad);


ROOT_TATTPAD_DECLARATIONVIRT(TAttPad);


ROOT_TATTPAD_DECLARATIONNONVIRT(TAttPad);


#ifdef __cplusplus
}
#endif
