#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TBOX_DECLARATIONVIRT
#define ROOT_TBOX_DECLARATIONVIRT(Type) \


#undef ROOT_TBOX_DECLARATIONNONVIRT
#define ROOT_TBOX_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTBox ( double x1, double y1, double x2, double y2 )

#undef ROOT_TBOX_DEFINITIONVIRT
#define ROOT_TBOX_DEFINITIONVIRT(Type)\


#undef ROOT_TBOX_DEFINITIONNONVIRT
#define ROOT_TBOX_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTBox ( double x1, double y1, double x2, double y2 )\
{\
Type * newp = new Type (x1, y1, x2, y2); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TOBJECT_DECLARATIONVIRT(TBox);
ROOT_TATTLINE_DECLARATIONVIRT(TBox);
ROOT_TATTFILL_DECLARATIONVIRT(TBox);
ROOT_DELETABLE_DECLARATIONVIRT(TBox);


ROOT_TBOX_DECLARATIONVIRT(TBox);


ROOT_TBOX_DECLARATIONNONVIRT(TBox);


#ifdef __cplusplus
}
#endif
