#include "HROOTTTree.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TChain.h"
#include "HROOTTChain.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TTREE_DEFINITIONVIRT(TChain)
ROOT_TNAMED_DEFINITIONVIRT(TChain)
ROOT_TATTLINE_DEFINITIONVIRT(TChain)
ROOT_TATTFILL_DEFINITIONVIRT(TChain)
ROOT_TATTMARKER_DEFINITIONVIRT(TChain)
ROOT_TOBJECT_DEFINITIONVIRT(TChain)
ROOT_DELETABLE_DEFINITIONVIRT(TChain)

ROOT_TCHAIN_DEFINITIONVIRT(TChain)

ROOT_TCHAIN_DEFINITIONNONVIRT(TChain)

void dummyTChain ( void ) 
{
  
}

