#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTCurlyLine.h"
#include "HROOTTPolyLine.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TCURLYARC_DECLARATIONVIRT
#define ROOT_TCURLYARC_DECLARATIONVIRT(Type) \


#undef ROOT_TCURLYARC_DECLARATIONNONVIRT
#define ROOT_TCURLYARC_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTCurlyArc ( double x1, double y1, double rad, double phimin, double phimax, double wl, double amp )

#undef ROOT_TCURLYARC_DEFINITIONVIRT
#define ROOT_TCURLYARC_DEFINITIONVIRT(Type)\


#undef ROOT_TCURLYARC_DEFINITIONNONVIRT
#define ROOT_TCURLYARC_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTCurlyArc ( double x1, double y1, double rad, double phimin, double phimax, double wl, double amp )\
{\
Type * newp = new Type (x1, y1, rad, phimin, phimax, wl, amp); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TCURLYLINE_DECLARATIONVIRT(TCurlyArc);
ROOT_TPOLYLINE_DECLARATIONVIRT(TCurlyArc);
ROOT_TOBJECT_DECLARATIONVIRT(TCurlyArc);
ROOT_TATTLINE_DECLARATIONVIRT(TCurlyArc);
ROOT_TATTFILL_DECLARATIONVIRT(TCurlyArc);
ROOT_DELETABLE_DECLARATIONVIRT(TCurlyArc);


ROOT_TCURLYARC_DECLARATIONVIRT(TCurlyArc);


ROOT_TCURLYARC_DECLARATIONNONVIRT(TCurlyArc);


#ifdef __cplusplus
}
#endif
