#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TCUTG_DECLARATIONVIRT
#define ROOT_TCUTG_DECLARATIONVIRT(Type) \


#undef ROOT_TCUTG_DECLARATIONNONVIRT
#define ROOT_TCUTG_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTCutG ( const char * name, int  n, double * x, double * y )

#undef ROOT_TCUTG_DEFINITIONVIRT
#define ROOT_TCUTG_DEFINITIONVIRT(Type)\


#undef ROOT_TCUTG_DEFINITIONNONVIRT
#define ROOT_TCUTG_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTCutG ( const char * name, int  n, double * x, double * y )\
{\
Type * newp = new Type (name, n, x, y); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TGRAPH_DECLARATIONVIRT(TCutG);
ROOT_TNAMED_DECLARATIONVIRT(TCutG);
ROOT_TATTLINE_DECLARATIONVIRT(TCutG);
ROOT_TATTFILL_DECLARATIONVIRT(TCutG);
ROOT_TATTMARKER_DECLARATIONVIRT(TCutG);
ROOT_TOBJECT_DECLARATIONVIRT(TCutG);
ROOT_DELETABLE_DECLARATIONVIRT(TCutG);


ROOT_TCUTG_DECLARATIONVIRT(TCutG);


ROOT_TCUTG_DECLARATIONNONVIRT(TCutG);


#ifdef __cplusplus
}
#endif
