#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPaveText.h"
#include "HROOTTPave.h"
#include "HROOTTAttText.h"
#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TDIAMOND_DECLARATIONVIRT
#define ROOT_TDIAMOND_DECLARATIONVIRT(Type) \


#undef ROOT_TDIAMOND_DECLARATIONNONVIRT
#define ROOT_TDIAMOND_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTDiamond ( double x1, double y1, double x2, double y2 )

#undef ROOT_TDIAMOND_DEFINITIONVIRT
#define ROOT_TDIAMOND_DEFINITIONVIRT(Type)\


#undef ROOT_TDIAMOND_DEFINITIONNONVIRT
#define ROOT_TDIAMOND_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTDiamond ( double x1, double y1, double x2, double y2 )\
{\
Type * newp = new Type (x1, y1, x2, y2); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPAVETEXT_DECLARATIONVIRT(TDiamond);
ROOT_TPAVE_DECLARATIONVIRT(TDiamond);
ROOT_TATTTEXT_DECLARATIONVIRT(TDiamond);
ROOT_TBOX_DECLARATIONVIRT(TDiamond);
ROOT_TOBJECT_DECLARATIONVIRT(TDiamond);
ROOT_TATTLINE_DECLARATIONVIRT(TDiamond);
ROOT_TATTFILL_DECLARATIONVIRT(TDiamond);
ROOT_DELETABLE_DECLARATIONVIRT(TDiamond);


ROOT_TDIAMOND_DECLARATIONVIRT(TDiamond);


ROOT_TDIAMOND_DECLARATIONNONVIRT(TDiamond);


#ifdef __cplusplus
}
#endif
