#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTNamed.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TDIRECTORY_DECLARATIONVIRT
#define ROOT_TDIRECTORY_DECLARATIONVIRT(Type) \
void Type ## _Append ( Type ## _p p, TObject_p obj, int replace ); \
void Type ## _addD ( Type ## _p p, TObject_p obj, int replace ); \
int  Type ## _AppendKey ( Type ## _p p, TKey_p key ); \
void Type ## _Close ( Type ## _p p, const char * option ); \
TObject_p Type ## _Get ( Type ## _p p, const char * namecycle )

#undef ROOT_TDIRECTORY_DECLARATIONNONVIRT
#define ROOT_TDIRECTORY_DECLARATIONNONVIRT(Type) \


#undef ROOT_TDIRECTORY_DEFINITIONVIRT
#define ROOT_TDIRECTORY_DEFINITIONVIRT(Type)\
void Type ## _Append ( Type ## _p p, TObject_p obj, int replace )\
{\
to_nonconst<Type,Type ## _t>(p)->Append(to_nonconst<TObject,TObject_t>(obj), replace);\
}\
void Type ## _addD ( Type ## _p p, TObject_p obj, int replace )\
{\
to_nonconst<Type,Type ## _t>(p)->Add(to_nonconst<TObject,TObject_t>(obj), replace);\
}\
int  Type ## _AppendKey ( Type ## _p p, TKey_p key )\
{\
return to_nonconst<Type,Type ## _t>(p)->AppendKey(to_nonconst<TKey,TKey_t>(key));\
}\
void Type ## _Close ( Type ## _p p, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->Close(option);\
}\
TObject_p Type ## _Get ( Type ## _p p, const char * namecycle )\
{\
return to_nonconst<TObject_t,TObject>((TObject*)to_nonconst<Type,Type ## _t>(p)->Get(namecycle));\
}

#undef ROOT_TDIRECTORY_DEFINITIONNONVIRT
#define ROOT_TDIRECTORY_DEFINITIONNONVIRT(Type)\


ROOT_TNAMED_DECLARATIONVIRT(TDirectory);
ROOT_TOBJECT_DECLARATIONVIRT(TDirectory);
ROOT_DELETABLE_DECLARATIONVIRT(TDirectory);


ROOT_TDIRECTORY_DECLARATIONVIRT(TDirectory);


ROOT_TDIRECTORY_DECLARATIONNONVIRT(TDirectory);


#ifdef __cplusplus
}
#endif
