#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TELLIPSE_DECLARATIONVIRT
#define ROOT_TELLIPSE_DECLARATIONVIRT(Type) \


#undef ROOT_TELLIPSE_DECLARATIONNONVIRT
#define ROOT_TELLIPSE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTEllipse ( double x1, double y1, double r1, double r2, double phimin, double phimax, double theta )

#undef ROOT_TELLIPSE_DEFINITIONVIRT
#define ROOT_TELLIPSE_DEFINITIONVIRT(Type)\


#undef ROOT_TELLIPSE_DEFINITIONNONVIRT
#define ROOT_TELLIPSE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTEllipse ( double x1, double y1, double r1, double r2, double phimin, double phimax, double theta )\
{\
Type * newp = new Type (x1, y1, r1, r2, phimin, phimax, theta); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TOBJECT_DECLARATIONVIRT(TEllipse);
ROOT_TATTLINE_DECLARATIONVIRT(TEllipse);
ROOT_TATTFILL_DECLARATIONVIRT(TEllipse);
ROOT_DELETABLE_DECLARATIONVIRT(TEllipse);


ROOT_TELLIPSE_DECLARATIONVIRT(TEllipse);


ROOT_TELLIPSE_DECLARATIONNONVIRT(TEllipse);


#ifdef __cplusplus
}
#endif
