#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TGRAPHASYMMERRORS_DECLARATIONVIRT
#define ROOT_TGRAPHASYMMERRORS_DECLARATIONVIRT(Type) \


#undef ROOT_TGRAPHASYMMERRORS_DECLARATIONNONVIRT
#define ROOT_TGRAPHASYMMERRORS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTGraphAsymmErrors ( int  n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh )

#undef ROOT_TGRAPHASYMMERRORS_DEFINITIONVIRT
#define ROOT_TGRAPHASYMMERRORS_DEFINITIONVIRT(Type)\


#undef ROOT_TGRAPHASYMMERRORS_DEFINITIONNONVIRT
#define ROOT_TGRAPHASYMMERRORS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTGraphAsymmErrors ( int  n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh )\
{\
Type * newp = new Type (n, x, y, exl, exh, eyl, eyh); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TGRAPH_DECLARATIONVIRT(TGraphAsymmErrors);
ROOT_TNAMED_DECLARATIONVIRT(TGraphAsymmErrors);
ROOT_TATTLINE_DECLARATIONVIRT(TGraphAsymmErrors);
ROOT_TATTFILL_DECLARATIONVIRT(TGraphAsymmErrors);
ROOT_TATTMARKER_DECLARATIONVIRT(TGraphAsymmErrors);
ROOT_TOBJECT_DECLARATIONVIRT(TGraphAsymmErrors);
ROOT_DELETABLE_DECLARATIONVIRT(TGraphAsymmErrors);


ROOT_TGRAPHASYMMERRORS_DECLARATIONVIRT(TGraphAsymmErrors);


ROOT_TGRAPHASYMMERRORS_DECLARATIONNONVIRT(TGraphAsymmErrors);


#ifdef __cplusplus
}
#endif
