#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TGRAPHBENTERRORS_DECLARATIONVIRT
#define ROOT_TGRAPHBENTERRORS_DECLARATIONVIRT(Type) \


#undef ROOT_TGRAPHBENTERRORS_DECLARATIONNONVIRT
#define ROOT_TGRAPHBENTERRORS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTGraphBentErrors ( int  n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh, double * exld, double * exhd, double * eyld, double * eyhd )

#undef ROOT_TGRAPHBENTERRORS_DEFINITIONVIRT
#define ROOT_TGRAPHBENTERRORS_DEFINITIONVIRT(Type)\


#undef ROOT_TGRAPHBENTERRORS_DEFINITIONNONVIRT
#define ROOT_TGRAPHBENTERRORS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTGraphBentErrors ( int  n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh, double * exld, double * exhd, double * eyld, double * eyhd )\
{\
Type * newp = new Type (n, x, y, exl, exh, eyl, eyh, exld, exhd, eyld, eyhd); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TGRAPH_DECLARATIONVIRT(TGraphBentErrors);
ROOT_TNAMED_DECLARATIONVIRT(TGraphBentErrors);
ROOT_TATTLINE_DECLARATIONVIRT(TGraphBentErrors);
ROOT_TATTFILL_DECLARATIONVIRT(TGraphBentErrors);
ROOT_TATTMARKER_DECLARATIONVIRT(TGraphBentErrors);
ROOT_TOBJECT_DECLARATIONVIRT(TGraphBentErrors);
ROOT_DELETABLE_DECLARATIONVIRT(TGraphBentErrors);


ROOT_TGRAPHBENTERRORS_DECLARATIONVIRT(TGraphBentErrors);


ROOT_TGRAPHBENTERRORS_DECLARATIONNONVIRT(TGraphBentErrors);


#ifdef __cplusplus
}
#endif
