#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TGraphErrors.h"
#include "HROOTTGraphErrors.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TGRAPH_DEFINITIONVIRT(TGraphErrors)
ROOT_TNAMED_DEFINITIONVIRT(TGraphErrors)
ROOT_TATTLINE_DEFINITIONVIRT(TGraphErrors)
ROOT_TATTFILL_DEFINITIONVIRT(TGraphErrors)
ROOT_TATTMARKER_DEFINITIONVIRT(TGraphErrors)
ROOT_TOBJECT_DEFINITIONVIRT(TGraphErrors)
ROOT_DELETABLE_DEFINITIONVIRT(TGraphErrors)

ROOT_TGRAPHERRORS_DEFINITIONVIRT(TGraphErrors)

ROOT_TGRAPHERRORS_DEFINITIONNONVIRT(TGraphErrors)

void dummyTGraphErrors ( void ) 
{
  
}

