#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TGRAPHERRORS_DECLARATIONVIRT
#define ROOT_TGRAPHERRORS_DECLARATIONVIRT(Type) \


#undef ROOT_TGRAPHERRORS_DECLARATIONNONVIRT
#define ROOT_TGRAPHERRORS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTGraphErrors ( int  n, double * x, double * y, double * ex, double * ey )

#undef ROOT_TGRAPHERRORS_DEFINITIONVIRT
#define ROOT_TGRAPHERRORS_DEFINITIONVIRT(Type)\


#undef ROOT_TGRAPHERRORS_DEFINITIONNONVIRT
#define ROOT_TGRAPHERRORS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTGraphErrors ( int  n, double * x, double * y, double * ex, double * ey )\
{\
Type * newp = new Type (n, x, y, ex, ey); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TGRAPH_DECLARATIONVIRT(TGraphErrors);
ROOT_TNAMED_DECLARATIONVIRT(TGraphErrors);
ROOT_TATTLINE_DECLARATIONVIRT(TGraphErrors);
ROOT_TATTFILL_DECLARATIONVIRT(TGraphErrors);
ROOT_TATTMARKER_DECLARATIONVIRT(TGraphErrors);
ROOT_TOBJECT_DECLARATIONVIRT(TGraphErrors);
ROOT_DELETABLE_DECLARATIONVIRT(TGraphErrors);


ROOT_TGRAPHERRORS_DECLARATIONVIRT(TGraphErrors);


ROOT_TGRAPHERRORS_DECLARATIONNONVIRT(TGraphErrors);


#ifdef __cplusplus
}
#endif
