#include "HROOTTGraphErrors.h"
#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TGraphPolar.h"
#include "HROOTTGraphPolar.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TGRAPHERRORS_DEFINITIONVIRT(TGraphPolar)
ROOT_TGRAPH_DEFINITIONVIRT(TGraphPolar)
ROOT_TNAMED_DEFINITIONVIRT(TGraphPolar)
ROOT_TATTLINE_DEFINITIONVIRT(TGraphPolar)
ROOT_TATTFILL_DEFINITIONVIRT(TGraphPolar)
ROOT_TATTMARKER_DEFINITIONVIRT(TGraphPolar)
ROOT_TOBJECT_DEFINITIONVIRT(TGraphPolar)
ROOT_DELETABLE_DEFINITIONVIRT(TGraphPolar)

ROOT_TGRAPHPOLAR_DEFINITIONVIRT(TGraphPolar)

ROOT_TGRAPHPOLAR_DEFINITIONNONVIRT(TGraphPolar)

void dummyTGraphPolar ( void ) 
{
  
}

