#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTGraphErrors.h"
#include "HROOTTGraph.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TGRAPHPOLAR_DECLARATIONVIRT
#define ROOT_TGRAPHPOLAR_DECLARATIONVIRT(Type) \


#undef ROOT_TGRAPHPOLAR_DECLARATIONNONVIRT
#define ROOT_TGRAPHPOLAR_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTGraphPolar ( int  n, double * x, double * y, double * ex, double * ey )

#undef ROOT_TGRAPHPOLAR_DEFINITIONVIRT
#define ROOT_TGRAPHPOLAR_DEFINITIONVIRT(Type)\


#undef ROOT_TGRAPHPOLAR_DEFINITIONNONVIRT
#define ROOT_TGRAPHPOLAR_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTGraphPolar ( int  n, double * x, double * y, double * ex, double * ey )\
{\
Type * newp = new Type (n, x, y, ex, ey); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TGRAPHERRORS_DECLARATIONVIRT(TGraphPolar);
ROOT_TGRAPH_DECLARATIONVIRT(TGraphPolar);
ROOT_TNAMED_DECLARATIONVIRT(TGraphPolar);
ROOT_TATTLINE_DECLARATIONVIRT(TGraphPolar);
ROOT_TATTFILL_DECLARATIONVIRT(TGraphPolar);
ROOT_TATTMARKER_DECLARATIONVIRT(TGraphPolar);
ROOT_TOBJECT_DECLARATIONVIRT(TGraphPolar);
ROOT_DELETABLE_DECLARATIONVIRT(TGraphPolar);


ROOT_TGRAPHPOLAR_DECLARATIONVIRT(TGraphPolar);


ROOT_TGRAPHPOLAR_DECLARATIONNONVIRT(TGraphPolar);


#ifdef __cplusplus
}
#endif
