#include "HROOTTH3.h"
#include "HROOTTArrayF.h"
#include "HROOTTH1.h"
#include "HROOTTAtt3D.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "HROOTTArray.h"
#include "TH3F.h"
#include "HROOTTH3F.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TH3_DEFINITIONVIRT(TH3F)
ROOT_TARRAYF_DEFINITIONVIRT(TH3F)
ROOT_TH1_DEFINITIONVIRT(TH3F)
ROOT_TATT3D_DEFINITIONVIRT(TH3F)
ROOT_TNAMED_DEFINITIONVIRT(TH3F)
ROOT_TATTLINE_DEFINITIONVIRT(TH3F)
ROOT_TATTFILL_DEFINITIONVIRT(TH3F)
ROOT_TATTMARKER_DEFINITIONVIRT(TH3F)
ROOT_TOBJECT_DEFINITIONVIRT(TH3F)
ROOT_DELETABLE_DEFINITIONVIRT(TH3F)
ROOT_TARRAY_DEFINITIONVIRT(TH3F)

ROOT_TH3F_DEFINITIONVIRT(TH3F)

ROOT_TH3F_DEFINITIONNONVIRT(TH3F)

void dummyTH3F ( void ) 
{
  
}

