#include "HROOTTCanvas.h"
#include "HROOTTAttText.h"
#include "HROOTTPad.h"
#include "HROOTTVirtualPad.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttPad.h"
#include "HROOTTQObject.h"
#include "HROOTDeletable.h"
#include "TInspectCanvas.h"
#include "HROOTTInspectCanvas.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TCANVAS_DEFINITIONVIRT(TInspectCanvas)
ROOT_TATTTEXT_DEFINITIONVIRT(TInspectCanvas)
ROOT_TPAD_DEFINITIONVIRT(TInspectCanvas)
ROOT_TVIRTUALPAD_DEFINITIONVIRT(TInspectCanvas)
ROOT_TOBJECT_DEFINITIONVIRT(TInspectCanvas)
ROOT_TATTLINE_DEFINITIONVIRT(TInspectCanvas)
ROOT_TATTFILL_DEFINITIONVIRT(TInspectCanvas)
ROOT_TATTPAD_DEFINITIONVIRT(TInspectCanvas)
ROOT_TQOBJECT_DEFINITIONVIRT(TInspectCanvas)
ROOT_DELETABLE_DEFINITIONVIRT(TInspectCanvas)

ROOT_TINSPECTCANVAS_DEFINITIONVIRT(TInspectCanvas)

ROOT_TINSPECTCANVAS_DEFINITIONNONVIRT(TInspectCanvas)

void dummyTInspectCanvas ( void ) 
{
  
}

