#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPave.h"
#include "HROOTTAttText.h"
#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TLEGEND_DECLARATIONVIRT
#define ROOT_TLEGEND_DECLARATIONVIRT(Type) \
TLegendEntry_p Type ## _AddEntry ( Type ## _p p, TObject_p obj, const char * label, const char * option )

#undef ROOT_TLEGEND_DECLARATIONNONVIRT
#define ROOT_TLEGEND_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTLegend ( double x1, double y1, double x2, double y2, const char * header, const char * option )

#undef ROOT_TLEGEND_DEFINITIONVIRT
#define ROOT_TLEGEND_DEFINITIONVIRT(Type)\
TLegendEntry_p Type ## _AddEntry ( Type ## _p p, TObject_p obj, const char * label, const char * option )\
{\
return to_nonconst<TLegendEntry_t,TLegendEntry>((TLegendEntry*)to_nonconst<Type,Type ## _t>(p)->AddEntry(to_nonconst<TObject,TObject_t>(obj), label, option));\
}

#undef ROOT_TLEGEND_DEFINITIONNONVIRT
#define ROOT_TLEGEND_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTLegend ( double x1, double y1, double x2, double y2, const char * header, const char * option )\
{\
Type * newp = new Type (x1, y1, x2, y2, header, option); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPAVE_DECLARATIONVIRT(TLegend);
ROOT_TATTTEXT_DECLARATIONVIRT(TLegend);
ROOT_TBOX_DECLARATIONVIRT(TLegend);
ROOT_TOBJECT_DECLARATIONVIRT(TLegend);
ROOT_TATTLINE_DECLARATIONVIRT(TLegend);
ROOT_TATTFILL_DECLARATIONVIRT(TLegend);
ROOT_DELETABLE_DECLARATIONVIRT(TLegend);


ROOT_TLEGEND_DECLARATIONVIRT(TLegend);


ROOT_TLEGEND_DECLARATIONNONVIRT(TLegend);


#ifdef __cplusplus
}
#endif
