#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTTree.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TNTUPLE_DECLARATIONVIRT
#define ROOT_TNTUPLE_DECLARATIONVIRT(Type) \


#undef ROOT_TNTUPLE_DECLARATIONNONVIRT
#define ROOT_TNTUPLE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTNtuple ( const char * name, const char * title, const char * varlist, int  bufsize )

#undef ROOT_TNTUPLE_DEFINITIONVIRT
#define ROOT_TNTUPLE_DEFINITIONVIRT(Type)\


#undef ROOT_TNTUPLE_DEFINITIONNONVIRT
#define ROOT_TNTUPLE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTNtuple ( const char * name, const char * title, const char * varlist, int  bufsize )\
{\
Type * newp = new Type (name, title, varlist, bufsize); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TTREE_DECLARATIONVIRT(TNtuple);
ROOT_TNAMED_DECLARATIONVIRT(TNtuple);
ROOT_TATTLINE_DECLARATIONVIRT(TNtuple);
ROOT_TATTFILL_DECLARATIONVIRT(TNtuple);
ROOT_TATTMARKER_DECLARATIONVIRT(TNtuple);
ROOT_TOBJECT_DECLARATIONVIRT(TNtuple);
ROOT_DELETABLE_DECLARATIONVIRT(TNtuple);


ROOT_TNTUPLE_DECLARATIONVIRT(TNtuple);


ROOT_TNTUPLE_DECLARATIONNONVIRT(TNtuple);


#ifdef __cplusplus
}
#endif
