#include "HROOTTTree.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TNtupleD.h"
#include "HROOTTNtupleD.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TTREE_DEFINITIONVIRT(TNtupleD)
ROOT_TNAMED_DEFINITIONVIRT(TNtupleD)
ROOT_TATTLINE_DEFINITIONVIRT(TNtupleD)
ROOT_TATTFILL_DEFINITIONVIRT(TNtupleD)
ROOT_TATTMARKER_DEFINITIONVIRT(TNtupleD)
ROOT_TOBJECT_DEFINITIONVIRT(TNtupleD)
ROOT_DELETABLE_DEFINITIONVIRT(TNtupleD)

ROOT_TNTUPLED_DEFINITIONVIRT(TNtupleD)

ROOT_TNTUPLED_DEFINITIONNONVIRT(TNtupleD)

void dummyTNtupleD ( void ) 
{
  
}

