#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTTree.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TNTUPLED_DECLARATIONVIRT
#define ROOT_TNTUPLED_DECLARATIONVIRT(Type) \


#undef ROOT_TNTUPLED_DECLARATIONNONVIRT
#define ROOT_TNTUPLED_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTNtupleD ( const char * name, const char * title, const char * varlist, int  bufsize )

#undef ROOT_TNTUPLED_DEFINITIONVIRT
#define ROOT_TNTUPLED_DEFINITIONVIRT(Type)\


#undef ROOT_TNTUPLED_DEFINITIONNONVIRT
#define ROOT_TNTUPLED_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTNtupleD ( const char * name, const char * title, const char * varlist, int  bufsize )\
{\
Type * newp = new Type (name, title, varlist, bufsize); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TTREE_DECLARATIONVIRT(TNtupleD);
ROOT_TNAMED_DECLARATIONVIRT(TNtupleD);
ROOT_TATTLINE_DECLARATIONVIRT(TNtupleD);
ROOT_TATTFILL_DECLARATIONVIRT(TNtupleD);
ROOT_TATTMARKER_DECLARATIONVIRT(TNtupleD);
ROOT_TOBJECT_DECLARATIONVIRT(TNtupleD);
ROOT_DELETABLE_DECLARATIONVIRT(TNtupleD);


ROOT_TNTUPLED_DECLARATIONVIRT(TNtupleD);


ROOT_TNTUPLED_DECLARATIONNONVIRT(TNtupleD);


#ifdef __cplusplus
}
#endif
