#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TPAVE_DECLARATIONVIRT
#define ROOT_TPAVE_DECLARATIONVIRT(Type) \


#undef ROOT_TPAVE_DECLARATIONNONVIRT
#define ROOT_TPAVE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTPave ( double x1, double y1, double x2, double y2, int  bordersize, const char * br )

#undef ROOT_TPAVE_DEFINITIONVIRT
#define ROOT_TPAVE_DEFINITIONVIRT(Type)\


#undef ROOT_TPAVE_DEFINITIONNONVIRT
#define ROOT_TPAVE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTPave ( double x1, double y1, double x2, double y2, int  bordersize, const char * br )\
{\
Type * newp = new Type (x1, y1, x2, y2, bordersize, br); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TBOX_DECLARATIONVIRT(TPave);
ROOT_TOBJECT_DECLARATIONVIRT(TPave);
ROOT_TATTLINE_DECLARATIONVIRT(TPave);
ROOT_TATTFILL_DECLARATIONVIRT(TPave);
ROOT_DELETABLE_DECLARATIONVIRT(TPave);


ROOT_TPAVE_DECLARATIONVIRT(TPave);


ROOT_TPAVE_DECLARATIONNONVIRT(TPave);


#ifdef __cplusplus
}
#endif
