#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPave.h"
#include "HROOTTAttText.h"
#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TPAVELABEL_DECLARATIONVIRT
#define ROOT_TPAVELABEL_DECLARATIONVIRT(Type) \


#undef ROOT_TPAVELABEL_DECLARATIONNONVIRT
#define ROOT_TPAVELABEL_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTPaveLabel ( double x1, double y1, double x2, double y2, const char * label, const char * option )

#undef ROOT_TPAVELABEL_DEFINITIONVIRT
#define ROOT_TPAVELABEL_DEFINITIONVIRT(Type)\


#undef ROOT_TPAVELABEL_DEFINITIONNONVIRT
#define ROOT_TPAVELABEL_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTPaveLabel ( double x1, double y1, double x2, double y2, const char * label, const char * option )\
{\
Type * newp = new Type (x1, y1, x2, y2, label, option); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPAVE_DECLARATIONVIRT(TPaveLabel);
ROOT_TATTTEXT_DECLARATIONVIRT(TPaveLabel);
ROOT_TBOX_DECLARATIONVIRT(TPaveLabel);
ROOT_TOBJECT_DECLARATIONVIRT(TPaveLabel);
ROOT_TATTLINE_DECLARATIONVIRT(TPaveLabel);
ROOT_TATTFILL_DECLARATIONVIRT(TPaveLabel);
ROOT_DELETABLE_DECLARATIONVIRT(TPaveLabel);


ROOT_TPAVELABEL_DECLARATIONVIRT(TPaveLabel);


ROOT_TPAVELABEL_DECLARATIONNONVIRT(TPaveLabel);


#ifdef __cplusplus
}
#endif
