#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTPaveText.h"
#include "HROOTTPave.h"
#include "HROOTTAttText.h"
#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TPAVESTEXT_DECLARATIONVIRT
#define ROOT_TPAVESTEXT_DECLARATIONVIRT(Type) \


#undef ROOT_TPAVESTEXT_DECLARATIONNONVIRT
#define ROOT_TPAVESTEXT_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTPavesText ( double x1, double y1, double x2, double y2, int  npaves, const char * br )

#undef ROOT_TPAVESTEXT_DEFINITIONVIRT
#define ROOT_TPAVESTEXT_DEFINITIONVIRT(Type)\


#undef ROOT_TPAVESTEXT_DEFINITIONNONVIRT
#define ROOT_TPAVESTEXT_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTPavesText ( double x1, double y1, double x2, double y2, int  npaves, const char * br )\
{\
Type * newp = new Type (x1, y1, x2, y2, npaves, br); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TPAVETEXT_DECLARATIONVIRT(TPavesText);
ROOT_TPAVE_DECLARATIONVIRT(TPavesText);
ROOT_TATTTEXT_DECLARATIONVIRT(TPavesText);
ROOT_TBOX_DECLARATIONVIRT(TPavesText);
ROOT_TOBJECT_DECLARATIONVIRT(TPavesText);
ROOT_TATTLINE_DECLARATIONVIRT(TPavesText);
ROOT_TATTFILL_DECLARATIONVIRT(TPavesText);
ROOT_DELETABLE_DECLARATIONVIRT(TPavesText);


ROOT_TPAVESTEXT_DECLARATIONVIRT(TPavesText);


ROOT_TPAVESTEXT_DECLARATIONNONVIRT(TPavesText);


#ifdef __cplusplus
}
#endif
