#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTShape.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TSPHE_DECLARATIONVIRT
#define ROOT_TSPHE_DECLARATIONVIRT(Type) \


#undef ROOT_TSPHE_DECLARATIONNONVIRT
#define ROOT_TSPHE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTSPHE ( const char * name, const char * title, const char * material, double rmin, double rmax, double themin, double themax, double phimin, double phimax )

#undef ROOT_TSPHE_DEFINITIONVIRT
#define ROOT_TSPHE_DEFINITIONVIRT(Type)\


#undef ROOT_TSPHE_DEFINITIONNONVIRT
#define ROOT_TSPHE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTSPHE ( const char * name, const char * title, const char * material, double rmin, double rmax, double themin, double themax, double phimin, double phimax )\
{\
Type * newp = new Type (name, title, material, rmin, rmax, themin, themax, phimin, phimax); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TSHAPE_DECLARATIONVIRT(TSPHE);
ROOT_TNAMED_DECLARATIONVIRT(TSPHE);
ROOT_TATTLINE_DECLARATIONVIRT(TSPHE);
ROOT_TATTFILL_DECLARATIONVIRT(TSPHE);
ROOT_TATT3D_DECLARATIONVIRT(TSPHE);
ROOT_TOBJECT_DECLARATIONVIRT(TSPHE);
ROOT_DELETABLE_DECLARATIONVIRT(TSPHE);


ROOT_TSPHE_DECLARATIONVIRT(TSPHE);


ROOT_TSPHE_DECLARATIONNONVIRT(TSPHE);


#ifdef __cplusplus
}
#endif
