#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTWbox.h"
#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TSLIDERBOX_DECLARATIONVIRT
#define ROOT_TSLIDERBOX_DECLARATIONVIRT(Type) \


#undef ROOT_TSLIDERBOX_DECLARATIONNONVIRT
#define ROOT_TSLIDERBOX_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTSliderBox ( double x1, double y1, double x2, double y2, int  color, int  bordersize, int  bordermode )

#undef ROOT_TSLIDERBOX_DEFINITIONVIRT
#define ROOT_TSLIDERBOX_DEFINITIONVIRT(Type)\


#undef ROOT_TSLIDERBOX_DEFINITIONNONVIRT
#define ROOT_TSLIDERBOX_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTSliderBox ( double x1, double y1, double x2, double y2, int  color, int  bordersize, int  bordermode )\
{\
Type * newp = new Type (x1, y1, x2, y2, color, bordersize, bordermode); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TWBOX_DECLARATIONVIRT(TSliderBox);
ROOT_TBOX_DECLARATIONVIRT(TSliderBox);
ROOT_TOBJECT_DECLARATIONVIRT(TSliderBox);
ROOT_TATTLINE_DECLARATIONVIRT(TSliderBox);
ROOT_TATTFILL_DECLARATIONVIRT(TSliderBox);
ROOT_DELETABLE_DECLARATIONVIRT(TSliderBox);


ROOT_TSLIDERBOX_DECLARATIONVIRT(TSliderBox);


ROOT_TSLIDERBOX_DECLARATIONNONVIRT(TSliderBox);


#ifdef __cplusplus
}
#endif
