#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTNamed.h"
#include "HROOTTAttText.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TTEXT_DECLARATIONVIRT
#define ROOT_TTEXT_DECLARATIONVIRT(Type) \
TText_p Type ## _DrawText ( Type ## _p p, double x, double y, const char * text ); \
TText_p Type ## _DrawTextNDC ( Type ## _p p, double x, double y, const char * text ); \
void Type ## _GetControlBox ( Type ## _p p, int  x, int  y, int  theta, int * cBoxX, int * cBoxY ); \
void Type ## _SetText ( Type ## _p p, double x, double y, const char * text )

#undef ROOT_TTEXT_DECLARATIONNONVIRT
#define ROOT_TTEXT_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTText ( double x, double y, const char * text )

#undef ROOT_TTEXT_DEFINITIONVIRT
#define ROOT_TTEXT_DEFINITIONVIRT(Type)\
TText_p Type ## _DrawText ( Type ## _p p, double x, double y, const char * text )\
{\
return to_nonconst<TText_t,TText>((TText*)to_nonconst<Type,Type ## _t>(p)->DrawText(x, y, text));\
}\
TText_p Type ## _DrawTextNDC ( Type ## _p p, double x, double y, const char * text )\
{\
return to_nonconst<TText_t,TText>((TText*)to_nonconst<Type,Type ## _t>(p)->DrawTextNDC(x, y, text));\
}\
void Type ## _GetControlBox ( Type ## _p p, int  x, int  y, int  theta, int * cBoxX, int * cBoxY )\
{\
to_nonconst<Type,Type ## _t>(p)->GetControlBox(x, y, theta, cBoxX, cBoxY);\
}\
void Type ## _SetText ( Type ## _p p, double x, double y, const char * text )\
{\
to_nonconst<Type,Type ## _t>(p)->SetText(x, y, text);\
}

#undef ROOT_TTEXT_DEFINITIONNONVIRT
#define ROOT_TTEXT_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTText ( double x, double y, const char * text )\
{\
Type * newp = new Type (x, y, text); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TNAMED_DECLARATIONVIRT(TText);
ROOT_TATTTEXT_DECLARATIONVIRT(TText);
ROOT_TOBJECT_DECLARATIONVIRT(TText);
ROOT_DELETABLE_DECLARATIONVIRT(TText);


ROOT_TTEXT_DECLARATIONVIRT(TText);


ROOT_TTEXT_DECLARATIONNONVIRT(TText);


#ifdef __cplusplus
}
#endif
