#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TTREE_DECLARATIONVIRT
#define ROOT_TTREE_DECLARATIONVIRT(Type) \


#undef ROOT_TTREE_DECLARATIONNONVIRT
#define ROOT_TTREE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTTree ( const char * name, const char * title, int  splitlevel )

#undef ROOT_TTREE_DEFINITIONVIRT
#define ROOT_TTREE_DEFINITIONVIRT(Type)\


#undef ROOT_TTREE_DEFINITIONNONVIRT
#define ROOT_TTREE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTTree ( const char * name, const char * title, int  splitlevel )\
{\
Type * newp = new Type (name, title, splitlevel); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TNAMED_DECLARATIONVIRT(TTree);
ROOT_TATTLINE_DECLARATIONVIRT(TTree);
ROOT_TATTFILL_DECLARATIONVIRT(TTree);
ROOT_TATTMARKER_DECLARATIONVIRT(TTree);
ROOT_TOBJECT_DECLARATIONVIRT(TTree);
ROOT_DELETABLE_DECLARATIONVIRT(TTree);


ROOT_TTREE_DECLARATIONVIRT(TTree);


ROOT_TTREE_DECLARATIONNONVIRT(TTree);


#ifdef __cplusplus
}
#endif
