#include "HROOTTTree.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"
#include "TTreeSQL.h"
#include "HROOTTTreeSQL.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TTREE_DEFINITIONVIRT(TTreeSQL)
ROOT_TNAMED_DEFINITIONVIRT(TTreeSQL)
ROOT_TATTLINE_DEFINITIONVIRT(TTreeSQL)
ROOT_TATTFILL_DEFINITIONVIRT(TTreeSQL)
ROOT_TATTMARKER_DEFINITIONVIRT(TTreeSQL)
ROOT_TOBJECT_DEFINITIONVIRT(TTreeSQL)
ROOT_DELETABLE_DEFINITIONVIRT(TTreeSQL)

ROOT_TTREESQL_DEFINITIONVIRT(TTreeSQL)

ROOT_TTREESQL_DEFINITIONNONVIRT(TTreeSQL)

void dummyTTreeSQL ( void ) 
{
  
}

