#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttPad.h"
#include "HROOTTQObject.h"
#include "HROOTDeletable.h"
#include "TVirtualPad.h"
#include "HROOTTVirtualPad.h"

using namespace std;

template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}



ROOT_TOBJECT_DEFINITIONVIRT(TVirtualPad)
ROOT_TATTLINE_DEFINITIONVIRT(TVirtualPad)
ROOT_TATTFILL_DEFINITIONVIRT(TVirtualPad)
ROOT_TATTPAD_DEFINITIONVIRT(TVirtualPad)
ROOT_TQOBJECT_DEFINITIONVIRT(TVirtualPad)
ROOT_DELETABLE_DEFINITIONVIRT(TVirtualPad)

ROOT_TVIRTUALPAD_DEFINITIONVIRT(TVirtualPad)

ROOT_TVIRTUALPAD_DEFINITIONNONVIRT(TVirtualPad)

void dummyTVirtualPad ( void ) 
{
  
}

