#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTBox.h"
#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTDeletable.h"

#undef ROOT_TWBOX_DECLARATIONVIRT
#define ROOT_TWBOX_DECLARATIONVIRT(Type) \
void Type ## _SetBorderMode ( Type ## _p p, int  bordermode )

#undef ROOT_TWBOX_DECLARATIONNONVIRT
#define ROOT_TWBOX_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTWbox ( double x1, double y1, double x2, double y2, int  color, int  bordersize, int  bordermode )

#undef ROOT_TWBOX_DEFINITIONVIRT
#define ROOT_TWBOX_DEFINITIONVIRT(Type)\
void Type ## _SetBorderMode ( Type ## _p p, int  bordermode )\
{\
to_nonconst<Type,Type ## _t>(p)->SetBorderMode(bordermode);\
}

#undef ROOT_TWBOX_DEFINITIONNONVIRT
#define ROOT_TWBOX_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTWbox ( double x1, double y1, double x2, double y2, int  color, int  bordersize, int  bordermode )\
{\
Type * newp = new Type (x1, y1, x2, y2, color, bordersize, bordermode); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TBOX_DECLARATIONVIRT(TWbox);
ROOT_TOBJECT_DECLARATIONVIRT(TWbox);
ROOT_TATTLINE_DECLARATIONVIRT(TWbox);
ROOT_TATTFILL_DECLARATIONVIRT(TWbox);
ROOT_DELETABLE_DECLARATIONVIRT(TWbox);


ROOT_TWBOX_DECLARATIONVIRT(TWbox);


ROOT_TWBOX_DECLARATIONNONVIRT(TWbox);


#ifdef __cplusplus
}
#endif
