#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTShape.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAtt3D.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TXTRU_DECLARATIONVIRT
#define ROOT_TXTRU_DECLARATIONVIRT(Type) \


#undef ROOT_TXTRU_DECLARATIONNONVIRT
#define ROOT_TXTRU_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTXTRU ( const char * name, const char * title, const char * material, int  nyx, int  nz )

#undef ROOT_TXTRU_DEFINITIONVIRT
#define ROOT_TXTRU_DEFINITIONVIRT(Type)\


#undef ROOT_TXTRU_DEFINITIONNONVIRT
#define ROOT_TXTRU_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTXTRU ( const char * name, const char * title, const char * material, int  nyx, int  nz )\
{\
Type * newp = new Type (name, title, material, nyx, nz); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TSHAPE_DECLARATIONVIRT(TXTRU);
ROOT_TNAMED_DECLARATIONVIRT(TXTRU);
ROOT_TATTLINE_DECLARATIONVIRT(TXTRU);
ROOT_TATTFILL_DECLARATIONVIRT(TXTRU);
ROOT_TATT3D_DECLARATIONVIRT(TXTRU);
ROOT_TOBJECT_DECLARATIONVIRT(TXTRU);
ROOT_DELETABLE_DECLARATIONVIRT(TXTRU);


ROOT_TXTRU_DECLARATIONVIRT(TXTRU);


ROOT_TXTRU_DECLARATIONNONVIRT(TXTRU);


#ifdef __cplusplus
}
#endif
