#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOTTYPE__
#define __HROOTTYPE__

#undef ROOT_TYPE_DECLARATION 
#define ROOT_TYPE_DECLARATION(Type) \
typedef struct Type ##_tag Type ## _t; \
typedef Type ## _t * Type ## _p; \
typedef Type ## _t const* const_ ## Type ## _p 

ROOT_TYPE_DECLARATION(Deletable);
ROOT_TYPE_DECLARATION(TObject);
ROOT_TYPE_DECLARATION(TNamed);
ROOT_TYPE_DECLARATION(TDictionary);
ROOT_TYPE_DECLARATION(TClass);
ROOT_TYPE_DECLARATION(TFormula);
ROOT_TYPE_DECLARATION(TAtt3D);
ROOT_TYPE_DECLARATION(TAttAxis);
ROOT_TYPE_DECLARATION(TAttBBox);
ROOT_TYPE_DECLARATION(TAttCanvas);
ROOT_TYPE_DECLARATION(TAttFill);
ROOT_TYPE_DECLARATION(TAttImage);
ROOT_TYPE_DECLARATION(TAttLine);
ROOT_TYPE_DECLARATION(TAttMarker);
ROOT_TYPE_DECLARATION(TAttPad);
ROOT_TYPE_DECLARATION(TAttParticle);
ROOT_TYPE_DECLARATION(TAttText);
ROOT_TYPE_DECLARATION(THStack);
ROOT_TYPE_DECLARATION(TF1);
ROOT_TYPE_DECLARATION(TGraph);
ROOT_TYPE_DECLARATION(TGraphAsymmErrors);
ROOT_TYPE_DECLARATION(TCutG);
ROOT_TYPE_DECLARATION(TGraphBentErrors);
ROOT_TYPE_DECLARATION(TGraphErrors);
ROOT_TYPE_DECLARATION(TGraphPolar);
ROOT_TYPE_DECLARATION(TGraphQQ);
ROOT_TYPE_DECLARATION(TEllipse);
ROOT_TYPE_DECLARATION(TArc);
ROOT_TYPE_DECLARATION(TCrown);
ROOT_TYPE_DECLARATION(TLine);
ROOT_TYPE_DECLARATION(TArrow);
ROOT_TYPE_DECLARATION(TGaxis);
ROOT_TYPE_DECLARATION(TShape);
ROOT_TYPE_DECLARATION(TBRIK);
ROOT_TYPE_DECLARATION(TTUBE);
ROOT_TYPE_DECLARATION(TPCON);
ROOT_TYPE_DECLARATION(TSPHE);
ROOT_TYPE_DECLARATION(TXTRU);
ROOT_TYPE_DECLARATION(TBox);
ROOT_TYPE_DECLARATION(TPave);
ROOT_TYPE_DECLARATION(TPaveText);
ROOT_TYPE_DECLARATION(TDiamond);
ROOT_TYPE_DECLARATION(TPaveStats);
ROOT_TYPE_DECLARATION(TPavesText);
ROOT_TYPE_DECLARATION(TLegend);
ROOT_TYPE_DECLARATION(TLegendEntry);
ROOT_TYPE_DECLARATION(TPaveLabel);
ROOT_TYPE_DECLARATION(TPaveClass);
ROOT_TYPE_DECLARATION(TWbox);
ROOT_TYPE_DECLARATION(TFrame);
ROOT_TYPE_DECLARATION(TSliderBox);
ROOT_TYPE_DECLARATION(TTree);
ROOT_TYPE_DECLARATION(TChain);
ROOT_TYPE_DECLARATION(TNtuple);
ROOT_TYPE_DECLARATION(TNtupleD);
ROOT_TYPE_DECLARATION(TTreeSQL);
ROOT_TYPE_DECLARATION(TPolyLine);
ROOT_TYPE_DECLARATION(TCurlyLine);
ROOT_TYPE_DECLARATION(TCurlyArc);
ROOT_TYPE_DECLARATION(TEfficiency);
ROOT_TYPE_DECLARATION(TAxis);
ROOT_TYPE_DECLARATION(TLatex);
ROOT_TYPE_DECLARATION(TText);
ROOT_TYPE_DECLARATION(TDirectory);
ROOT_TYPE_DECLARATION(TDirectoryFile);
ROOT_TYPE_DECLARATION(TFile);
ROOT_TYPE_DECLARATION(TBranch);
ROOT_TYPE_DECLARATION(TVirtualTreePlayer);
ROOT_TYPE_DECLARATION(TTreePlayer);
ROOT_TYPE_DECLARATION(TArray);
ROOT_TYPE_DECLARATION(TArrayC);
ROOT_TYPE_DECLARATION(TArrayD);
ROOT_TYPE_DECLARATION(TArrayF);
ROOT_TYPE_DECLARATION(TArrayI);
ROOT_TYPE_DECLARATION(TArrayL);
ROOT_TYPE_DECLARATION(TArrayL64);
ROOT_TYPE_DECLARATION(TArrayS);
ROOT_TYPE_DECLARATION(TH1);
ROOT_TYPE_DECLARATION(TH2);
ROOT_TYPE_DECLARATION(TH3);
ROOT_TYPE_DECLARATION(TH1C);
ROOT_TYPE_DECLARATION(TH1D);
ROOT_TYPE_DECLARATION(TH1F);
ROOT_TYPE_DECLARATION(TH1I);
ROOT_TYPE_DECLARATION(TH1S);
ROOT_TYPE_DECLARATION(TH2C);
ROOT_TYPE_DECLARATION(TH2D);
ROOT_TYPE_DECLARATION(TH2F);
ROOT_TYPE_DECLARATION(TH2I);
ROOT_TYPE_DECLARATION(TH2Poly);
ROOT_TYPE_DECLARATION(TH2S);
ROOT_TYPE_DECLARATION(TH3C);
ROOT_TYPE_DECLARATION(TH3D);
ROOT_TYPE_DECLARATION(TH3F);
ROOT_TYPE_DECLARATION(TH3I);
ROOT_TYPE_DECLARATION(TH3S);
ROOT_TYPE_DECLARATION(TQObject);
ROOT_TYPE_DECLARATION(TVirtualPad);
ROOT_TYPE_DECLARATION(TPad);
ROOT_TYPE_DECLARATION(TButton);
ROOT_TYPE_DECLARATION(TGroupButton);
ROOT_TYPE_DECLARATION(TCanvas);
ROOT_TYPE_DECLARATION(TDialogCanvas);
ROOT_TYPE_DECLARATION(TInspectCanvas);
ROOT_TYPE_DECLARATION(TEvePad);
ROOT_TYPE_DECLARATION(TSlider);
ROOT_TYPE_DECLARATION(TApplication);
ROOT_TYPE_DECLARATION(TRint);
ROOT_TYPE_DECLARATION(TRandom);
ROOT_TYPE_DECLARATION(TCollection);
ROOT_TYPE_DECLARATION(TSeqCollection);
ROOT_TYPE_DECLARATION(TObjArray);
ROOT_TYPE_DECLARATION(TList);
ROOT_TYPE_DECLARATION(TKey);
ROOT_TYPE_DECLARATION(TDatime);
ROOT_TYPE_DECLARATION(TVirtualHistPainter);

#endif __HROOTTYPE__

#ifdef __cplusplus
}
#endif
