{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TArrayD.Implementation where


import HROOT.TypeCast

import HROOT.Class.TArrayD.RawType
import HROOT.Class.TArrayD.FFI
import HROOT.Class.TArrayD.Interface
import HROOT.Class.TArrayD.Cast

import HROOT.Class.TArray.RawType
import HROOT.Class.TArray.Cast
import HROOT.Class.TArray.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITArrayD TArrayD where
instance ITArray TArrayD where
instance IDeletable TArrayD where
  delete = xform0 c_tarrayd_delete

instance ITArrayD (Exist TArrayD) where

instance ITArray (Exist TArrayD) where

instance IDeletable (Exist TArrayD) where
  delete (ETArrayD x) = delete x





instance FPtr (Exist TArrayD) where
  type Raw (Exist TArrayD) = RawTArrayD
  get_fptr (ETArrayD obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayD (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayD) :: TArrayD)
