{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TArrayS.Implementation where


import HROOT.TypeCast

import HROOT.Class.TArrayS.RawType
import HROOT.Class.TArrayS.FFI
import HROOT.Class.TArrayS.Interface
import HROOT.Class.TArrayS.Cast

import HROOT.Class.TArray.RawType
import HROOT.Class.TArray.Cast
import HROOT.Class.TArray.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITArrayS TArrayS where
instance ITArray TArrayS where
instance IDeletable TArrayS where
  delete = xform0 c_tarrays_delete

instance ITArrayS (Exist TArrayS) where

instance ITArray (Exist TArrayS) where

instance IDeletable (Exist TArrayS) where
  delete (ETArrayS x) = delete x





instance FPtr (Exist TArrayS) where
  type Raw (Exist TArrayS) = RawTArrayS
  get_fptr (ETArrayS obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayS (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayS) :: TArrayS)
