{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TAttImage.Implementation where


import HROOT.TypeCast

import HROOT.Class.TAttImage.RawType
import HROOT.Class.TAttImage.FFI
import HROOT.Class.TAttImage.Interface
import HROOT.Class.TAttImage.Cast

import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITAttImage TAttImage where
instance IDeletable TAttImage where
  delete = xform0 c_tattimage_delete

instance ITAttImage (Exist TAttImage) where

instance IDeletable (Exist TAttImage) where
  delete (ETAttImage x) = delete x





instance FPtr (Exist TAttImage) where
  type Raw (Exist TAttImage) = RawTAttImage
  get_fptr (ETAttImage obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttImage (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttImage) :: TAttImage)
