{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TBox.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TBox.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTBox.h"

foreign import ccall "HROOTTBox.h TBox_Draw" c_tbox_draw 
  :: (Ptr RawTBox) -> CString -> IO ()
foreign import ccall "HROOTTBox.h TBox_FindObject" c_tbox_findobject 
  :: (Ptr RawTBox) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTBox.h TBox_GetName" c_tbox_getname 
  :: (Ptr RawTBox) -> IO CString
foreign import ccall "HROOTTBox.h TBox_IsA" c_tbox_isa 
  :: (Ptr RawTBox) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTBox.h TBox_IsFolder" c_tbox_isfolder 
  :: (Ptr RawTBox) -> IO CInt
foreign import ccall "HROOTTBox.h TBox_IsEqual" c_tbox_isequal 
  :: (Ptr RawTBox) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTBox.h TBox_IsSortable" c_tbox_issortable 
  :: (Ptr RawTBox) -> IO CInt
foreign import ccall "HROOTTBox.h TBox_Paint" c_tbox_paint 
  :: (Ptr RawTBox) -> CString -> IO ()
foreign import ccall "HROOTTBox.h TBox_printObj" c_tbox_printobj 
  :: (Ptr RawTBox) -> CString -> IO ()
foreign import ccall "HROOTTBox.h TBox_RecursiveRemove" c_tbox_recursiveremove 
  :: (Ptr RawTBox) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTBox.h TBox_SaveAs" c_tbox_saveas 
  :: (Ptr RawTBox) -> CString -> CString -> IO ()
foreign import ccall "HROOTTBox.h TBox_UseCurrentStyle" c_tbox_usecurrentstyle 
  :: (Ptr RawTBox) -> IO ()
foreign import ccall "HROOTTBox.h TBox_Write" c_tbox_write 
  :: (Ptr RawTBox) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTBox.h TBox_GetLineColor" c_tbox_getlinecolor 
  :: (Ptr RawTBox) -> IO CInt
foreign import ccall "HROOTTBox.h TBox_GetLineStyle" c_tbox_getlinestyle 
  :: (Ptr RawTBox) -> IO CInt
foreign import ccall "HROOTTBox.h TBox_GetLineWidth" c_tbox_getlinewidth 
  :: (Ptr RawTBox) -> IO CInt
foreign import ccall "HROOTTBox.h TBox_ResetAttLine" c_tbox_resetattline 
  :: (Ptr RawTBox) -> CString -> IO ()
foreign import ccall "HROOTTBox.h TBox_SetLineAttributes" c_tbox_setlineattributes 
  :: (Ptr RawTBox) -> IO ()
foreign import ccall "HROOTTBox.h TBox_SetLineColor" c_tbox_setlinecolor 
  :: (Ptr RawTBox) -> CInt -> IO ()
foreign import ccall "HROOTTBox.h TBox_SetLineStyle" c_tbox_setlinestyle 
  :: (Ptr RawTBox) -> CInt -> IO ()
foreign import ccall "HROOTTBox.h TBox_SetLineWidth" c_tbox_setlinewidth 
  :: (Ptr RawTBox) -> CInt -> IO ()
foreign import ccall "HROOTTBox.h TBox_SetFillColor" c_tbox_setfillcolor 
  :: (Ptr RawTBox) -> CInt -> IO ()
foreign import ccall "HROOTTBox.h TBox_SetFillStyle" c_tbox_setfillstyle 
  :: (Ptr RawTBox) -> CInt -> IO ()
foreign import ccall "HROOTTBox.h TBox_delete" c_tbox_delete 
  :: (Ptr RawTBox) -> IO ()
foreign import ccall "HROOTTBox.h TBox_newTBox" c_tbox_newtbox 
  :: CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTBox)

