{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TCollection.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TCollection.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTCollection.h"

foreign import ccall "HROOTTCollection.h TCollection_Draw" c_tcollection_draw 
  :: (Ptr RawTCollection) -> CString -> IO ()
foreign import ccall "HROOTTCollection.h TCollection_FindObject" c_tcollection_findobject 
  :: (Ptr RawTCollection) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTCollection.h TCollection_GetName" c_tcollection_getname 
  :: (Ptr RawTCollection) -> IO CString
foreign import ccall "HROOTTCollection.h TCollection_IsA" c_tcollection_isa 
  :: (Ptr RawTCollection) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTCollection.h TCollection_IsFolder" c_tcollection_isfolder 
  :: (Ptr RawTCollection) -> IO CInt
foreign import ccall "HROOTTCollection.h TCollection_IsEqual" c_tcollection_isequal 
  :: (Ptr RawTCollection) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTCollection.h TCollection_IsSortable" c_tcollection_issortable 
  :: (Ptr RawTCollection) -> IO CInt
foreign import ccall "HROOTTCollection.h TCollection_Paint" c_tcollection_paint 
  :: (Ptr RawTCollection) -> CString -> IO ()
foreign import ccall "HROOTTCollection.h TCollection_printObj" c_tcollection_printobj 
  :: (Ptr RawTCollection) -> CString -> IO ()
foreign import ccall "HROOTTCollection.h TCollection_RecursiveRemove" c_tcollection_recursiveremove 
  :: (Ptr RawTCollection) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTCollection.h TCollection_SaveAs" c_tcollection_saveas 
  :: (Ptr RawTCollection) -> CString -> CString -> IO ()
foreign import ccall "HROOTTCollection.h TCollection_UseCurrentStyle" c_tcollection_usecurrentstyle 
  :: (Ptr RawTCollection) -> IO ()
foreign import ccall "HROOTTCollection.h TCollection_Write" c_tcollection_write 
  :: (Ptr RawTCollection) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTCollection.h TCollection_delete" c_tcollection_delete 
  :: (Ptr RawTCollection) -> IO ()

