{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TCurlyArc.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TCurlyArc.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTCurlyArc.h"

foreign import ccall "HROOTTCurlyArc.h TCurlyArc_Draw" c_tcurlyarc_draw 
  :: (Ptr RawTCurlyArc) -> CString -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_FindObject" c_tcurlyarc_findobject 
  :: (Ptr RawTCurlyArc) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_GetName" c_tcurlyarc_getname 
  :: (Ptr RawTCurlyArc) -> IO CString
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_IsA" c_tcurlyarc_isa 
  :: (Ptr RawTCurlyArc) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_IsFolder" c_tcurlyarc_isfolder 
  :: (Ptr RawTCurlyArc) -> IO CInt
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_IsEqual" c_tcurlyarc_isequal 
  :: (Ptr RawTCurlyArc) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_IsSortable" c_tcurlyarc_issortable 
  :: (Ptr RawTCurlyArc) -> IO CInt
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_Paint" c_tcurlyarc_paint 
  :: (Ptr RawTCurlyArc) -> CString -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_printObj" c_tcurlyarc_printobj 
  :: (Ptr RawTCurlyArc) -> CString -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_RecursiveRemove" c_tcurlyarc_recursiveremove 
  :: (Ptr RawTCurlyArc) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_SaveAs" c_tcurlyarc_saveas 
  :: (Ptr RawTCurlyArc) -> CString -> CString -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_UseCurrentStyle" c_tcurlyarc_usecurrentstyle 
  :: (Ptr RawTCurlyArc) -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_Write" c_tcurlyarc_write 
  :: (Ptr RawTCurlyArc) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_GetLineColor" c_tcurlyarc_getlinecolor 
  :: (Ptr RawTCurlyArc) -> IO CInt
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_GetLineStyle" c_tcurlyarc_getlinestyle 
  :: (Ptr RawTCurlyArc) -> IO CInt
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_GetLineWidth" c_tcurlyarc_getlinewidth 
  :: (Ptr RawTCurlyArc) -> IO CInt
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_ResetAttLine" c_tcurlyarc_resetattline 
  :: (Ptr RawTCurlyArc) -> CString -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_SetLineAttributes" c_tcurlyarc_setlineattributes 
  :: (Ptr RawTCurlyArc) -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_SetLineColor" c_tcurlyarc_setlinecolor 
  :: (Ptr RawTCurlyArc) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_SetLineStyle" c_tcurlyarc_setlinestyle 
  :: (Ptr RawTCurlyArc) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_SetLineWidth" c_tcurlyarc_setlinewidth 
  :: (Ptr RawTCurlyArc) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_SetFillColor" c_tcurlyarc_setfillcolor 
  :: (Ptr RawTCurlyArc) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_SetFillStyle" c_tcurlyarc_setfillstyle 
  :: (Ptr RawTCurlyArc) -> CInt -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_delete" c_tcurlyarc_delete 
  :: (Ptr RawTCurlyArc) -> IO ()
foreign import ccall "HROOTTCurlyArc.h TCurlyArc_newTCurlyArc" c_tcurlyarc_newtcurlyarc 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTCurlyArc)

