{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TDialogCanvas.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TDialogCanvas.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTDialogCanvas.h"

foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetTextAlign" c_tdialogcanvas_gettextalign 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetTextAngle" c_tdialogcanvas_gettextangle 
  :: (Ptr RawTDialogCanvas) -> IO CDouble
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetTextColor" c_tdialogcanvas_gettextcolor 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetTextFont" c_tdialogcanvas_gettextfont 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetTextSize" c_tdialogcanvas_gettextsize 
  :: (Ptr RawTDialogCanvas) -> IO CDouble
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_ResetAttText" c_tdialogcanvas_resetatttext 
  :: (Ptr RawTDialogCanvas) -> CString -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTextAttributes" c_tdialogcanvas_settextattributes 
  :: (Ptr RawTDialogCanvas) -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTextAlign" c_tdialogcanvas_settextalign 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTextAngle" c_tdialogcanvas_settextangle 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTextColor" c_tdialogcanvas_settextcolor 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTextFont" c_tdialogcanvas_settextfont 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTextSize" c_tdialogcanvas_settextsize 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTextSizePixels" c_tdialogcanvas_settextsizepixels 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_cd" c_tdialogcanvas_cd 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetFrame" c_tdialogcanvas_getframe 
  :: (Ptr RawTDialogCanvas) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_Modified" c_tdialogcanvas_modified 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_Range" c_tdialogcanvas_range 
  :: (Ptr RawTDialogCanvas) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_Draw" c_tdialogcanvas_draw 
  :: (Ptr RawTDialogCanvas) -> CString -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_FindObject" c_tdialogcanvas_findobject 
  :: (Ptr RawTDialogCanvas) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetName" c_tdialogcanvas_getname 
  :: (Ptr RawTDialogCanvas) -> IO CString
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_IsA" c_tdialogcanvas_isa 
  :: (Ptr RawTDialogCanvas) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_IsFolder" c_tdialogcanvas_isfolder 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_IsEqual" c_tdialogcanvas_isequal 
  :: (Ptr RawTDialogCanvas) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_IsSortable" c_tdialogcanvas_issortable 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_Paint" c_tdialogcanvas_paint 
  :: (Ptr RawTDialogCanvas) -> CString -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_printObj" c_tdialogcanvas_printobj 
  :: (Ptr RawTDialogCanvas) -> CString -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_RecursiveRemove" c_tdialogcanvas_recursiveremove 
  :: (Ptr RawTDialogCanvas) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SaveAs" c_tdialogcanvas_saveas 
  :: (Ptr RawTDialogCanvas) -> CString -> CString -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_UseCurrentStyle" c_tdialogcanvas_usecurrentstyle 
  :: (Ptr RawTDialogCanvas) -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_Write" c_tdialogcanvas_write 
  :: (Ptr RawTDialogCanvas) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetLineColor" c_tdialogcanvas_getlinecolor 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetLineStyle" c_tdialogcanvas_getlinestyle 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_GetLineWidth" c_tdialogcanvas_getlinewidth 
  :: (Ptr RawTDialogCanvas) -> IO CInt
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_ResetAttLine" c_tdialogcanvas_resetattline 
  :: (Ptr RawTDialogCanvas) -> CString -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetLineAttributes" c_tdialogcanvas_setlineattributes 
  :: (Ptr RawTDialogCanvas) -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetLineColor" c_tdialogcanvas_setlinecolor 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetLineStyle" c_tdialogcanvas_setlinestyle 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetLineWidth" c_tdialogcanvas_setlinewidth 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetFillColor" c_tdialogcanvas_setfillcolor 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetFillStyle" c_tdialogcanvas_setfillstyle 
  :: (Ptr RawTDialogCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_ResetAttPad" c_tdialogcanvas_resetattpad 
  :: (Ptr RawTDialogCanvas) -> CString -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetBottomMargin" c_tdialogcanvas_setbottommargin 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetLeftMargin" c_tdialogcanvas_setleftmargin 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetRightMargin" c_tdialogcanvas_setrightmargin 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetTopMargin" c_tdialogcanvas_settopmargin 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetMargin" c_tdialogcanvas_setmargin 
  :: (Ptr RawTDialogCanvas) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetAfile" c_tdialogcanvas_setafile 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetXfile" c_tdialogcanvas_setxfile 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetYfile" c_tdialogcanvas_setyfile 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetAstat" c_tdialogcanvas_setastat 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetXstat" c_tdialogcanvas_setxstat 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_SetYstat" c_tdialogcanvas_setystat 
  :: (Ptr RawTDialogCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTDialogCanvas.h TDialogCanvas_delete" c_tdialogcanvas_delete 
  :: (Ptr RawTDialogCanvas) -> IO ()

