{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TDialogCanvas.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TDialogCanvas.RawType

import HROOT.Class.TCanvas.Interface
import HROOT.Class.TAttText.Interface


class (ITCanvas a,ITAttText a) => ITDialogCanvas a where

instance Existable TDialogCanvas where
  data Exist TDialogCanvas = forall a. (FPtr a, ITDialogCanvas a) => ETDialogCanvas a

upcastTDialogCanvas :: (FPtr a, ITDialogCanvas a) => a -> TDialogCanvas
upcastTDialogCanvas h = let fh = get_fptr h
                            fh2 :: ForeignPtr RawTDialogCanvas = castForeignPtr fh
                        in cast_fptr_to_obj fh2
