{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TDiamond.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TDiamond.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTDiamond.h"

foreign import ccall "HROOTTDiamond.h TDiamond_GetTextAlign" c_tdiamond_gettextalign 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_GetTextAngle" c_tdiamond_gettextangle 
  :: (Ptr RawTDiamond) -> IO CDouble
foreign import ccall "HROOTTDiamond.h TDiamond_GetTextColor" c_tdiamond_gettextcolor 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_GetTextFont" c_tdiamond_gettextfont 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_GetTextSize" c_tdiamond_gettextsize 
  :: (Ptr RawTDiamond) -> IO CDouble
foreign import ccall "HROOTTDiamond.h TDiamond_ResetAttText" c_tdiamond_resetatttext 
  :: (Ptr RawTDiamond) -> CString -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetTextAttributes" c_tdiamond_settextattributes 
  :: (Ptr RawTDiamond) -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetTextAlign" c_tdiamond_settextalign 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetTextAngle" c_tdiamond_settextangle 
  :: (Ptr RawTDiamond) -> CDouble -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetTextColor" c_tdiamond_settextcolor 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetTextFont" c_tdiamond_settextfont 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetTextSize" c_tdiamond_settextsize 
  :: (Ptr RawTDiamond) -> CDouble -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetTextSizePixels" c_tdiamond_settextsizepixels 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_Draw" c_tdiamond_draw 
  :: (Ptr RawTDiamond) -> CString -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_FindObject" c_tdiamond_findobject 
  :: (Ptr RawTDiamond) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTDiamond.h TDiamond_GetName" c_tdiamond_getname 
  :: (Ptr RawTDiamond) -> IO CString
foreign import ccall "HROOTTDiamond.h TDiamond_IsA" c_tdiamond_isa 
  :: (Ptr RawTDiamond) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTDiamond.h TDiamond_IsFolder" c_tdiamond_isfolder 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_IsEqual" c_tdiamond_isequal 
  :: (Ptr RawTDiamond) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_IsSortable" c_tdiamond_issortable 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_Paint" c_tdiamond_paint 
  :: (Ptr RawTDiamond) -> CString -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_printObj" c_tdiamond_printobj 
  :: (Ptr RawTDiamond) -> CString -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_RecursiveRemove" c_tdiamond_recursiveremove 
  :: (Ptr RawTDiamond) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SaveAs" c_tdiamond_saveas 
  :: (Ptr RawTDiamond) -> CString -> CString -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_UseCurrentStyle" c_tdiamond_usecurrentstyle 
  :: (Ptr RawTDiamond) -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_Write" c_tdiamond_write 
  :: (Ptr RawTDiamond) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_GetLineColor" c_tdiamond_getlinecolor 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_GetLineStyle" c_tdiamond_getlinestyle 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_GetLineWidth" c_tdiamond_getlinewidth 
  :: (Ptr RawTDiamond) -> IO CInt
foreign import ccall "HROOTTDiamond.h TDiamond_ResetAttLine" c_tdiamond_resetattline 
  :: (Ptr RawTDiamond) -> CString -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetLineAttributes" c_tdiamond_setlineattributes 
  :: (Ptr RawTDiamond) -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetLineColor" c_tdiamond_setlinecolor 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetLineStyle" c_tdiamond_setlinestyle 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetLineWidth" c_tdiamond_setlinewidth 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetFillColor" c_tdiamond_setfillcolor 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_SetFillStyle" c_tdiamond_setfillstyle 
  :: (Ptr RawTDiamond) -> CInt -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_delete" c_tdiamond_delete 
  :: (Ptr RawTDiamond) -> IO ()
foreign import ccall "HROOTTDiamond.h TDiamond_newTDiamond" c_tdiamond_newtdiamond 
  :: CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTDiamond)

