{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TEllipse.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TEllipse.RawType

import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.Interface


class (ITObject a,ITAttLine a,ITAttFill a) => ITEllipse a where

instance Existable TEllipse where
  data Exist TEllipse = forall a. (FPtr a, ITEllipse a) => ETEllipse a

upcastTEllipse :: (FPtr a, ITEllipse a) => a -> TEllipse
upcastTEllipse h = let fh = get_fptr h
                       fh2 :: ForeignPtr RawTEllipse = castForeignPtr fh
                   in cast_fptr_to_obj fh2
