{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TEvePad.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TEvePad.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTEvePad.h"

foreign import ccall "HROOTTEvePad.h TEvePad_cd" c_tevepad_cd 
  :: (Ptr RawTEvePad) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTEvePad.h TEvePad_GetFrame" c_tevepad_getframe 
  :: (Ptr RawTEvePad) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTEvePad.h TEvePad_Modified" c_tevepad_modified 
  :: (Ptr RawTEvePad) -> CInt -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_Range" c_tevepad_range 
  :: (Ptr RawTEvePad) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_Draw" c_tevepad_draw 
  :: (Ptr RawTEvePad) -> CString -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_FindObject" c_tevepad_findobject 
  :: (Ptr RawTEvePad) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTEvePad.h TEvePad_GetName" c_tevepad_getname 
  :: (Ptr RawTEvePad) -> IO CString
foreign import ccall "HROOTTEvePad.h TEvePad_IsA" c_tevepad_isa 
  :: (Ptr RawTEvePad) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTEvePad.h TEvePad_IsFolder" c_tevepad_isfolder 
  :: (Ptr RawTEvePad) -> IO CInt
foreign import ccall "HROOTTEvePad.h TEvePad_IsEqual" c_tevepad_isequal 
  :: (Ptr RawTEvePad) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTEvePad.h TEvePad_IsSortable" c_tevepad_issortable 
  :: (Ptr RawTEvePad) -> IO CInt
foreign import ccall "HROOTTEvePad.h TEvePad_Paint" c_tevepad_paint 
  :: (Ptr RawTEvePad) -> CString -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_printObj" c_tevepad_printobj 
  :: (Ptr RawTEvePad) -> CString -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_RecursiveRemove" c_tevepad_recursiveremove 
  :: (Ptr RawTEvePad) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SaveAs" c_tevepad_saveas 
  :: (Ptr RawTEvePad) -> CString -> CString -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_UseCurrentStyle" c_tevepad_usecurrentstyle 
  :: (Ptr RawTEvePad) -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_Write" c_tevepad_write 
  :: (Ptr RawTEvePad) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTEvePad.h TEvePad_GetLineColor" c_tevepad_getlinecolor 
  :: (Ptr RawTEvePad) -> IO CInt
foreign import ccall "HROOTTEvePad.h TEvePad_GetLineStyle" c_tevepad_getlinestyle 
  :: (Ptr RawTEvePad) -> IO CInt
foreign import ccall "HROOTTEvePad.h TEvePad_GetLineWidth" c_tevepad_getlinewidth 
  :: (Ptr RawTEvePad) -> IO CInt
foreign import ccall "HROOTTEvePad.h TEvePad_ResetAttLine" c_tevepad_resetattline 
  :: (Ptr RawTEvePad) -> CString -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetLineAttributes" c_tevepad_setlineattributes 
  :: (Ptr RawTEvePad) -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetLineColor" c_tevepad_setlinecolor 
  :: (Ptr RawTEvePad) -> CInt -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetLineStyle" c_tevepad_setlinestyle 
  :: (Ptr RawTEvePad) -> CInt -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetLineWidth" c_tevepad_setlinewidth 
  :: (Ptr RawTEvePad) -> CInt -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetFillColor" c_tevepad_setfillcolor 
  :: (Ptr RawTEvePad) -> CInt -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetFillStyle" c_tevepad_setfillstyle 
  :: (Ptr RawTEvePad) -> CInt -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_ResetAttPad" c_tevepad_resetattpad 
  :: (Ptr RawTEvePad) -> CString -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetBottomMargin" c_tevepad_setbottommargin 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetLeftMargin" c_tevepad_setleftmargin 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetRightMargin" c_tevepad_setrightmargin 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetTopMargin" c_tevepad_settopmargin 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetMargin" c_tevepad_setmargin 
  :: (Ptr RawTEvePad) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetAfile" c_tevepad_setafile 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetXfile" c_tevepad_setxfile 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetYfile" c_tevepad_setyfile 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetAstat" c_tevepad_setastat 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetXstat" c_tevepad_setxstat 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_SetYstat" c_tevepad_setystat 
  :: (Ptr RawTEvePad) -> CDouble -> IO ()
foreign import ccall "HROOTTEvePad.h TEvePad_delete" c_tevepad_delete 
  :: (Ptr RawTEvePad) -> IO ()

