{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TEvePad.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TEvePad.RawType

import HROOT.Class.TPad.Interface


class (ITPad a) => ITEvePad a where

instance Existable TEvePad where
  data Exist TEvePad = forall a. (FPtr a, ITEvePad a) => ETEvePad a

upcastTEvePad :: (FPtr a, ITEvePad a) => a -> TEvePad
upcastTEvePad h = let fh = get_fptr h
                      fh2 :: ForeignPtr RawTEvePad = castForeignPtr fh
                  in cast_fptr_to_obj fh2
