{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TGraphAsymmErrors.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TGraphAsymmErrors.RawType
import HROOT.Class.TF1.RawType
import HROOT.Class.TH1F.RawType
import HROOT.Class.TList.RawType
import HROOT.Class.TAxis.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTGraphAsymmErrors.h"

foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_Apply" c_tgraphasymmerrors_apply 
  :: (Ptr RawTGraphAsymmErrors) -> (Ptr RawTF1) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_Chisquare" c_tgraphasymmerrors_chisquare 
  :: (Ptr RawTGraphAsymmErrors) -> (Ptr RawTF1) -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_DrawGraph" c_tgraphasymmerrors_drawgraph 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> (Ptr CDouble) -> (Ptr CDouble) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_drawPanelTGraph" c_tgraphasymmerrors_drawpaneltgraph 
  :: (Ptr RawTGraphAsymmErrors) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_Expand" c_tgraphasymmerrors_expand 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_FitPanelTGraph" c_tgraphasymmerrors_fitpaneltgraph 
  :: (Ptr RawTGraphAsymmErrors) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_getCorrelationFactorTGraph" c_tgraphasymmerrors_getcorrelationfactortgraph 
  :: (Ptr RawTGraphAsymmErrors) -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_getCovarianceTGraph" c_tgraphasymmerrors_getcovariancetgraph 
  :: (Ptr RawTGraphAsymmErrors) -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_getMeanTGraph" c_tgraphasymmerrors_getmeantgraph 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_getRMSTGraph" c_tgraphasymmerrors_getrmstgraph 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorX" c_tgraphasymmerrors_geterrorx 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorY" c_tgraphasymmerrors_geterrory 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorXhigh" c_tgraphasymmerrors_geterrorxhigh 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorXlow" c_tgraphasymmerrors_geterrorxlow 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorYhigh" c_tgraphasymmerrors_geterroryhigh 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetErrorYlow" c_tgraphasymmerrors_geterrorylow 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_InitExpo" c_tgraphasymmerrors_initexpo 
  :: (Ptr RawTGraphAsymmErrors) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_InitGaus" c_tgraphasymmerrors_initgaus 
  :: (Ptr RawTGraphAsymmErrors) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_InitPolynom" c_tgraphasymmerrors_initpolynom 
  :: (Ptr RawTGraphAsymmErrors) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_InsertPoint" c_tgraphasymmerrors_insertpoint 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_integralTGraph" c_tgraphasymmerrors_integraltgraph 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_IsEditable" c_tgraphasymmerrors_iseditable 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_isInsideTGraph" c_tgraphasymmerrors_isinsidetgraph 
  :: (Ptr RawTGraphAsymmErrors) -> CDouble -> CDouble -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_LeastSquareFit" c_tgraphasymmerrors_leastsquarefit 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> (Ptr CDouble) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_PaintStats" c_tgraphasymmerrors_paintstats 
  :: (Ptr RawTGraphAsymmErrors) -> (Ptr RawTF1) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_RemovePoint" c_tgraphasymmerrors_removepoint 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetEditable" c_tgraphasymmerrors_seteditable 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetHistogram" c_tgraphasymmerrors_sethistogram 
  :: (Ptr RawTGraphAsymmErrors) -> (Ptr RawTH1F) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_setMaximumTGraph" c_tgraphasymmerrors_setmaximumtgraph 
  :: (Ptr RawTGraphAsymmErrors) -> CDouble -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_setMinimumTGraph" c_tgraphasymmerrors_setminimumtgraph 
  :: (Ptr RawTGraphAsymmErrors) -> CDouble -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_Set" c_tgraphasymmerrors_set 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetPoint" c_tgraphasymmerrors_setpoint 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetName" c_tgraphasymmerrors_setname 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetNameTitle" c_tgraphasymmerrors_setnametitle 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetTitle" c_tgraphasymmerrors_settitle 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetLineColor" c_tgraphasymmerrors_getlinecolor 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetLineStyle" c_tgraphasymmerrors_getlinestyle 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetLineWidth" c_tgraphasymmerrors_getlinewidth 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_ResetAttLine" c_tgraphasymmerrors_resetattline 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetLineAttributes" c_tgraphasymmerrors_setlineattributes 
  :: (Ptr RawTGraphAsymmErrors) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetLineColor" c_tgraphasymmerrors_setlinecolor 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetLineStyle" c_tgraphasymmerrors_setlinestyle 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetLineWidth" c_tgraphasymmerrors_setlinewidth 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetFillColor" c_tgraphasymmerrors_setfillcolor 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetFillStyle" c_tgraphasymmerrors_setfillstyle 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetMarkerColor" c_tgraphasymmerrors_getmarkercolor 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetMarkerStyle" c_tgraphasymmerrors_getmarkerstyle 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetMarkerSize" c_tgraphasymmerrors_getmarkersize 
  :: (Ptr RawTGraphAsymmErrors) -> IO CDouble
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_ResetAttMarker" c_tgraphasymmerrors_resetattmarker 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerAttributes" c_tgraphasymmerrors_setmarkerattributes 
  :: (Ptr RawTGraphAsymmErrors) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerColor" c_tgraphasymmerrors_setmarkercolor 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerStyle" c_tgraphasymmerrors_setmarkerstyle 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SetMarkerSize" c_tgraphasymmerrors_setmarkersize 
  :: (Ptr RawTGraphAsymmErrors) -> CInt -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_Draw" c_tgraphasymmerrors_draw 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_FindObject" c_tgraphasymmerrors_findobject 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_GetName" c_tgraphasymmerrors_getname 
  :: (Ptr RawTGraphAsymmErrors) -> IO CString
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_IsA" c_tgraphasymmerrors_isa 
  :: (Ptr RawTGraphAsymmErrors) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_IsFolder" c_tgraphasymmerrors_isfolder 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_IsEqual" c_tgraphasymmerrors_isequal 
  :: (Ptr RawTGraphAsymmErrors) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_IsSortable" c_tgraphasymmerrors_issortable 
  :: (Ptr RawTGraphAsymmErrors) -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_Paint" c_tgraphasymmerrors_paint 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_printObj" c_tgraphasymmerrors_printobj 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_RecursiveRemove" c_tgraphasymmerrors_recursiveremove 
  :: (Ptr RawTGraphAsymmErrors) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_SaveAs" c_tgraphasymmerrors_saveas 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> CString -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_UseCurrentStyle" c_tgraphasymmerrors_usecurrentstyle 
  :: (Ptr RawTGraphAsymmErrors) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_Write" c_tgraphasymmerrors_write 
  :: (Ptr RawTGraphAsymmErrors) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_delete" c_tgraphasymmerrors_delete 
  :: (Ptr RawTGraphAsymmErrors) -> IO ()
foreign import ccall "HROOTTGraphAsymmErrors.h TGraphAsymmErrors_newTGraphAsymmErrors" c_tgraphasymmerrors_newtgraphasymmerrors 
  :: CInt -> (Ptr CDouble) -> (Ptr CDouble) -> (Ptr CDouble) -> (Ptr CDouble) -> (Ptr CDouble) -> (Ptr CDouble) -> IO (Ptr RawTGraphAsymmErrors)

