{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TGraphPolar.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TGraphPolar.RawType

import HROOT.Class.TGraphErrors.Interface


class (ITGraphErrors a) => ITGraphPolar a where

instance Existable TGraphPolar where
  data Exist TGraphPolar = forall a. (FPtr a, ITGraphPolar a) => ETGraphPolar a

upcastTGraphPolar :: (FPtr a, ITGraphPolar a) => a -> TGraphPolar
upcastTGraphPolar h = let fh = get_fptr h
                          fh2 :: ForeignPtr RawTGraphPolar = castForeignPtr fh
                      in cast_fptr_to_obj fh2
