{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TGroupButton.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TGroupButton.RawType

import HROOT.Class.TButton.Interface


class (ITButton a) => ITGroupButton a where

instance Existable TGroupButton where
  data Exist TGroupButton = forall a. (FPtr a, ITGroupButton a) => ETGroupButton a

upcastTGroupButton :: (FPtr a, ITGroupButton a) => a -> TGroupButton
upcastTGroupButton h = let fh = get_fptr h
                           fh2 :: ForeignPtr RawTGroupButton = castForeignPtr fh
                       in cast_fptr_to_obj fh2
