{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.THStack.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.THStack.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTHStack.h"

foreign import ccall "HROOTTHStack.h THStack_SetName" c_thstack_setname 
  :: (Ptr RawTHStack) -> CString -> IO ()
foreign import ccall "HROOTTHStack.h THStack_SetNameTitle" c_thstack_setnametitle 
  :: (Ptr RawTHStack) -> CString -> CString -> IO ()
foreign import ccall "HROOTTHStack.h THStack_SetTitle" c_thstack_settitle 
  :: (Ptr RawTHStack) -> CString -> IO ()
foreign import ccall "HROOTTHStack.h THStack_Draw" c_thstack_draw 
  :: (Ptr RawTHStack) -> CString -> IO ()
foreign import ccall "HROOTTHStack.h THStack_FindObject" c_thstack_findobject 
  :: (Ptr RawTHStack) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTHStack.h THStack_GetName" c_thstack_getname 
  :: (Ptr RawTHStack) -> IO CString
foreign import ccall "HROOTTHStack.h THStack_IsA" c_thstack_isa 
  :: (Ptr RawTHStack) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTHStack.h THStack_IsFolder" c_thstack_isfolder 
  :: (Ptr RawTHStack) -> IO CInt
foreign import ccall "HROOTTHStack.h THStack_IsEqual" c_thstack_isequal 
  :: (Ptr RawTHStack) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTHStack.h THStack_IsSortable" c_thstack_issortable 
  :: (Ptr RawTHStack) -> IO CInt
foreign import ccall "HROOTTHStack.h THStack_Paint" c_thstack_paint 
  :: (Ptr RawTHStack) -> CString -> IO ()
foreign import ccall "HROOTTHStack.h THStack_printObj" c_thstack_printobj 
  :: (Ptr RawTHStack) -> CString -> IO ()
foreign import ccall "HROOTTHStack.h THStack_RecursiveRemove" c_thstack_recursiveremove 
  :: (Ptr RawTHStack) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTHStack.h THStack_SaveAs" c_thstack_saveas 
  :: (Ptr RawTHStack) -> CString -> CString -> IO ()
foreign import ccall "HROOTTHStack.h THStack_UseCurrentStyle" c_thstack_usecurrentstyle 
  :: (Ptr RawTHStack) -> IO ()
foreign import ccall "HROOTTHStack.h THStack_Write" c_thstack_write 
  :: (Ptr RawTHStack) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTHStack.h THStack_delete" c_thstack_delete 
  :: (Ptr RawTHStack) -> IO ()
foreign import ccall "HROOTTHStack.h THStack_newTHStack" c_thstack_newthstack 
  :: CString -> CString -> IO (Ptr RawTHStack)

