{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TKey.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TKey.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTKey.h"

foreign import ccall "HROOTTKey.h TKey_SetName" c_tkey_setname 
  :: (Ptr RawTKey) -> CString -> IO ()
foreign import ccall "HROOTTKey.h TKey_SetNameTitle" c_tkey_setnametitle 
  :: (Ptr RawTKey) -> CString -> CString -> IO ()
foreign import ccall "HROOTTKey.h TKey_SetTitle" c_tkey_settitle 
  :: (Ptr RawTKey) -> CString -> IO ()
foreign import ccall "HROOTTKey.h TKey_Draw" c_tkey_draw 
  :: (Ptr RawTKey) -> CString -> IO ()
foreign import ccall "HROOTTKey.h TKey_FindObject" c_tkey_findobject 
  :: (Ptr RawTKey) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTKey.h TKey_GetName" c_tkey_getname 
  :: (Ptr RawTKey) -> IO CString
foreign import ccall "HROOTTKey.h TKey_IsA" c_tkey_isa 
  :: (Ptr RawTKey) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTKey.h TKey_IsFolder" c_tkey_isfolder 
  :: (Ptr RawTKey) -> IO CInt
foreign import ccall "HROOTTKey.h TKey_IsEqual" c_tkey_isequal 
  :: (Ptr RawTKey) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTKey.h TKey_IsSortable" c_tkey_issortable 
  :: (Ptr RawTKey) -> IO CInt
foreign import ccall "HROOTTKey.h TKey_Paint" c_tkey_paint 
  :: (Ptr RawTKey) -> CString -> IO ()
foreign import ccall "HROOTTKey.h TKey_printObj" c_tkey_printobj 
  :: (Ptr RawTKey) -> CString -> IO ()
foreign import ccall "HROOTTKey.h TKey_RecursiveRemove" c_tkey_recursiveremove 
  :: (Ptr RawTKey) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTKey.h TKey_SaveAs" c_tkey_saveas 
  :: (Ptr RawTKey) -> CString -> CString -> IO ()
foreign import ccall "HROOTTKey.h TKey_UseCurrentStyle" c_tkey_usecurrentstyle 
  :: (Ptr RawTKey) -> IO ()
foreign import ccall "HROOTTKey.h TKey_Write" c_tkey_write 
  :: (Ptr RawTKey) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTKey.h TKey_delete" c_tkey_delete 
  :: (Ptr RawTKey) -> IO ()

