{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TList.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TList.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTList.h"

foreign import ccall "HROOTTList.h TList_Draw" c_tlist_draw 
  :: (Ptr RawTList) -> CString -> IO ()
foreign import ccall "HROOTTList.h TList_FindObject" c_tlist_findobject 
  :: (Ptr RawTList) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTList.h TList_GetName" c_tlist_getname 
  :: (Ptr RawTList) -> IO CString
foreign import ccall "HROOTTList.h TList_IsA" c_tlist_isa 
  :: (Ptr RawTList) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTList.h TList_IsFolder" c_tlist_isfolder 
  :: (Ptr RawTList) -> IO CInt
foreign import ccall "HROOTTList.h TList_IsEqual" c_tlist_isequal 
  :: (Ptr RawTList) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTList.h TList_IsSortable" c_tlist_issortable 
  :: (Ptr RawTList) -> IO CInt
foreign import ccall "HROOTTList.h TList_Paint" c_tlist_paint 
  :: (Ptr RawTList) -> CString -> IO ()
foreign import ccall "HROOTTList.h TList_printObj" c_tlist_printobj 
  :: (Ptr RawTList) -> CString -> IO ()
foreign import ccall "HROOTTList.h TList_RecursiveRemove" c_tlist_recursiveremove 
  :: (Ptr RawTList) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTList.h TList_SaveAs" c_tlist_saveas 
  :: (Ptr RawTList) -> CString -> CString -> IO ()
foreign import ccall "HROOTTList.h TList_UseCurrentStyle" c_tlist_usecurrentstyle 
  :: (Ptr RawTList) -> IO ()
foreign import ccall "HROOTTList.h TList_Write" c_tlist_write 
  :: (Ptr RawTList) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTList.h TList_delete" c_tlist_delete 
  :: (Ptr RawTList) -> IO ()

