{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TNtuple.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TNtuple.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTNtuple.h"

foreign import ccall "HROOTTNtuple.h TNtuple_SetName" c_tntuple_setname 
  :: (Ptr RawTNtuple) -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetNameTitle" c_tntuple_setnametitle 
  :: (Ptr RawTNtuple) -> CString -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetTitle" c_tntuple_settitle 
  :: (Ptr RawTNtuple) -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_GetLineColor" c_tntuple_getlinecolor 
  :: (Ptr RawTNtuple) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_GetLineStyle" c_tntuple_getlinestyle 
  :: (Ptr RawTNtuple) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_GetLineWidth" c_tntuple_getlinewidth 
  :: (Ptr RawTNtuple) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_ResetAttLine" c_tntuple_resetattline 
  :: (Ptr RawTNtuple) -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetLineAttributes" c_tntuple_setlineattributes 
  :: (Ptr RawTNtuple) -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetLineColor" c_tntuple_setlinecolor 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetLineStyle" c_tntuple_setlinestyle 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetLineWidth" c_tntuple_setlinewidth 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetFillColor" c_tntuple_setfillcolor 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetFillStyle" c_tntuple_setfillstyle 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_GetMarkerColor" c_tntuple_getmarkercolor 
  :: (Ptr RawTNtuple) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_GetMarkerStyle" c_tntuple_getmarkerstyle 
  :: (Ptr RawTNtuple) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_GetMarkerSize" c_tntuple_getmarkersize 
  :: (Ptr RawTNtuple) -> IO CDouble
foreign import ccall "HROOTTNtuple.h TNtuple_ResetAttMarker" c_tntuple_resetattmarker 
  :: (Ptr RawTNtuple) -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetMarkerAttributes" c_tntuple_setmarkerattributes 
  :: (Ptr RawTNtuple) -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetMarkerColor" c_tntuple_setmarkercolor 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetMarkerStyle" c_tntuple_setmarkerstyle 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SetMarkerSize" c_tntuple_setmarkersize 
  :: (Ptr RawTNtuple) -> CInt -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_Draw" c_tntuple_draw 
  :: (Ptr RawTNtuple) -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_FindObject" c_tntuple_findobject 
  :: (Ptr RawTNtuple) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTNtuple.h TNtuple_GetName" c_tntuple_getname 
  :: (Ptr RawTNtuple) -> IO CString
foreign import ccall "HROOTTNtuple.h TNtuple_IsA" c_tntuple_isa 
  :: (Ptr RawTNtuple) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTNtuple.h TNtuple_IsFolder" c_tntuple_isfolder 
  :: (Ptr RawTNtuple) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_IsEqual" c_tntuple_isequal 
  :: (Ptr RawTNtuple) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_IsSortable" c_tntuple_issortable 
  :: (Ptr RawTNtuple) -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_Paint" c_tntuple_paint 
  :: (Ptr RawTNtuple) -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_printObj" c_tntuple_printobj 
  :: (Ptr RawTNtuple) -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_RecursiveRemove" c_tntuple_recursiveremove 
  :: (Ptr RawTNtuple) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_SaveAs" c_tntuple_saveas 
  :: (Ptr RawTNtuple) -> CString -> CString -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_UseCurrentStyle" c_tntuple_usecurrentstyle 
  :: (Ptr RawTNtuple) -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_Write" c_tntuple_write 
  :: (Ptr RawTNtuple) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTNtuple.h TNtuple_delete" c_tntuple_delete 
  :: (Ptr RawTNtuple) -> IO ()
foreign import ccall "HROOTTNtuple.h TNtuple_newTNtuple" c_tntuple_newtntuple 
  :: CString -> CString -> CString -> CInt -> IO (Ptr RawTNtuple)

