{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TNtupleD.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TNtupleD.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTNtupleD.h"

foreign import ccall "HROOTTNtupleD.h TNtupleD_SetName" c_tntupled_setname 
  :: (Ptr RawTNtupleD) -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetNameTitle" c_tntupled_setnametitle 
  :: (Ptr RawTNtupleD) -> CString -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetTitle" c_tntupled_settitle 
  :: (Ptr RawTNtupleD) -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_GetLineColor" c_tntupled_getlinecolor 
  :: (Ptr RawTNtupleD) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_GetLineStyle" c_tntupled_getlinestyle 
  :: (Ptr RawTNtupleD) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_GetLineWidth" c_tntupled_getlinewidth 
  :: (Ptr RawTNtupleD) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_ResetAttLine" c_tntupled_resetattline 
  :: (Ptr RawTNtupleD) -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetLineAttributes" c_tntupled_setlineattributes 
  :: (Ptr RawTNtupleD) -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetLineColor" c_tntupled_setlinecolor 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetLineStyle" c_tntupled_setlinestyle 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetLineWidth" c_tntupled_setlinewidth 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetFillColor" c_tntupled_setfillcolor 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetFillStyle" c_tntupled_setfillstyle 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_GetMarkerColor" c_tntupled_getmarkercolor 
  :: (Ptr RawTNtupleD) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_GetMarkerStyle" c_tntupled_getmarkerstyle 
  :: (Ptr RawTNtupleD) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_GetMarkerSize" c_tntupled_getmarkersize 
  :: (Ptr RawTNtupleD) -> IO CDouble
foreign import ccall "HROOTTNtupleD.h TNtupleD_ResetAttMarker" c_tntupled_resetattmarker 
  :: (Ptr RawTNtupleD) -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetMarkerAttributes" c_tntupled_setmarkerattributes 
  :: (Ptr RawTNtupleD) -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetMarkerColor" c_tntupled_setmarkercolor 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetMarkerStyle" c_tntupled_setmarkerstyle 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SetMarkerSize" c_tntupled_setmarkersize 
  :: (Ptr RawTNtupleD) -> CInt -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_Draw" c_tntupled_draw 
  :: (Ptr RawTNtupleD) -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_FindObject" c_tntupled_findobject 
  :: (Ptr RawTNtupleD) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTNtupleD.h TNtupleD_GetName" c_tntupled_getname 
  :: (Ptr RawTNtupleD) -> IO CString
foreign import ccall "HROOTTNtupleD.h TNtupleD_IsA" c_tntupled_isa 
  :: (Ptr RawTNtupleD) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTNtupleD.h TNtupleD_IsFolder" c_tntupled_isfolder 
  :: (Ptr RawTNtupleD) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_IsEqual" c_tntupled_isequal 
  :: (Ptr RawTNtupleD) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_IsSortable" c_tntupled_issortable 
  :: (Ptr RawTNtupleD) -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_Paint" c_tntupled_paint 
  :: (Ptr RawTNtupleD) -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_printObj" c_tntupled_printobj 
  :: (Ptr RawTNtupleD) -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_RecursiveRemove" c_tntupled_recursiveremove 
  :: (Ptr RawTNtupleD) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_SaveAs" c_tntupled_saveas 
  :: (Ptr RawTNtupleD) -> CString -> CString -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_UseCurrentStyle" c_tntupled_usecurrentstyle 
  :: (Ptr RawTNtupleD) -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_Write" c_tntupled_write 
  :: (Ptr RawTNtupleD) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTNtupleD.h TNtupleD_delete" c_tntupled_delete 
  :: (Ptr RawTNtupleD) -> IO ()
foreign import ccall "HROOTTNtupleD.h TNtupleD_newTNtupleD" c_tntupled_newtntupled 
  :: CString -> CString -> CString -> CInt -> IO (Ptr RawTNtupleD)

