{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPaveClass.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPaveClass.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPaveClass.h"

foreign import ccall "HROOTTPaveClass.h TPaveClass_GetTextAlign" c_tpaveclass_gettextalign 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetTextAngle" c_tpaveclass_gettextangle 
  :: (Ptr RawTPaveClass) -> IO CDouble
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetTextColor" c_tpaveclass_gettextcolor 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetTextFont" c_tpaveclass_gettextfont 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetTextSize" c_tpaveclass_gettextsize 
  :: (Ptr RawTPaveClass) -> IO CDouble
foreign import ccall "HROOTTPaveClass.h TPaveClass_ResetAttText" c_tpaveclass_resetatttext 
  :: (Ptr RawTPaveClass) -> CString -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetTextAttributes" c_tpaveclass_settextattributes 
  :: (Ptr RawTPaveClass) -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetTextAlign" c_tpaveclass_settextalign 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetTextAngle" c_tpaveclass_settextangle 
  :: (Ptr RawTPaveClass) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetTextColor" c_tpaveclass_settextcolor 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetTextFont" c_tpaveclass_settextfont 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetTextSize" c_tpaveclass_settextsize 
  :: (Ptr RawTPaveClass) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetTextSizePixels" c_tpaveclass_settextsizepixels 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_Draw" c_tpaveclass_draw 
  :: (Ptr RawTPaveClass) -> CString -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_FindObject" c_tpaveclass_findobject 
  :: (Ptr RawTPaveClass) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetName" c_tpaveclass_getname 
  :: (Ptr RawTPaveClass) -> IO CString
foreign import ccall "HROOTTPaveClass.h TPaveClass_IsA" c_tpaveclass_isa 
  :: (Ptr RawTPaveClass) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPaveClass.h TPaveClass_IsFolder" c_tpaveclass_isfolder 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_IsEqual" c_tpaveclass_isequal 
  :: (Ptr RawTPaveClass) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_IsSortable" c_tpaveclass_issortable 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_Paint" c_tpaveclass_paint 
  :: (Ptr RawTPaveClass) -> CString -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_printObj" c_tpaveclass_printobj 
  :: (Ptr RawTPaveClass) -> CString -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_RecursiveRemove" c_tpaveclass_recursiveremove 
  :: (Ptr RawTPaveClass) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SaveAs" c_tpaveclass_saveas 
  :: (Ptr RawTPaveClass) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_UseCurrentStyle" c_tpaveclass_usecurrentstyle 
  :: (Ptr RawTPaveClass) -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_Write" c_tpaveclass_write 
  :: (Ptr RawTPaveClass) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetLineColor" c_tpaveclass_getlinecolor 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetLineStyle" c_tpaveclass_getlinestyle 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_GetLineWidth" c_tpaveclass_getlinewidth 
  :: (Ptr RawTPaveClass) -> IO CInt
foreign import ccall "HROOTTPaveClass.h TPaveClass_ResetAttLine" c_tpaveclass_resetattline 
  :: (Ptr RawTPaveClass) -> CString -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetLineAttributes" c_tpaveclass_setlineattributes 
  :: (Ptr RawTPaveClass) -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetLineColor" c_tpaveclass_setlinecolor 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetLineStyle" c_tpaveclass_setlinestyle 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetLineWidth" c_tpaveclass_setlinewidth 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetFillColor" c_tpaveclass_setfillcolor 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_SetFillStyle" c_tpaveclass_setfillstyle 
  :: (Ptr RawTPaveClass) -> CInt -> IO ()
foreign import ccall "HROOTTPaveClass.h TPaveClass_delete" c_tpaveclass_delete 
  :: (Ptr RawTPaveClass) -> IO ()

