{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPaveLabel.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPaveLabel.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPaveLabel.h"

foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetTextAlign" c_tpavelabel_gettextalign 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetTextAngle" c_tpavelabel_gettextangle 
  :: (Ptr RawTPaveLabel) -> IO CDouble
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetTextColor" c_tpavelabel_gettextcolor 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetTextFont" c_tpavelabel_gettextfont 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetTextSize" c_tpavelabel_gettextsize 
  :: (Ptr RawTPaveLabel) -> IO CDouble
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_ResetAttText" c_tpavelabel_resetatttext 
  :: (Ptr RawTPaveLabel) -> CString -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetTextAttributes" c_tpavelabel_settextattributes 
  :: (Ptr RawTPaveLabel) -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetTextAlign" c_tpavelabel_settextalign 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetTextAngle" c_tpavelabel_settextangle 
  :: (Ptr RawTPaveLabel) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetTextColor" c_tpavelabel_settextcolor 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetTextFont" c_tpavelabel_settextfont 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetTextSize" c_tpavelabel_settextsize 
  :: (Ptr RawTPaveLabel) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetTextSizePixels" c_tpavelabel_settextsizepixels 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_Draw" c_tpavelabel_draw 
  :: (Ptr RawTPaveLabel) -> CString -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_FindObject" c_tpavelabel_findobject 
  :: (Ptr RawTPaveLabel) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetName" c_tpavelabel_getname 
  :: (Ptr RawTPaveLabel) -> IO CString
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_IsA" c_tpavelabel_isa 
  :: (Ptr RawTPaveLabel) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_IsFolder" c_tpavelabel_isfolder 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_IsEqual" c_tpavelabel_isequal 
  :: (Ptr RawTPaveLabel) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_IsSortable" c_tpavelabel_issortable 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_Paint" c_tpavelabel_paint 
  :: (Ptr RawTPaveLabel) -> CString -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_printObj" c_tpavelabel_printobj 
  :: (Ptr RawTPaveLabel) -> CString -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_RecursiveRemove" c_tpavelabel_recursiveremove 
  :: (Ptr RawTPaveLabel) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SaveAs" c_tpavelabel_saveas 
  :: (Ptr RawTPaveLabel) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_UseCurrentStyle" c_tpavelabel_usecurrentstyle 
  :: (Ptr RawTPaveLabel) -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_Write" c_tpavelabel_write 
  :: (Ptr RawTPaveLabel) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetLineColor" c_tpavelabel_getlinecolor 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetLineStyle" c_tpavelabel_getlinestyle 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_GetLineWidth" c_tpavelabel_getlinewidth 
  :: (Ptr RawTPaveLabel) -> IO CInt
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_ResetAttLine" c_tpavelabel_resetattline 
  :: (Ptr RawTPaveLabel) -> CString -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetLineAttributes" c_tpavelabel_setlineattributes 
  :: (Ptr RawTPaveLabel) -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetLineColor" c_tpavelabel_setlinecolor 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetLineStyle" c_tpavelabel_setlinestyle 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetLineWidth" c_tpavelabel_setlinewidth 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetFillColor" c_tpavelabel_setfillcolor 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_SetFillStyle" c_tpavelabel_setfillstyle 
  :: (Ptr RawTPaveLabel) -> CInt -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_delete" c_tpavelabel_delete 
  :: (Ptr RawTPaveLabel) -> IO ()
foreign import ccall "HROOTTPaveLabel.h TPaveLabel_newTPaveLabel" c_tpavelabel_newtpavelabel 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CString -> CString -> IO (Ptr RawTPaveLabel)

