{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TPaveLabel.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TPaveLabel.RawType

import HROOT.Class.TPave.Interface
import HROOT.Class.TAttText.Interface


class (ITPave a,ITAttText a) => ITPaveLabel a where

instance Existable TPaveLabel where
  data Exist TPaveLabel = forall a. (FPtr a, ITPaveLabel a) => ETPaveLabel a

upcastTPaveLabel :: (FPtr a, ITPaveLabel a) => a -> TPaveLabel
upcastTPaveLabel h = let fh = get_fptr h
                         fh2 :: ForeignPtr RawTPaveLabel = castForeignPtr fh
                     in cast_fptr_to_obj fh2
