{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPaveText.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPaveText.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPaveText.h"

foreign import ccall "HROOTTPaveText.h TPaveText_GetTextAlign" c_tpavetext_gettextalign 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_GetTextAngle" c_tpavetext_gettextangle 
  :: (Ptr RawTPaveText) -> IO CDouble
foreign import ccall "HROOTTPaveText.h TPaveText_GetTextColor" c_tpavetext_gettextcolor 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_GetTextFont" c_tpavetext_gettextfont 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_GetTextSize" c_tpavetext_gettextsize 
  :: (Ptr RawTPaveText) -> IO CDouble
foreign import ccall "HROOTTPaveText.h TPaveText_ResetAttText" c_tpavetext_resetatttext 
  :: (Ptr RawTPaveText) -> CString -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetTextAttributes" c_tpavetext_settextattributes 
  :: (Ptr RawTPaveText) -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetTextAlign" c_tpavetext_settextalign 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetTextAngle" c_tpavetext_settextangle 
  :: (Ptr RawTPaveText) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetTextColor" c_tpavetext_settextcolor 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetTextFont" c_tpavetext_settextfont 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetTextSize" c_tpavetext_settextsize 
  :: (Ptr RawTPaveText) -> CDouble -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetTextSizePixels" c_tpavetext_settextsizepixels 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_Draw" c_tpavetext_draw 
  :: (Ptr RawTPaveText) -> CString -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_FindObject" c_tpavetext_findobject 
  :: (Ptr RawTPaveText) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPaveText.h TPaveText_GetName" c_tpavetext_getname 
  :: (Ptr RawTPaveText) -> IO CString
foreign import ccall "HROOTTPaveText.h TPaveText_IsA" c_tpavetext_isa 
  :: (Ptr RawTPaveText) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPaveText.h TPaveText_IsFolder" c_tpavetext_isfolder 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_IsEqual" c_tpavetext_isequal 
  :: (Ptr RawTPaveText) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_IsSortable" c_tpavetext_issortable 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_Paint" c_tpavetext_paint 
  :: (Ptr RawTPaveText) -> CString -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_printObj" c_tpavetext_printobj 
  :: (Ptr RawTPaveText) -> CString -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_RecursiveRemove" c_tpavetext_recursiveremove 
  :: (Ptr RawTPaveText) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SaveAs" c_tpavetext_saveas 
  :: (Ptr RawTPaveText) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_UseCurrentStyle" c_tpavetext_usecurrentstyle 
  :: (Ptr RawTPaveText) -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_Write" c_tpavetext_write 
  :: (Ptr RawTPaveText) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_GetLineColor" c_tpavetext_getlinecolor 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_GetLineStyle" c_tpavetext_getlinestyle 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_GetLineWidth" c_tpavetext_getlinewidth 
  :: (Ptr RawTPaveText) -> IO CInt
foreign import ccall "HROOTTPaveText.h TPaveText_ResetAttLine" c_tpavetext_resetattline 
  :: (Ptr RawTPaveText) -> CString -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetLineAttributes" c_tpavetext_setlineattributes 
  :: (Ptr RawTPaveText) -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetLineColor" c_tpavetext_setlinecolor 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetLineStyle" c_tpavetext_setlinestyle 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetLineWidth" c_tpavetext_setlinewidth 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetFillColor" c_tpavetext_setfillcolor 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_SetFillStyle" c_tpavetext_setfillstyle 
  :: (Ptr RawTPaveText) -> CInt -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_delete" c_tpavetext_delete 
  :: (Ptr RawTPaveText) -> IO ()
foreign import ccall "HROOTTPaveText.h TPaveText_newTPaveText" c_tpavetext_newtpavetext 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CString -> IO (Ptr RawTPaveText)

