{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TPaveText.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TPaveText.RawType

import HROOT.Class.TPave.Interface
import HROOT.Class.TAttText.Interface


class (ITPave a,ITAttText a) => ITPaveText a where

instance Existable TPaveText where
  data Exist TPaveText = forall a. (FPtr a, ITPaveText a) => ETPaveText a

upcastTPaveText :: (FPtr a, ITPaveText a) => a -> TPaveText
upcastTPaveText h = let fh = get_fptr h
                        fh2 :: ForeignPtr RawTPaveText = castForeignPtr fh
                    in cast_fptr_to_obj fh2
