{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPavesText.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPavesText.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPavesText.h"

foreign import ccall "HROOTTPavesText.h TPavesText_GetTextAlign" c_tpavestext_gettextalign 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_GetTextAngle" c_tpavestext_gettextangle 
  :: (Ptr RawTPavesText) -> IO CDouble
foreign import ccall "HROOTTPavesText.h TPavesText_GetTextColor" c_tpavestext_gettextcolor 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_GetTextFont" c_tpavestext_gettextfont 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_GetTextSize" c_tpavestext_gettextsize 
  :: (Ptr RawTPavesText) -> IO CDouble
foreign import ccall "HROOTTPavesText.h TPavesText_ResetAttText" c_tpavestext_resetatttext 
  :: (Ptr RawTPavesText) -> CString -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetTextAttributes" c_tpavestext_settextattributes 
  :: (Ptr RawTPavesText) -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetTextAlign" c_tpavestext_settextalign 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetTextAngle" c_tpavestext_settextangle 
  :: (Ptr RawTPavesText) -> CDouble -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetTextColor" c_tpavestext_settextcolor 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetTextFont" c_tpavestext_settextfont 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetTextSize" c_tpavestext_settextsize 
  :: (Ptr RawTPavesText) -> CDouble -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetTextSizePixels" c_tpavestext_settextsizepixels 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_Draw" c_tpavestext_draw 
  :: (Ptr RawTPavesText) -> CString -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_FindObject" c_tpavestext_findobject 
  :: (Ptr RawTPavesText) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPavesText.h TPavesText_GetName" c_tpavestext_getname 
  :: (Ptr RawTPavesText) -> IO CString
foreign import ccall "HROOTTPavesText.h TPavesText_IsA" c_tpavestext_isa 
  :: (Ptr RawTPavesText) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPavesText.h TPavesText_IsFolder" c_tpavestext_isfolder 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_IsEqual" c_tpavestext_isequal 
  :: (Ptr RawTPavesText) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_IsSortable" c_tpavestext_issortable 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_Paint" c_tpavestext_paint 
  :: (Ptr RawTPavesText) -> CString -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_printObj" c_tpavestext_printobj 
  :: (Ptr RawTPavesText) -> CString -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_RecursiveRemove" c_tpavestext_recursiveremove 
  :: (Ptr RawTPavesText) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SaveAs" c_tpavestext_saveas 
  :: (Ptr RawTPavesText) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_UseCurrentStyle" c_tpavestext_usecurrentstyle 
  :: (Ptr RawTPavesText) -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_Write" c_tpavestext_write 
  :: (Ptr RawTPavesText) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_GetLineColor" c_tpavestext_getlinecolor 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_GetLineStyle" c_tpavestext_getlinestyle 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_GetLineWidth" c_tpavestext_getlinewidth 
  :: (Ptr RawTPavesText) -> IO CInt
foreign import ccall "HROOTTPavesText.h TPavesText_ResetAttLine" c_tpavestext_resetattline 
  :: (Ptr RawTPavesText) -> CString -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetLineAttributes" c_tpavestext_setlineattributes 
  :: (Ptr RawTPavesText) -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetLineColor" c_tpavestext_setlinecolor 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetLineStyle" c_tpavestext_setlinestyle 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetLineWidth" c_tpavestext_setlinewidth 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetFillColor" c_tpavestext_setfillcolor 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_SetFillStyle" c_tpavestext_setfillstyle 
  :: (Ptr RawTPavesText) -> CInt -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_delete" c_tpavestext_delete 
  :: (Ptr RawTPavesText) -> IO ()
foreign import ccall "HROOTTPavesText.h TPavesText_newTPavesText" c_tpavestext_newtpavestext 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CInt -> CString -> IO (Ptr RawTPavesText)

