{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TPavesText.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TPavesText.RawType

import HROOT.Class.TPaveText.Interface


class (ITPaveText a) => ITPavesText a where

instance Existable TPavesText where
  data Exist TPavesText = forall a. (FPtr a, ITPavesText a) => ETPavesText a

upcastTPavesText :: (FPtr a, ITPavesText a) => a -> TPavesText
upcastTPavesText h = let fh = get_fptr h
                         fh2 :: ForeignPtr RawTPavesText = castForeignPtr fh
                     in cast_fptr_to_obj fh2
