{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPolyLine.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPolyLine.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPolyLine.h"

foreign import ccall "HROOTTPolyLine.h TPolyLine_Draw" c_tpolyline_draw 
  :: (Ptr RawTPolyLine) -> CString -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_FindObject" c_tpolyline_findobject 
  :: (Ptr RawTPolyLine) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPolyLine.h TPolyLine_GetName" c_tpolyline_getname 
  :: (Ptr RawTPolyLine) -> IO CString
foreign import ccall "HROOTTPolyLine.h TPolyLine_IsA" c_tpolyline_isa 
  :: (Ptr RawTPolyLine) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPolyLine.h TPolyLine_IsFolder" c_tpolyline_isfolder 
  :: (Ptr RawTPolyLine) -> IO CInt
foreign import ccall "HROOTTPolyLine.h TPolyLine_IsEqual" c_tpolyline_isequal 
  :: (Ptr RawTPolyLine) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPolyLine.h TPolyLine_IsSortable" c_tpolyline_issortable 
  :: (Ptr RawTPolyLine) -> IO CInt
foreign import ccall "HROOTTPolyLine.h TPolyLine_Paint" c_tpolyline_paint 
  :: (Ptr RawTPolyLine) -> CString -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_printObj" c_tpolyline_printobj 
  :: (Ptr RawTPolyLine) -> CString -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_RecursiveRemove" c_tpolyline_recursiveremove 
  :: (Ptr RawTPolyLine) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_SaveAs" c_tpolyline_saveas 
  :: (Ptr RawTPolyLine) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_UseCurrentStyle" c_tpolyline_usecurrentstyle 
  :: (Ptr RawTPolyLine) -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_Write" c_tpolyline_write 
  :: (Ptr RawTPolyLine) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPolyLine.h TPolyLine_GetLineColor" c_tpolyline_getlinecolor 
  :: (Ptr RawTPolyLine) -> IO CInt
foreign import ccall "HROOTTPolyLine.h TPolyLine_GetLineStyle" c_tpolyline_getlinestyle 
  :: (Ptr RawTPolyLine) -> IO CInt
foreign import ccall "HROOTTPolyLine.h TPolyLine_GetLineWidth" c_tpolyline_getlinewidth 
  :: (Ptr RawTPolyLine) -> IO CInt
foreign import ccall "HROOTTPolyLine.h TPolyLine_ResetAttLine" c_tpolyline_resetattline 
  :: (Ptr RawTPolyLine) -> CString -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_SetLineAttributes" c_tpolyline_setlineattributes 
  :: (Ptr RawTPolyLine) -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_SetLineColor" c_tpolyline_setlinecolor 
  :: (Ptr RawTPolyLine) -> CInt -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_SetLineStyle" c_tpolyline_setlinestyle 
  :: (Ptr RawTPolyLine) -> CInt -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_SetLineWidth" c_tpolyline_setlinewidth 
  :: (Ptr RawTPolyLine) -> CInt -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_SetFillColor" c_tpolyline_setfillcolor 
  :: (Ptr RawTPolyLine) -> CInt -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_SetFillStyle" c_tpolyline_setfillstyle 
  :: (Ptr RawTPolyLine) -> CInt -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_delete" c_tpolyline_delete 
  :: (Ptr RawTPolyLine) -> IO ()
foreign import ccall "HROOTTPolyLine.h TPolyLine_newTPolyLine" c_tpolyline_newtpolyline 
  :: CInt -> (Ptr CDouble) -> (Ptr CDouble) -> CString -> IO (Ptr RawTPolyLine)

