{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TRint.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TRint.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTRint.h"

foreign import ccall "HROOTTRint.h TRint_Run" c_trint_run 
  :: (Ptr RawTRint) -> CInt -> IO ()
foreign import ccall "HROOTTRint.h TRint_Draw" c_trint_draw 
  :: (Ptr RawTRint) -> CString -> IO ()
foreign import ccall "HROOTTRint.h TRint_FindObject" c_trint_findobject 
  :: (Ptr RawTRint) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTRint.h TRint_GetName" c_trint_getname 
  :: (Ptr RawTRint) -> IO CString
foreign import ccall "HROOTTRint.h TRint_IsA" c_trint_isa 
  :: (Ptr RawTRint) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTRint.h TRint_IsFolder" c_trint_isfolder 
  :: (Ptr RawTRint) -> IO CInt
foreign import ccall "HROOTTRint.h TRint_IsEqual" c_trint_isequal 
  :: (Ptr RawTRint) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTRint.h TRint_IsSortable" c_trint_issortable 
  :: (Ptr RawTRint) -> IO CInt
foreign import ccall "HROOTTRint.h TRint_Paint" c_trint_paint 
  :: (Ptr RawTRint) -> CString -> IO ()
foreign import ccall "HROOTTRint.h TRint_printObj" c_trint_printobj 
  :: (Ptr RawTRint) -> CString -> IO ()
foreign import ccall "HROOTTRint.h TRint_RecursiveRemove" c_trint_recursiveremove 
  :: (Ptr RawTRint) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTRint.h TRint_SaveAs" c_trint_saveas 
  :: (Ptr RawTRint) -> CString -> CString -> IO ()
foreign import ccall "HROOTTRint.h TRint_UseCurrentStyle" c_trint_usecurrentstyle 
  :: (Ptr RawTRint) -> IO ()
foreign import ccall "HROOTTRint.h TRint_Write" c_trint_write 
  :: (Ptr RawTRint) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTRint.h TRint_delete" c_trint_delete 
  :: (Ptr RawTRint) -> IO ()
foreign import ccall "HROOTTRint.h TRint_newTRint" c_trint_newtrint 
  :: CString -> (Ptr CInt) -> (Ptr (CString)) -> IO (Ptr RawTRint)

