{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TSliderBox.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TSliderBox.RawType

import HROOT.Class.TWbox.Interface


class (ITWbox a) => ITSliderBox a where

instance Existable TSliderBox where
  data Exist TSliderBox = forall a. (FPtr a, ITSliderBox a) => ETSliderBox a

upcastTSliderBox :: (FPtr a, ITSliderBox a) => a -> TSliderBox
upcastTSliderBox h = let fh = get_fptr h
                         fh2 :: ForeignPtr RawTSliderBox = castForeignPtr fh
                     in cast_fptr_to_obj fh2
