{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TTreePlayer.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TTreePlayer.RawType

import HROOT.Class.TVirtualTreePlayer.Interface


class (ITVirtualTreePlayer a) => ITTreePlayer a where

instance Existable TTreePlayer where
  data Exist TTreePlayer = forall a. (FPtr a, ITTreePlayer a) => ETTreePlayer a

upcastTTreePlayer :: (FPtr a, ITTreePlayer a) => a -> TTreePlayer
upcastTTreePlayer h = let fh = get_fptr h
                          fh2 :: ForeignPtr RawTTreePlayer = castForeignPtr fh
                      in cast_fptr_to_obj fh2
