{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TTreeSQL.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TTreeSQL.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTTreeSQL.h"

foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetName" c_ttreesql_setname 
  :: (Ptr RawTTreeSQL) -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetNameTitle" c_ttreesql_setnametitle 
  :: (Ptr RawTTreeSQL) -> CString -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetTitle" c_ttreesql_settitle 
  :: (Ptr RawTTreeSQL) -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_GetLineColor" c_ttreesql_getlinecolor 
  :: (Ptr RawTTreeSQL) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_GetLineStyle" c_ttreesql_getlinestyle 
  :: (Ptr RawTTreeSQL) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_GetLineWidth" c_ttreesql_getlinewidth 
  :: (Ptr RawTTreeSQL) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_ResetAttLine" c_ttreesql_resetattline 
  :: (Ptr RawTTreeSQL) -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetLineAttributes" c_ttreesql_setlineattributes 
  :: (Ptr RawTTreeSQL) -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetLineColor" c_ttreesql_setlinecolor 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetLineStyle" c_ttreesql_setlinestyle 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetLineWidth" c_ttreesql_setlinewidth 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetFillColor" c_ttreesql_setfillcolor 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetFillStyle" c_ttreesql_setfillstyle 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_GetMarkerColor" c_ttreesql_getmarkercolor 
  :: (Ptr RawTTreeSQL) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_GetMarkerStyle" c_ttreesql_getmarkerstyle 
  :: (Ptr RawTTreeSQL) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_GetMarkerSize" c_ttreesql_getmarkersize 
  :: (Ptr RawTTreeSQL) -> IO CDouble
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_ResetAttMarker" c_ttreesql_resetattmarker 
  :: (Ptr RawTTreeSQL) -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetMarkerAttributes" c_ttreesql_setmarkerattributes 
  :: (Ptr RawTTreeSQL) -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetMarkerColor" c_ttreesql_setmarkercolor 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetMarkerStyle" c_ttreesql_setmarkerstyle 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SetMarkerSize" c_ttreesql_setmarkersize 
  :: (Ptr RawTTreeSQL) -> CInt -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_Draw" c_ttreesql_draw 
  :: (Ptr RawTTreeSQL) -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_FindObject" c_ttreesql_findobject 
  :: (Ptr RawTTreeSQL) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_GetName" c_ttreesql_getname 
  :: (Ptr RawTTreeSQL) -> IO CString
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_IsA" c_ttreesql_isa 
  :: (Ptr RawTTreeSQL) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_IsFolder" c_ttreesql_isfolder 
  :: (Ptr RawTTreeSQL) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_IsEqual" c_ttreesql_isequal 
  :: (Ptr RawTTreeSQL) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_IsSortable" c_ttreesql_issortable 
  :: (Ptr RawTTreeSQL) -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_Paint" c_ttreesql_paint 
  :: (Ptr RawTTreeSQL) -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_printObj" c_ttreesql_printobj 
  :: (Ptr RawTTreeSQL) -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_RecursiveRemove" c_ttreesql_recursiveremove 
  :: (Ptr RawTTreeSQL) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_SaveAs" c_ttreesql_saveas 
  :: (Ptr RawTTreeSQL) -> CString -> CString -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_UseCurrentStyle" c_ttreesql_usecurrentstyle 
  :: (Ptr RawTTreeSQL) -> IO ()
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_Write" c_ttreesql_write 
  :: (Ptr RawTTreeSQL) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTTreeSQL.h TTreeSQL_delete" c_ttreesql_delete 
  :: (Ptr RawTTreeSQL) -> IO ()

