{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TVirtualTreePlayer.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TVirtualTreePlayer.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTVirtualTreePlayer.h"

foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_Draw" c_tvirtualtreeplayer_draw 
  :: (Ptr RawTVirtualTreePlayer) -> CString -> IO ()
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_FindObject" c_tvirtualtreeplayer_findobject 
  :: (Ptr RawTVirtualTreePlayer) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_GetName" c_tvirtualtreeplayer_getname 
  :: (Ptr RawTVirtualTreePlayer) -> IO CString
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_IsA" c_tvirtualtreeplayer_isa 
  :: (Ptr RawTVirtualTreePlayer) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_IsFolder" c_tvirtualtreeplayer_isfolder 
  :: (Ptr RawTVirtualTreePlayer) -> IO CInt
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_IsEqual" c_tvirtualtreeplayer_isequal 
  :: (Ptr RawTVirtualTreePlayer) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_IsSortable" c_tvirtualtreeplayer_issortable 
  :: (Ptr RawTVirtualTreePlayer) -> IO CInt
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_Paint" c_tvirtualtreeplayer_paint 
  :: (Ptr RawTVirtualTreePlayer) -> CString -> IO ()
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_printObj" c_tvirtualtreeplayer_printobj 
  :: (Ptr RawTVirtualTreePlayer) -> CString -> IO ()
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_RecursiveRemove" c_tvirtualtreeplayer_recursiveremove 
  :: (Ptr RawTVirtualTreePlayer) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_SaveAs" c_tvirtualtreeplayer_saveas 
  :: (Ptr RawTVirtualTreePlayer) -> CString -> CString -> IO ()
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_UseCurrentStyle" c_tvirtualtreeplayer_usecurrentstyle 
  :: (Ptr RawTVirtualTreePlayer) -> IO ()
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_Write" c_tvirtualtreeplayer_write 
  :: (Ptr RawTVirtualTreePlayer) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTVirtualTreePlayer.h TVirtualTreePlayer_delete" c_tvirtualtreeplayer_delete 
  :: (Ptr RawTVirtualTreePlayer) -> IO ()

