{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TVirtualTreePlayer.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TVirtualTreePlayer.RawType

import HROOT.Class.TObject.Interface


class (ITObject a) => ITVirtualTreePlayer a where

instance Existable TVirtualTreePlayer where
  data Exist TVirtualTreePlayer = forall a. (FPtr a, ITVirtualTreePlayer a) => ETVirtualTreePlayer a

upcastTVirtualTreePlayer :: (FPtr a, ITVirtualTreePlayer a) => a -> TVirtualTreePlayer
upcastTVirtualTreePlayer h = let fh = get_fptr h
                                 fh2 :: ForeignPtr RawTVirtualTreePlayer = castForeignPtr fh
                             in cast_fptr_to_obj fh2
