{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TWbox.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TWbox.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTWbox.h"

foreign import ccall "HROOTTWbox.h TWbox_Draw" c_twbox_draw 
  :: (Ptr RawTWbox) -> CString -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_FindObject" c_twbox_findobject 
  :: (Ptr RawTWbox) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTWbox.h TWbox_GetName" c_twbox_getname 
  :: (Ptr RawTWbox) -> IO CString
foreign import ccall "HROOTTWbox.h TWbox_IsA" c_twbox_isa 
  :: (Ptr RawTWbox) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTWbox.h TWbox_IsFolder" c_twbox_isfolder 
  :: (Ptr RawTWbox) -> IO CInt
foreign import ccall "HROOTTWbox.h TWbox_IsEqual" c_twbox_isequal 
  :: (Ptr RawTWbox) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTWbox.h TWbox_IsSortable" c_twbox_issortable 
  :: (Ptr RawTWbox) -> IO CInt
foreign import ccall "HROOTTWbox.h TWbox_Paint" c_twbox_paint 
  :: (Ptr RawTWbox) -> CString -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_printObj" c_twbox_printobj 
  :: (Ptr RawTWbox) -> CString -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_RecursiveRemove" c_twbox_recursiveremove 
  :: (Ptr RawTWbox) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_SaveAs" c_twbox_saveas 
  :: (Ptr RawTWbox) -> CString -> CString -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_UseCurrentStyle" c_twbox_usecurrentstyle 
  :: (Ptr RawTWbox) -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_Write" c_twbox_write 
  :: (Ptr RawTWbox) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTWbox.h TWbox_GetLineColor" c_twbox_getlinecolor 
  :: (Ptr RawTWbox) -> IO CInt
foreign import ccall "HROOTTWbox.h TWbox_GetLineStyle" c_twbox_getlinestyle 
  :: (Ptr RawTWbox) -> IO CInt
foreign import ccall "HROOTTWbox.h TWbox_GetLineWidth" c_twbox_getlinewidth 
  :: (Ptr RawTWbox) -> IO CInt
foreign import ccall "HROOTTWbox.h TWbox_ResetAttLine" c_twbox_resetattline 
  :: (Ptr RawTWbox) -> CString -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_SetLineAttributes" c_twbox_setlineattributes 
  :: (Ptr RawTWbox) -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_SetLineColor" c_twbox_setlinecolor 
  :: (Ptr RawTWbox) -> CInt -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_SetLineStyle" c_twbox_setlinestyle 
  :: (Ptr RawTWbox) -> CInt -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_SetLineWidth" c_twbox_setlinewidth 
  :: (Ptr RawTWbox) -> CInt -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_SetFillColor" c_twbox_setfillcolor 
  :: (Ptr RawTWbox) -> CInt -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_SetFillStyle" c_twbox_setfillstyle 
  :: (Ptr RawTWbox) -> CInt -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_delete" c_twbox_delete 
  :: (Ptr RawTWbox) -> IO ()
foreign import ccall "HROOTTWbox.h TWbox_newTWbox" c_twbox_newtwbox 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CInt -> CInt -> CInt -> IO (Ptr RawTWbox)
foreign import ccall "HROOTTWbox.h TWbox_SetBorderMode" c_twbox_setbordermode 
  :: (Ptr RawTWbox) -> CInt -> IO ()

